SystemOrganization addCategory: #'NXTalk-ST-Kernel'!
SystemOrganization addCategory: #'NXTalk-Building'!
SystemOrganization addCategory: #'NXTalk-ST-Collections'!
SystemOrganization addCategory: #'NXTalk-ST-Tests'!
SystemOrganization addCategory: #'NXTalk-Building-Tests'!
SystemOrganization addCategory: #'NXTalk-User Interface'!
SystemOrganization addCategory: #'NXTalk-ST-Hardware'!
SystemOrganization addCategory: #'NXTalk-Connections'!
SystemOrganization addCategory: #'NXTalk-ST-Streams'!
SystemOrganization addCategory: #'NXTalk-ST-Programs'!
SystemOrganization addCategory: #'NXTalk-Examples-Snake'!
SystemOrganization addCategory: #'NXTalk-ST-Packaging'!
SystemOrganization addCategory: #'NXTalk-Examples-LineFollower'!

!String methodsFor: '*nxtalk' stamp: 'mab 6/6/2008 11:13'!
asNXTObject
	| string |
	string := NXTString new: self size.
	^ string replaceFrom: 1 to: self size with: self! !

!String methodsFor: '*nxtalk' stamp: 'mab 7/25/2008 19:53'!
print
	Transcript show: self.! !

!String methodsFor: '*nxtalk' stamp: 'mab 7/25/2008 19:53'!
printNl
	self print.
	Transcript cr.! !

TestCase subclass: #NXTImageTest
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building-Tests'!

!NXTImageTest methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 18:17'!
setUp
	image := NXTImage new.
	image specialObjects at: #runSymbol put: (image symbolAt: #run).! !

!NXTImageTest methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 19:17'!
testObjectCountDoesNotChangeAfterWrite
	self 
		shouldnt: [ image writeToStream: (MultiByteBinaryOrTextStream with: String new) binary ]
		raise: Exception.! !

Model subclass: #NXTConnectDialog
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-User Interface'!

!NXTConnectDialog class methodsFor: 'as yet unclassified' stamp: 'mab 6/12/2008 13:18'!
open
	^ ToolBuilder open: self! !

!NXTConnectDialog methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 13:57'!
buildWith: builder
	| windowSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: 'NXT - Transfer'.
	windowSpec extent: 300@200.
	windowSpec children: OrderedCollection new.
	windowSpec children add: (builder pluggableButtonSpec new
		model: self;
		label: 'Socket (to localhost:10000)';
		action: #socket;
		frame: (0.1@0.1 corner: 0.9@0.3);
		yourself).
	windowSpec children add: (builder pluggableButtonSpec new
		model: self;
		label: 'Usb connection';
		action: #usb;
		frame: (0.1@0.4 corner: 0.9@0.6);
		yourself).
	windowSpec children add: (builder pluggableButtonSpec new
		model: self;
		label: 'Serial Port 3';
		action: #serial;
		frame: (0.1@0.7 corner: 0.9@0.9);
		yourself).
	^builder build: windowSpec! !

!NXTConnectDialog methodsFor: 'accessing' stamp: 'mab 6/22/2008 15:46'!
connection
	^ connection! !

!NXTConnectDialog methodsFor: 'accessing' stamp: 'mab 6/22/2008 15:46'!
connection: anObject
	connection := anObject! !

!NXTConnectDialog methodsFor: 'actions' stamp: 'mab 9/16/2008 17:05'!
serial
	| con |
	[ con := NXTSerialConnection connect ]
		on: Error
		do: [ self inform: 'Could not connect to serial port' ].
	self connection: con.
	self changed.
	self connection ifNotNil: [ self containingWindow delete ].! !

!NXTConnectDialog methodsFor: 'actions' stamp: 'mab 6/22/2008 16:07'!
socket
	| con |
	[ con := NXTSocketConnection connect ]
		on: Error
		do: [ self inform: 'Could not connect to socket' ].
	self connection: con.
	self changed.
	self connection ifNotNil: [ self containingWindow delete ].! !

!NXTConnectDialog methodsFor: 'actions' stamp: 'mab 6/22/2008 13:58'!
usb
	self error: 'Usb connection is yet not implemented!!'! !

Model subclass: #NXTTransferTool
	instanceVariableNames: 'localSelection localClasses remoteClasses dialogOpen connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-User Interface'!

!NXTTransferTool class methodsFor: 'as yet unclassified' stamp: 'mab 6/10/2008 13:16'!
open
	^ ToolBuilder open: self! !

!NXTTransferTool methodsFor: 'as yet unclassified' stamp: 'mab 6/10/2008 16:03'!
buildWith: builder
	| windowSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: 'NXT - Transfer'.
	windowSpec extent: 600@360.
	windowSpec children: OrderedCollection new.
	windowSpec children add: (builder pluggableButtonSpec new
		model: self;
		label: 'Connect';
		action: #connect;
		frame: (0.8@0 corner: 0.95@0.1);
		yourself).
	windowSpec children add: (builder pluggableListSpec new
		model: self;
		list: #localClasses;
		getSelected: #localSelection;
		setSelected: #localSelection:;
		frame: (0@0.2 corner: 0.45@0.9);
		yourself).
	windowSpec children add: (builder pluggableButtonSpec new
		model: self;
		label: '>';
		frame: (0.45@0.45 corner: 0.55@0.55);
		yourself).
	windowSpec children add: (builder pluggableListSpec new
		model: self;
		list: #remoteClasses;
		frame: (0.55@0.2 corner: 1@0.9);
		yourself).
	^builder build: windowSpec! !

!NXTTransferTool methodsFor: 'actions' stamp: 'mab 6/22/2008 15:48'!
connect
	| dialog |
	self ensureModalDialog: [
		dialog := NXTConnectDialog new.
		dialog addDependent: self.
		ToolBuilder default runModal: (ToolBuilder open: dialog) ].
	! !

!NXTTransferTool methodsFor: 'accessing' stamp: 'mab 8/12/2008 18:24'!
connection
	^ connection! !

!NXTTransferTool methodsFor: 'accessing' stamp: 'mab 6/22/2008 15:50'!
connection: anObject
	connection := anObject! !

!NXTTransferTool methodsFor: 'accessing' stamp: 'mab 6/22/2008 14:58'!
dialogOpen
	^ dialogOpen! !

!NXTTransferTool methodsFor: 'accessing' stamp: 'mab 6/22/2008 14:58'!
dialogOpen: anObject
	dialogOpen := anObject! !

!NXTTransferTool methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 15:50'!
ensureModalDialog: aBlock
	self dialogOpen ifFalse: [
		self dialogOpen: true.
		aBlock value.
		self dialogOpen: false ].! !

!NXTTransferTool methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 14:58'!
initialize
	dialogOpen := false! !

!NXTTransferTool methodsFor: 'accessing' stamp: 'mab 6/22/2008 15:55'!
isConnected
	^ self connection isNil not! !

!NXTTransferTool methodsFor: 'as yet unclassified' stamp: 'mab 6/10/2008 16:06'!
localClasses
	^ localClasses ifNil: [ 
		localClasses := (NXTObject allSubclasses collect: [ :class | class name ]) asSortedCollection ]! !

!NXTTransferTool methodsFor: 'accessing' stamp: 'mab 6/10/2008 16:04'!
localSelection
	^ localSelection ifNil: [ localSelection := self localClasses first ]! !

!NXTTransferTool methodsFor: 'accessing' stamp: 'mab 6/10/2008 15:57'!
localSelection: anObject
	localSelection := anObject! !

!NXTTransferTool methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 18:20'!
remoteClasses
	^ remoteClasses ifNil: [ remoteClasses := OrderedCollection with: 'Not connected yet' ]! !

!NXTTransferTool methodsFor: 'actions' stamp: 'mab 9/16/2008 17:09'!
retrieveRemoteClasses
	| datastream |
	datastream := NXTDataStream on: self connection.
	datastream nextPut: (NXTMessage selector: #getClassList asNXTObject).
	datastream flush.
	remoteClasses := datastream next.
	self changed: #remoteClasses.! !

!NXTTransferTool methodsFor: 'actions' stamp: 'mab 8/12/2008 18:24'!
update: observed
	| oldConnection |
	oldConnection := self connection.
	self connection: observed connection.
	(oldConnection ~= self connection and: [ self isConnected ]) ifTrue: [
		self retrieveRemoteClasses ].
	self changed.! !

Model subclass: #NXTTransferToolOld
	instanceVariableNames: 'localSelection localClasses remoteClasses dialogOpen connection connectButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-User Interface'!

!LargePositiveInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 11:24'!
asNXTObject
	| size nxtObject |
	size := self digitLength.
	nxtObject := NXTLargePositiveInteger new: size.
	1 to: size do: [ :i | nxtObject at: i put: (self at: i) ].
	^ nxtObject! !

Object subclass: #NXTClassCompiler
	instanceVariableNames: 'compilerContext compiledClass superclass nxtClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 13:53'!
classNamed: aClassName
	^ self compilerContext classNamed: aClassName! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 18:21'!
compile: aClass into: anNXTClass
	self compiledClass: aClass.
	self superclass: self compileSuperclass.
	self fillEmptyClass: anNXTClass.
! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 19:27'!
compileSuperclass
	^ (self compiledClass name = #NXTObject or: [self compiledClass name = #'NXTObject class'])
		ifFalse: [ self compilerContext classNamed: self compiledClass superclass name asSymbol ]
		ifTrue: [ nil asNXTObject ]! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:21'!
compiledClass
	^ compiledClass! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:21'!
compiledClass: anObject
	compiledClass := anObject! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 13:21'!
compilerContext
	^ compilerContext! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/17/2008 13:21'!
compilerContext: anObject
	compilerContext := anObject! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/21/2008 14:45'!
fillEmptyClass: class
	class name: self compiledClass name asSymbol asNXTObject.
	class format: (self compiledClass elementSize bitOr: self instVarNames size << 2).
	self compiledClass isVariable ifTrue: [ class format: (class format bitOr: 1 << 7) ].
	class superclass: self superclass.
	"self compiledClass name asSymbol = #'NXTPackageManager class' ifTrue: [ self halt. ]."
	class subclasses: NXTArray new.
	self includeMethodDictionaryOf: self compiledClass in: class.
	self includeClassVariablesOf: self compiledClass in: class.
	self includeInstanceVariablesOf: self compiledClass in: class.
	self includeClassSideInstanceVariablesOf: self compiledClass in: class.
	^ class! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 13:47'!
includeClassSideInstanceVariablesOf: aClass in: aNXTClass
	self compiledClass isMeta ifTrue: [ ^ self ].
	"self compiledClass class instVarNames do: [ :instVarName |
		self image addObjectGraph: (self compiledClass instVarNamed: instVarName asSymbol) ]."! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 16:37'!
includeClassVariablesOf: aClass in: aNXTClass
	aNXTClass classPool: nil asNXTObject.
	self compiledClass isMeta ifTrue: [ ^ self ].
	self compiledClass classPool ifNotEmpty: [
		aNXTClass classPool: self compiledClass classPool asNXTObject ].! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 19:20'!
includeInstanceVariablesOf: aClass in: aNXTClass
	| instVarNames |
	instVarNames := NXTArray new: aClass instVarNames size.
	aNXTClass instVarNames: instVarNames.
	aClass instVarNames doWithIndex: [ :name :index |
		instVarNames at: index put: name asSymbol asNXTObject ]! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 19:11'!
includeMethodDictionaryOf: aClass in: aNXTClass
	| methodDictionary method index selectors |
	index := 1.
	selectors := aClass selectors reject: [ :selector |
		(aClass organization categoryOfElement: selector) = #'nxt-exclude' ].
	methodDictionary := NXTArray new: selectors size * 2.
	aNXTClass methodDictionary: methodDictionary.
	self nxtClass: aNXTClass.
	selectors do: [ :selector |
		method := NXTMethodCompiler new
			compilerContext: self;
			compileMethod: (aClass compiledMethodAt: selector).
		methodDictionary at: index put: selector asNXTObject.
		methodDictionary at: index + 1 put: method.
		index := index + 2 ].! !

!NXTClassCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 13:33'!
includeSuperclass
	self compiledClass name = #NXTObject
		ifFalse: [ self classObject 
			superclass: (self compilerContext 
				classAt: self compiledClass superclass name asSymbol) ]
		ifTrue: [ self classObject superclass: nil ].! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/16/2008 16:55'!
instVarNames
	self compiledClass isMeta 
		ifTrue: [ ^ NXTClass allInstVarNames, self compiledClass instVarNames ]
		ifFalse: [ ^ self compiledClass allInstVarNames ]! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/6/2008 02:37'!
nxtClass
	^ nxtClass! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 11/6/2008 02:37'!
nxtClass: anObject
	nxtClass := anObject! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:39'!
superclass
	^ superclass! !

!NXTClassCompiler methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:39'!
superclass: anObject
	superclass := anObject! !

Object subclass: #NXTImage
	instanceVariableNames: 'specialObjects symbols classes paddings metaclasses finished objectTable packageManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImage class methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:59'!
specialClasses
	^ { 
		#NXTSmallInteger.
		#NXTLargePositiveInteger.
		#NXTLargeNegativeInteger.
		#NXTString.
		#NXTMethod.
		#NXTBlock.
		#NXTSymbol.
		#NXTMethodFrame.
		#NXTBlockFrame.
		#NXTArray.
		#NXTProcess.
		#NXTMessage.
		#NXTWeakArray
	 }! !

!NXTImage class methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 12:50'!
specialObjects
	^ {
	#System -> #NXTSystem.
	#nil -> #NXTUndefinedObject.
	#true -> #NXTTrue. 
	#false -> #NXTFalse.
	#Processor -> #NXTProcessorScheduler.
	#Smalltalk -> #NXTSystemDictionary.
	}! !

!NXTImage methodsFor: 'package inclusion' stamp: 'mab 11/19/2008 19:43'!
addClass: class from: aPackage
	self classes at: class name asSqueakObject put: class.
	self metaclasses at: class put: (aPackage metaclasses at: class).! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 12/15/2008 09:09'!
addObject: anNXTObject
	self finished ifTrue: [ Error signal: 'Image is already finished' ].
	anNXTObject class = SmallInteger ifTrue: [ ^ anNXTObject ].
	anNXTObject isNXTObject
		ifTrue: [ ^ self objectTable addObject: anNXTObject ]
		ifFalse: [ Error signal: 'Attempt to insert non-NXTObject into image' ]! !

!NXTImage methodsFor: 'package inclusion' stamp: 'mab 11/19/2008 19:28'!
addPackage: aPackage
	aPackage classes valuesDo: [ :class |
		class isClassProxy 
			ifTrue: [ self error: 'No class proxies allowed here' ]
			ifFalse: [ self addClass: class from: aPackage ]].
	self packageManager packages add: aPackage.! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 09:25'!
classNamed: aClassName
	^ self classNamed: aClassName ifAbsent: [ self error: 'Class not found' ]! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 19:24'!
classNamed: aClassName ifAbsent: aBlock
	^ self classes at: aClassName ifAbsent: [
		(aClassName endsWith: ' class') ifFalse: [ ^ aBlock value ].
		^ self metaclasses at: (self classes at: (aClassName allButLast: 6) asSymbol) ifAbsent: aBlock]! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/17/2008 14:09'!
classes
	^ classes! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 12/12/2008 21:03'!
collectObjectRecursively: anNXTObject
	(self objectTable objects identityIncludes: anNXTObject) ifFalse: [
		anNXTObject isNXTObject ifFalse: [ self error: 'No NXTObject' ].
		anNXTObject isClassProxy ifTrue: [ self error: 'Class proxies are not allowed in image' ].
		self addObject: anNXTObject.
		anNXTObject referencesDo: [ :reference | self collectObjectRecursively: reference ]].
! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 14:36'!
collectObjects
	self rootObjects do: [ :object |
		self collectObjectRecursively: object ].
! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 22:22'!
compileClass: aClassName
	| newClass newMetaclass |
	(self classes includesKey: aClassName) ifTrue: [ self error: 'Double class' ].
	newClass := self classes at: aClassName put: NXTClass new.
	newMetaclass := self metaclasses at: newClass put: NXTMetaclass new.
	newMetaclass thisClass: newClass.
	NXTClassCompiler new
		image: self;
		compile: (Smalltalk at: aClassName) into: newClass.
	NXTClassCompiler new
		image: self;
		compile: (Smalltalk at: aClassName) class into: newMetaclass.! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/17/2008 10:08'!
convertObject: anObject
	anObject isNXTObject ifTrue: [ ^ anObject ].
	anObject ifNil: [ ^ self specialObjectAt: #nil ].
	self error: 'Could not convert for image'.! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 11/17/2008 17:24'!
createClassRelationships
	self createMetaclassRelationship.
	self createSubclassRelationships.! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 11/20/2008 15:37'!
createMetaSubclassRelationshipsFor: metaclass
	| subclasses |
	subclasses := self metaclasses values select: [ :subclass | subclass superclass = metaclass ].
	subclasses := NXTOrderedCollection withAll: subclasses.
	metaclass subclasses: subclasses.! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 11/19/2008 19:43'!
createMetaclassRelationship
	| theMetaclass |
	theMetaclass := self classes at: #NXTMetaclass.
	self metaclasses values do: [ :metaclass |
		self metaclasses at: metaclass put: theMetaclass ].
	"NXTObject class superclass = NXTClass"
	(self metaclasses at: (self classes at: #NXTObject)) superclass: (self classes at: #NXTClass).! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 11/17/2008 17:23'!
createSubclassRelationships
	self classes valuesDo: [ :class |
		self createSubclassRelationshipsFor: class ].
	self metaclasses valuesDo: [ :metaclass |
		self createMetaSubclassRelationshipsFor: metaclass ].! !

!NXTImage methodsFor: 'class relationships' stamp: 'mab 11/20/2008 15:36'!
createSubclassRelationshipsFor: class
	| subclasses |
	subclasses := self classes values select: [ :subclass | subclass superclass = class ].
	subclasses := NXTOrderedCollection withAll: subclasses.
	class subclasses: subclasses.! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:36'!
createSystemDictionary
	self classes valuesDo: [ :class |
		self systemDictionary at: class name put: class ].
	self systemDictionary packageManager: self packageManager.
! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 12/15/2008 10:54'!
finalizeImage
	self includeDependentObjects.
	self unifyUniqueObjects.
	self resolveClassProxies.
	self collectObjects.
	self rehashDictionaries.
	self finished: true.! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 10:58'!
findAssociationOrNil: anObject in: array
	| element start finish |
	finish := array size.
	start := ((self hashFor: anObject) \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) isNil or: [element key = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) isNil or: [element key = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 10:59'!
findElementOrNil: anObject in: array
	| element start finish |
	finish := array size.
	start := ((self hashFor: anObject) \\ finish) + 1.
	
	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 6/2/2008 19:14'!
finished
	^ finished! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 6/2/2008 19:14'!
finished: anObject
	finished := anObject! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 11:10'!
hashFor: anObject
	"Retrieves NXTalk hash for anObject by replacing NXTObject>>identityHash"
	| identityHashMethod replacement hash |
	identityHashMethod := NXTObject >> #identityHash.
	[
		replacement := NXTObject >> #identityHashReplacement.
		replacement literalAt: 2 put: self objectTable.
		NXTObject methodDict at: #identityHash put: replacement.
		hash := anObject hash.
	] ensure: [ NXTObject methodDict at: #identityHash put: identityHashMethod ].
	^ hash! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 17:26'!
includeDependentObjects
	self includeSpecialObjects.
	self createSystemDictionary.
	self createClassRelationships.! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 11:12'!
includeSpecialObjects
	self specialObjects at: #startup put: (self symbolAt: #startup).
	self specialObjects at: #doesNotUnderstand: put: (self symbolAt: #doesNotUnderstand:).
	self specialObjects at: #onNonLocalReturnsDo: put: (self symbolAt: #onNonLocalReturnsDo:).
	self class specialObjects do: [ :assoc |
		self specialObjectAt: assoc key ].! !

!NXTImage methodsFor: 'testing' stamp: 'mab 11/17/2008 14:04'!
includesClass: aClassName
	^ (classes includesKey: aClassName) or: [ metaclasses anySatisfy: [ :metaclass | metaclass name asSqueakObject = aClassName ]]! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 14:04'!
initialize
	objects := OrderedCollection new.
	specialObjects := Dictionary new.
	symbols := Dictionary new.
	classes := Dictionary new.
	paddings := 0.
	metaclasses := Dictionary new.
	finished := false.! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 4/28/2008 23:31'!
isSpecialObject: aSymbol
	^ self class specialObjects detect: [ :each |
		each key = aSymbol ] ifNone: [ false ].! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/17/2008 15:15'!
metaclasses
	^ metaclasses! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 12/12/2008 20:52'!
objectTable
	^ objectTable ifNil: [ objectTable := NXTObjectTable new ]! !

!NXTImage methodsFor: 'accessing' stamp: 'mab 11/17/2008 16:14'!
packageManager
	^ packageManager ifNil: [ packageManager := NXTPackageManager new ]! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 10:56'!
rehashDictionaries
	| visited |
	visited := Set new.
	self rootObjects do: [ :object |
		self rehashDictionariesRecursively: object visited: visited ].! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 11:05'!
rehashDictionariesRecursively: anNXTObject visited: visited
	(visited identityIncludes: anNXTObject) ifFalse: [
		visited add: anNXTObject.
		anNXTObject referencesDo: [ :object |
			object isDictionary 
				ifTrue: [ self rehashDictionary: object ]
				ifFalse: [ (object isKindOf: NXTSet) ifTrue: [ self rehashSet: object ]].
			self rehashDictionariesRecursively: object visited: visited ]].! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 13:22'!
rehashDictionary: dict
	"Rehashes dictionary in place using NXTalk hashes"
	| array associations |
	associations := OrderedCollection new.
	array := dict instVarNamed: #array.
	array doWithIndex: [ :assoc :index | 
		assoc isNil ifFalse: [ associations add: assoc ].
		array at: index put: (self specialObjectAt: #nil) ].
	associations do: [ :assoc |
		array at: (self findAssociationOrNil: assoc key in: array) put: assoc ].! !

!NXTImage methodsFor: 'collection rehashing' stamp: 'mab 12/15/2008 11:08'!
rehashSet: dict
	"Rehashes dictionary in place using NXTalk hashes"
	| array elements |
	elements := OrderedCollection new.
	array := dict instVarNamed: #array.
	array doWithIndex: [ :element :index | 
		element isNil ifFalse: [ elements add: element ].
		array at: index put: (self specialObjectAt: #nil) ].
	elements do: [ :element |
		array at: (self findElementOrNil: element in: array) put: element ].! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 11:59'!
resolveClassProxies
	| visited |
	visited := Set new.
	self rootObjects do: [ :object |
		self resolveClassProxiesRecursively: object visited: visited ].! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 10:13'!
resolveClassProxiesRecursively: anNXTObject visited: visited
	(visited identityIncludes: anNXTObject) ifFalse: [
		visited add: anNXTObject.
		anNXTObject referencesDo: [ :object |
			object isClassProxy ifTrue: [ self resolveClassProxy: object ].
			self resolveClassProxiesRecursively: object visited: visited ]].! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 10:21'!
resolveClassProxy: aClassProxy
	| name newObject |
	name := aClassProxy name asSqueakObject.
	newObject := self specialObjects at: name ifAbsent: [
		self classNamed: name ifAbsent: [ self error: 'Could not resolve class proxy' ]].
	aClassProxy becomeForward: newObject copyHash: false.! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 12:15'!
rootObjects
	^ self classes values, self metaclasses values, self specialObjects values, {self packageManager. self systemDictionary}
! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 11/18/2008 14:18'!
specialObjectAt: aSymbol
	| specialObject specialClass|
	^ specialObjects at: aSymbol ifAbsentPut: [
		specialClass := Smalltalk at: (self specialObjectClassAt: aSymbol).
		specialObject := specialClass new.
		specialClass allInstVarNames do: [ :name |
			(specialObject instVarNamed: name) ifNil: [
				specialObject instVarNamed: name put: (self specialObjectAt: #nil) ]]. specialObject ]! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 4/28/2008 23:36'!
specialObjectClassAt: aSymbol
	^ (self class specialObjects detect: [ :each | each key = aSymbol ]) value! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:06'!
specialObjects
	^ specialObjects! !

!NXTImage methodsFor: 'accessing special objects' stamp: 'mab 2/20/2008 03:06'!
specialObjects: anObject
	specialObjects := anObject! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 13:59'!
symbolAt: aSymbol
	^ symbols at: aSymbol ifAbsentPut: [ aSymbol asNXTObject ]! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 12:51'!
systemDictionary
	^ self specialObjectAt: #Smalltalk! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 10:11'!
unifyUniqueObject: oldValue
	oldValue isSymbol ifTrue: [ ^ self symbolAt: oldValue asSqueakObject ].
	oldValue class = NXTTrue ifTrue: [ ^ self specialObjectAt: #true ].
	oldValue class = NXTFalse ifTrue: [ ^ self specialObjectAt: #false ].
	oldValue isNil ifTrue: [ ^ self specialObjectAt: #nil ].
	^ oldValue! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 10:34'!
unifyUniqueObjects
	| visited |
	visited := Set new.
	self rootObjects do: [ :object |
		self unifyUniqueObjectsRecursively: object visited: visited ].! !

!NXTImage methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 10:12'!
unifyUniqueObjectsRecursively: object visited: visited
	object isNXTObject ifFalse: [ self error: 'NXTObject expected' ].
	(visited identityIncludes: object) ifFalse: [ 
		visited add: object.
		object referencesReplace: [ :oldValue | 
			self unifyUniqueObject: oldValue ].
		object referencesDo: [ :reference |
			self unifyUniqueObjectsRecursively: reference visited: visited ]].! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 12/15/2008 09:00'!
writeHeaderTo: aByteStream
	aByteStream littleEndianWord: 16r4242.
	aByteStream littleEndianWord: self objectTable objects size.! !

!NXTImage methodsFor: 'private' stamp: 'mab 6/2/2008 18:04'!
writeImageToStream: aByteStream
	self writeHeaderTo: aByteStream.
	self writeSpecialObjectsTo: aByteStream.
	self writeObjectsTo: aByteStream.! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 12/15/2008 09:13'!
writeObjectTableToStream: aByteStream
	aByteStream nextLittleEndianNumber: 2 put: self objectTable positions size.
	aByteStream flush.
	self objectTable positions do: [ :each |
		aByteStream nextLittleEndianNumber: 4 put: each ].
	aByteStream flush.! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 12/15/2008 09:00'!
writeObjectsTo: aByteStream
	self objectTable objects do: [ :each | 
		self objectTable update: each position: aByteStream position.
		each writeOn: aByteStream withImage: self.
		aByteStream position odd ifTrue: [ "padding"
			paddings := paddings + 1.
			aByteStream nextPut: 0 ]].! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 1/3/2009 11:12'!
writeSpecialObjectsTo: aByteStream
	(self specialObjects at: #startup) 
		writeAsReferenceOn: aByteStream 
		within: self.
	self class specialObjects do: [ :objectToClass |
		(self specialObjectAt: objectToClass key) 
			writeAsReferenceOn: aByteStream within: self ].
	(self specialObjects at: #doesNotUnderstand:) 
		writeAsReferenceOn: aByteStream 
		within: self.
	(self specialObjects at: #onNonLocalReturnsDo:)
		writeAsReferenceOn: aByteStream
		within: self.
	self class specialClasses do: [ :className |
		(self classes at: className)
			writeAsReferenceOn: aByteStream within: self ].! !

!NXTImage methodsFor: 'serializing' stamp: 'mab 12/12/2008 20:54'!
writeToStream: aByteStream 
	self finished ifFalse: [ self error: 'Image has to be finalized' ].
	self writeImageToStream: aByteStream! !

Object subclass: #NXTImageBuilder
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTImageBuilder class methodsFor: 'as yet unclassified' stamp: 'mab 2/20/2008 02:52'!
standardCategories
	^ #('NXTalk-Kernel' 'NXTalk-Collections')! !

!NXTImageBuilder methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:23'!
helloWorldImageOn: aByteStream
	self image: NXTImage new.
	self image addPackage: (NXTPackageCompiler new compile: NXTBaseLibrary new).
	self image addPackage: (NXTPackageCompiler new compile: NXTStreamLibrary new).
	self image addPackage: (NXTPackageCompiler new compile: NXTUsbManagerApp new).
	self image addPackage: (NXTPackageCompiler new compile: NXTBluetoothTesterApp new).
	"self image addPackage: (NXTPackageCompiler new compile: NXTDemoApp new)."
	self image addPackage: (NXTPackageCompiler new compile: NXTTestRunnerApp new).
	self image addPackage: (NXTPackageCompiler new compile: NXSnakeApp new).
	self image addPackage: (NXTPackageCompiler new compile: NXTThreadTestApp new).
	self image addPackage: (NXTPackageCompiler new compile: NXTBenchmarkApp new).
	"self image addPackage: (NXTPackageCompiler new compile: NXTSensorTestApp new).
	self image addPackage: (NXTPackageCompiler new compile: NXTLineFollowerApp new)."
	self image addPackage: (NXTPackageCompiler new compile: NXTLineFollowerApp2 new).
	self image finalizeImage.
	self image writeToStream: aByteStream.

! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image
	^ image! !

!NXTImageBuilder methodsFor: 'accessing' stamp: 'mab 2/20/2008 02:50'!
image: anObject
	image := anObject! !

Object subclass: #NXTObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTObject commentStamp: 'mab 12/19/2008 18:46' prior: 0!
I am the base class for every class whose instances should be deployable to the NXT brick. I provide a protocol similar to Object, but much smaller. The category 'nxt-exclude' contains methods, which will be omitted by the compiler.

Instance Variables
!

NXTObject subclass: #NXSBoard
	instanceVariableNames: 'view width height board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSBoard class methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:11'!
newWithWidth: width height: height numberOfApples: numberOfApples
    | newBoard |
    newBoard := self new.
    newBoard board: (NXTArray new: width).
    newBoard width: width.
    newBoard height: height.
		
    1 to: numberOfApples do: [
      newBoard addApple.
    ].
    ^newBoard! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 16:04'!
add: element
	(self board at: element x) isNil ifTrue: [
      self board at: element x put: (NXTArray new: height).
    ].
    (self board at: element x) at: element y put: element.
    view add: element! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
addApple
	| added x y newApple |
	added := false.
	[ added ] whileFalse: 
		[ x := width atRandom.
		y := height atRandom.
		(self board at: x) isNil ifTrue: 
			[ self board 
				at: x
				put: (NXTArray new: height) ].
		((self board at: x) at: y) isNil ifTrue: 
			[ newApple := NXSApple 
				newWithX: x
				Y: y.
			(self board at: x) 
				at: y
				put: newApple.
			added := true.
			view isNil ifFalse: [ view addApple: newApple ] ] ]! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
board
	^ board! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
board: anObject
	board := anObject! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
height
	^ height! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
height: anObject
	height := anObject! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:50'!
isAppleAtX: x Y: y
	((board at: x) isNil) ifFalse: [
      ((board at: x) at: y) isNil ifFalse: [
        ^((board at: x) at: y) isApple
      ]
    ].
    ^false! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:26'!
isSnakeAtX: x Y: y
    ((board at: x) isNil) ifFalse: [
      ((board at: x) at: y) isNil ifFalse: [
        ^((board at: x) at: y) isSnakeElement
      ]
    ].
    ^false! !

!NXSBoard methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:09'!
remove: element
	(self board at: element x) at: element y put: nil.
	self view remove: element.! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
view
	^ view! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:07'!
view: anObject
	view := anObject.
	anObject board: board.
	anObject updateCompletely.! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
width
	^ width! !

!NXSBoard methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:03'!
width: anObject
	width := anObject! !

NXTObject subclass: #NXSBoardView
	instanceVariableNames: 'width height board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSBoardView class methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:18'!
new: board
    | newBoardView |
    newBoardView := self new.
    board view: newBoardView.
    newBoardView width: board width.
    newBoardView height: board height.
    ^newBoardView! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:53'!
add: snakeElement
    self display cursorToX: snakeElement x Y: snakeElement y.
    self display put: '#'.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:54'!
addApple: apple
    self display cursorToX: apple x Y: apple y.
    self display put: 'o'.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:14'!
board: value
	board := value.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:14'!
height: value
	height := value.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:54'!
remove: snakeElement
    self display cursorToX: snakeElement x Y: snakeElement y.
    self display put: ' '.! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:54'!
updateCompletely
    board do: [ :y |
      y isNil ifFalse: [
        y do: [ :apple |
          apple isNil ifFalse: [
            self display cursorToX: apple x Y: apple y.
            self display put: 'o'
          ]
        ]
      ]
    ]! !

!NXSBoardView methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:14'!
width: value
	width := value.! !

NXTObject subclass: #NXSElement
	instanceVariableNames: 'x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

NXSElement subclass: #NXSApple
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSApple methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:08'!
isApple
	^ true! !

!NXSElement class methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:47'!
newWithX: x Y: y
	| newElement |
	newElement := self new.
	newElement x: x.
	newElement y: y.
	^ newElement! !

!NXSElement methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:08'!
isApple
	^ false! !

!NXSElement methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:26'!
isSnakeElement
	^ false! !

!NXSElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:01'!
x
	^ x! !

!NXSElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:01'!
x: anObject
	x := anObject! !

!NXSElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:01'!
y
	^ y! !

!NXSElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:01'!
y: anObject
	y := anObject! !

NXSElement subclass: #NXSnakeElement
	instanceVariableNames: 'next prev'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:27'!
isSnakeElement
	^ true! !

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:22'!
next
	^ next! !

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:22'!
next: anObject
	next := anObject! !

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:22'!
prev
	^ prev! !

!NXSnakeElement methodsFor: 'accessing' stamp: 'mab 9/12/2008 14:22'!
prev: anObject
	prev := anObject! !

NXTObject subclass: #NXSnake
	instanceVariableNames: 'head tail board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSnake class methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:31'!
newWithX: x Y: y andBoard: board 
	| newSnake head |
	newSnake := NXSnake new.
	head := NXSnakeElement 
		newWithX: x
		Y: y.
	newSnake head: head.
	newSnake tail: head.
	newSnake board: board.
	board add: head.
	^ newSnake! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:23'!
board: value
	board := value.! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:23'!
head: value
	head := value.! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 16:00'!
move: newPos
    newPos next: head.
    head prev: newPos.
    head := newPos.

    (board isAppleAtX: newPos x Y: newPos y) ifTrue: [
      board addApple
    ] ifFalse: [

      (board isSnakeAtX: newPos x Y: newPos y) ifTrue: [
        ^false
      ].
      board remove: tail.
      tail := tail prev.
      tail next: nil.
    ].
    board add: newPos.

    ^true! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
moveDown
	| newPos |
	newPos := NXSnakeElement 
		newWithX: head x
		Y: head y.
	newPos y: (self 
			overflow: newPos y + 1
			max: board height).
	^ self move: newPos! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
moveLeft
	| newPos |
	newPos := NXSnakeElement 
		newWithX: head x
		Y: head y.
	newPos x: (self 
			overflow: newPos x - 1
			max: board width).
	^ self move: newPos! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
moveRight
	| newPos |
	newPos := NXSnakeElement 
		newWithX: head x
		Y: head y.
	newPos x: (self 
			overflow: newPos x + 1
			max: board width).
	^ self move: newPos! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:30'!
moveUp
	| newPos |
	newPos := NXSnakeElement 
		newWithX: head x
		Y: head y.
	newPos y: (self 
			overflow: newPos y - 1
			max: board height).
	^ self move: newPos! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:50'!
overflow: val max: max
    (val < 1) ifTrue: [ ^ max + val ].
    (val > max) ifTrue: [ ^ val - max ].
	^ val! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:29'!
run
	| aBoard view chr snake dir continue |
	self display scrolling: false.
	self display clear.
	dir := self buttons enter.
	aBoard := NXSBoard 
		newWithWidth: 16
		height: 8
		numberOfApples: 5.
	view := NXSBoardView new: aBoard.
	snake := NXSnake 
		newWithX: 5
		Y: 5
		andBoard: aBoard.
	continue := true.
	[ continue ] whileTrue: 
		[ chr := self buttons read.
		self buttons none ~= chr ifTrue: [ dir := chr ].
		NXTTimer sleepFor: 250.
		self buttons enter = dir ifTrue: [ continue := snake moveUp ].
		self buttons exit = dir ifTrue: [ continue := snake moveDown ].
		self buttons left = dir ifTrue: [ continue := snake moveLeft ].
		self buttons right = dir ifTrue: [ continue := snake moveRight ] ].
	self display clear.
	self display scrolling: true.
	'GAME OVER' printNl! !

!NXSnake methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:23'!
tail: value
	tail := value.! !

NXTObject subclass: #NXTAnyButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTAnyButton methodsFor: 'testing' stamp: 'mab 9/19/2008 17:01'!
ifNotPressed: aBlock
	self isPressed ifFalse: [ ^ aBlock value ]! !

!NXTAnyButton methodsFor: 'testing' stamp: 'mab 9/19/2008 16:59'!
ifPressed: aBlock
	self isPressed ifTrue: [ ^ aBlock value ]! !

!NXTAnyButton methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:08'!
isPressed
	^ self class buttonRead ~= self class noneButton! !

!NXTAnyButton methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:06'!
wait
	self class waitForAnyKey.! !

NXTAnyButton subclass: #NXTButton
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:29'!
buttonRead
	<NXTPrimitive: 6>! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:10'!
enter
	^ self new number:1! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:11'!
exit
	^ self new number: 2! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:11'!
left
	^ self new number: 3! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:17'!
none
	^ self new number: 0! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:12'!
right
	^ self new number: 4! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 15:13'!
waitFor: aButtonNumber
	Processor activeProcess waitFor: (NXTEvent button: aButtonNumber).
	^ aButtonNumber! !

!NXTButton class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:21'!
waitForAnyKey
	[ self buttonRead = 0] whileTrue.
	^ self buttonRead! !

!NXTButton methodsFor: 'testing' stamp: 'mab 7/22/2008 18:36'!
isPressed
	^ self class buttonRead == self number! !

!NXTButton methodsFor: 'accessing' stamp: 'mab 7/22/2008 18:34'!
number
	^ number! !

!NXTButton methodsFor: 'accessing' stamp: 'mab 7/22/2008 18:34'!
number: anObject
	number := anObject! !

!NXTButton methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:27'!
onPressedDo: aBlock
	| ownerFrame ownerProcess |
	ownerFrame := thisContext sender.
	ownerProcess := Processor activeProcess.
	^ [ self wait.
		Processor withoutScheduling: [
			aBlock onNonLocalReturnsDo: [ :value | ownerProcess return: value from: ownerFrame. ownerProcess resume ]]] fork! !

!NXTButton methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:08'!
wait
	self class waitFor: self number! !

NXTObject subclass: #NXTBenchmark
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTBenchmark methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 14:09'!
run
	'Running tiny benchmarks. Will take 5 minutes...' printNl.
	Processor withoutScheduling: [
		0 tinyBenchmarks ].! !

NXTObject subclass: #NXTBluetooth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:30'!
acceptConnection: aBoolean
	<NXTPrimitive: 72>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:31'!
connectionEstablished
	<NXTPrimitive: 73>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:33'!
dataRead
	<NXTPrimitive: 77>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:29'!
isConnectionPending
	<NXTPrimitive: 70>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 15:48'!
isDataWritten
	<NXTPrimitive: 79>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:32'!
isStreamOpen
	<NXTPrimitive: 75>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:29'!
isWaitingForPIN
	<NXTPrimitive: 69>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:31'!
openStream: handle
	<NXTPrimitive: 74>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:32'!
readInto: aByteArray
	<NXTPrimitive: 76>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/10/2009 20:30'!
sendPIN: aString
	<NXTPrimitive: 71>! !

!NXTBluetooth class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 15:48'!
write: aByteArray
	<NXTPrimitive: 78>! !

NXTObject subclass: #NXTBluetoothTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTBluetoothTester methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 17:16'!
run
	| handle |
	'start' printNl.
	[ NXTButton buttonRead = 0 ] whileTrue: [
		(NXTBluetooth isConnectionPending or: [ NXTBluetooth isWaitingForPIN ]) ifTrue: [
			NXTBluetooth sendPIN: '1234'.
			'pin' print.
			[ NXTBluetooth isConnectionPending ] whileFalse.
			'con' print.
			NXTBluetooth acceptConnection: true.
			[ (handle := NXTBluetooth connectionEstablished) isNil ] whileTrue.
			NXTBluetooth openStream: handle.
			[ NXTBluetooth isStreamOpen ] whileFalse.
			handle := NXTDataStream on: NXTBluetoothStream new.
			(NXTDispatcher for: NXTDriver new on: handle) receive ]].! !

NXTObject subclass: #NXTBoolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTBoolean commentStamp: 'mab 12/19/2008 19:15' prior: 0!
I am a base class for the two boolean classes of NXTalk. I implement shared behavior and define the available protocol.

Instance Variables
!

!NXTBoolean methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:20'!
ifFalse: falseBlock ifTrue: trueBlock
	^ self ifTrue: trueBlock ifFalse: falseBlock! !

NXTBoolean subclass: #NXTFalse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTFalse commentStamp: 'mab 12/28/2008 17:27' prior: 0!
My sole instance 'false' represents the global value for the boolean false.

Instance Variables
!

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:28'!
& aBoolean
	^ self! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:19'!
and: otherBlock
	^ false! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 23:16'!
ifFalse: aBlock
	^ aBlock value! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 23:16'!
ifTrue: aBlock
	^ nil! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:19'!
ifTrue: trueBlock ifFalse: falseBlock
	^ falseBlock value! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:28'!
not
	^ true! !

!NXTFalse methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 11:11'!
or: alternativeBlock
	^ alternativeBlock value! !

NXTBoolean subclass: #NXTTrue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:29'!
& aBoolean
	^ aBoolean! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:18'!
and: otherBlock
	^ otherBlock value! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 23:17'!
ifFalse: aBlock
	^ nil! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 23:17'!
ifTrue: aBlock
	^ aBlock value! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:19'!
ifTrue: trueBlock ifFalse: falseBlock
	^ trueBlock value! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:28'!
not
	^ false! !

!NXTTrue methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 11:11'!
or: alternativeBlock
	^ self! !

NXTObject subclass: #NXTButtonContainer
	instanceVariableNames: 'left right enter exit any none'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:05'!
any
	^ any! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:26'!
enter
	^ enter! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:26'!
exit
	^ exit! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:17'!
initialize
	enter := NXTButton enter.
	exit := NXTButton exit.
	left := NXTButton left.
	right := NXTButton right.
	none := NXTButton none.
	any := NXTAnyButton new.! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:27'!
left
	^ left! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:17'!
none
	^ none! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 14:31'!
read
	| key |
	key := NXTButton buttonRead.
	key = self enter number ifTrue: [ ^ self enter ].
	key = self exit number ifTrue: [ ^ self exit ].
	key = self left number ifTrue: [ ^ self left ].
	key = self right number ifTrue: [ ^ self right ].
	^ self none! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:27'!
right
	^ right! !

!NXTButtonContainer methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 17:21'!
waitForAny
	| key |
	key := NXTButton waitForAnyKey.
	NXTTimer waitFor: 1.
	key = self enter number ifTrue: [ ^ self enter ].
	key = self exit number ifTrue: [ ^ self exit ].
	key = self left number ifTrue: [ ^ self left ].
	key = self right number ifTrue: [ ^ self right ].
	self error: 'Unknown key!!'.! !

NXTObject subclass: #NXTClass
	instanceVariableNames: 'methodDictionary superclass name format instVarNames classPool subclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTClass commentStamp: 'mab 12/19/2008 19:01' prior: 0!
A NXTClass is the description of a class on the NXT.

Instance Variables
	classPool:		<NXTDictionary>
	format:		<NXTSmallInteger>
	instVarNames:		<NXTArray>
	methodDictionary:		<NXTDictionary>
	name:		<NXTString>
	subclasses:		<NXTArray>
	superclass:		<NXTClass>

classPool
	- A dictionary mapping from class variable names to their values.

format
	- Contains bit-encoded information about the instances. For instance, whether they are indexed or normal objects. See the method implementations for more details.

instVarNames
	- An array containing the names of the instance variables in their defined order.

methodDictionary
	- A dictionary mapping from method names to their implementations.

name
	- The name of the described class.

subclasses
	- An array of subclasses.

superclass
	- The superclass of this class.
!

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 15:57'!
allInstances 
	"Answer a collection of all current instances of the receiver."

	| all |
	all := NXTOrderedCollection new.
	self allInstancesDo: [:x | x == all ifFalse: [all add: x]].
	^ all asArray
! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 16:11'!
allInstancesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the current instances of the 
	receiver.
	
	Because aBlock might change the class of inst (for example, using become:),
	it is essential to compute next before aBlock value: inst."
	| inst next |
	self ==  NXTUndefinedObject ifTrue: [^ aBlock value: nil].
	inst := self firstInstance.
	[ inst == nil ] whileFalse: [
		next := inst nextInstance.
		aBlock value: inst.
		inst := next]! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:48'!
allSubInstances 
	"Answer a list of all current instances of the receiver and all of its subclasses."
	| aCollection |
	aCollection := NXTOrderedCollection new.
	self allSubInstancesDo:
		[:x | x == aCollection ifFalse: [aCollection add: x]].
	^ aCollection! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:48'!
allSubInstancesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the current instances of the 
	receiver and all its subclasses."

	self allInstancesDo: aBlock.
	self allSubclassesDo: [:sub | sub allInstancesDo: aBlock]! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 17:58'!
allSubclasses
	| classes |
	classes := NXTOrderedCollection new.
	self allSubclassesDo: [ :class |
		classes add: class ].
	^ classes! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:49'!
allSubclassesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the receiver's subclasses."

	self subclassesDo: 
		[:cl | 
		aBlock value: cl.
		cl allSubclassesDo: aBlock]! !

!NXTClass methodsFor: 'nxt-exclude' stamp: 'mab 7/25/2008 14:10'!
asSqueakObject
	^ Smalltalk at: self name asSqueakObject! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 15:55'!
basicNew
	<NXTPrimitive: 15>! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 16:56'!
basicNew: sizeRequested
	<NXTPrimitive: 16>! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 10:44'!
classPool
	^ classPool ifNil: [ NXTDictionary new ]! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 10/8/2008 21:13'!
classPool: value
	classPool := value! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 16:19'!
classPoolAt: classVar
	^ self classPool at: classVar ifAbsent: [ 
		self superclass ifNil: [ self error: 'Not in class pool' ].
		^ self superclass classPoolAt: classVar ]! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 16:37'!
classPoolAt: classVar put: value
	self classPool at: classVar ifAbsent: [ 
		self superclass ifNil: [ self error: 'Not in class pool' ].
		^ self superclass classPoolAt: classVar put: value ].
	^ self classPool at: classVar put: value.! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:40'!
environment
	^ Smalltalk! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 16:12'!
firstInstance
	<NXTPrimitive: 28>! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 6/5/2008 17:06'!
format
	^ format! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 6/5/2008 17:06'!
format: anObject
	format := anObject! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:23'!
inheritsFrom: aClass 
	"Answer whether the argument, aClass, is on the receiver's superclass 
	chain."

	| aSuperclass |
	aSuperclass := superclass.
	[aSuperclass == nil]
		whileFalse: 
			[aSuperclass == aClass ifTrue: [^true].
			aSuperclass := aSuperclass superclass].
	^false! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 9/1/2008 17:48'!
instSize
	^ format >> 2! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:47'!
instVarNames
	^ instVarNames! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:47'!
instVarNames: anObject
	instVarNames := anObject! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/22/2008 16:35'!
isClass
	^ true! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 14:07'!
isClassProxy
	^ false! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 16:47'!
isMeta
	^ false! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 11/14/2008 19:12'!
isVariable
	^ ((self format >> 7) bitAnd: 1) = 1! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:46'!
methodDictionary
	^ methodDictionary! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:46'!
methodDictionary: anObject
	methodDictionary := anObject! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 16:06'!
name
	^ name! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 16:06'!
name: aSymbol
	^ name := aSymbol! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 15:56'!
new
	^ self basicNew initialize! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 16:48'!
new: sizeRequested 
	^ (self basicNew: sizeRequested) initialize  ! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 11/16/2008 14:52'!
selectors
	| c |
	c := NXTOrderedCollection new.
	self methodDictionary pairsDo: [ :selector :method |
		c add: selector ].
	^ c! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:31'!
subclasses
	^ subclasses! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:23'!
subclasses: array
	subclasses := array! !

!NXTClass methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:50'!
subclassesDo: aBlock
	"Evaluate the argument, aBlock, for each of the receiver's immediate subclasses."
	^self subclasses do: aBlock! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:45'!
superclass
	^ superclass! !

!NXTClass methodsFor: 'accessing' stamp: 'mab 5/21/2008 14:45'!
superclass: anObject
	superclass := anObject! !

!NXTClass methodsFor: 'nxt-exclude' stamp: 'mab 11/18/2008 14:47'!
writeDataOn: aByteStream withImage: image
	 | class instanceVariable |
	super writeDataOn: aByteStream withImage: image.
	self isMeta ifFalse: [
		"Write metaclass' instance variables"
		class := (Smalltalk at: self name asSqueakObject).
		class class instVarNames do: [ :instVarName |
			instanceVariable :=  class instVarNamed: instVarName asSymbol.
			"instanceVariable ifNil: [" instanceVariable := image specialObjectAt: #nil "]".
			instanceVariable asNXTObject writeAsReferenceOn: aByteStream within: image ]].! !

NXTClass subclass: #NXTMetaclass
	instanceVariableNames: 'thisClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMetaclass methodsFor: 'nxt-exclude' stamp: 'mab 7/25/2008 14:09'!
asSqueakObject
	^ (Smalltalk at: (name asSqueakObject allButLast: 6) asSymbol) class! !

!NXTMetaclass methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:50'!
classPool
	^ thisClass classPool! !

!NXTMetaclass methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:50'!
isMeta
	^ true! !

!NXTMetaclass methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 17:17'!
thisClass
	^ thisClass! !

!NXTMetaclass methodsFor: 'as yet unclassified' stamp: 'mab 10/28/2008 15:35'!
thisClass: class
	thisClass := class.! !

NXTObject subclass: #NXTClassProxy
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

!NXTClassProxy class methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:30'!
for: aName
	^ self new name: aName! !

!NXTClassProxy methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 14:06'!
isClassProxy
	^ true! !

!NXTClassProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:30'!
name
	^ name! !

!NXTClassProxy methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:30'!
name: anObject
	name := anObject! !

NXTObject subclass: #NXTCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTCollection class methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:37'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size)
		addAll: aCollection;
		yourself! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 9/25/2008 19:58'!
addAll: aCollection
	aCollection do: [ :each | self add: each ].! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:06'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:06'!
asArray
	"Answer an Array whose elements are the elements of the receiver.
	Implementation note: Cannot use ''Array withAll: self'' as that only
	works for SequenceableCollections which support the replacement 
	primitive."

	| array index |
	array := NXTArray new: self size.
	index := 0.
	self do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:26'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ NXTSet withAll: self! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 18:01'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:57'!
doWithIndex: binaryBlock
	| index |
	index := 0.
	self do: [:elt | binaryBlock value: elt value: (index := index + 1)].! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 9/15/2008 18:13'!
emptyCheck

	self isEmpty ifTrue: [self errorEmptyCollection]! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 9/15/2008 18:13'!
errorEmptyCollection

	self error: 'this collection is empty'! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 10:06'!
errorNotFound: anObject
	"Actually, this should raise a special Exception not just an error."

	self error: 'Object is not in the collection.'! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 14:06'!
includes: anObject 
	"Answer whether anObject is one of the receiver's elements."

	^ self anySatisfy: [:each | each = anObject]! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:35'!
isEmpty
	"Answer whether the receiver contains any elements."

	^self size = 0! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:35'!
reject: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver only those elements for 
	which aBlock evaluates to false. Answer the new collection."

	^self select: [:element | (aBlock value: element) == false]! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 10:05'!
remove: oldObject 
	"Remove oldObject from the receiver's elements. Answer oldObject 
	unless no element is equal to oldObject, in which case, raise an error.
	ArrayedCollections cannot respond to this message."

	^ self remove: oldObject ifAbsent: [self errorNotFound: oldObject]! !

!NXTCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 15:09'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection := self species new.
	self do: [:each | (aBlock value: each) ifTrue: [ newCollection add: each]].
	^newCollection! !

NXTCollection subclass: #NXTSequenceableCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

NXTSequenceableCollection variableSubclass: #NXTArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWith: a
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 1.
	array at: 1 put: a.
	^ array! !

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWith: a with: b 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 2.
	array at: 1 put: a.
	array at: 2 put: b.
	^ array! !

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWith: a with: b with: c 
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 3.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	^ array! !

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWith: a with: b with: c with: d
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	| array |
	array := self new: 4.
	array at: 1 put: a.
	array at: 2 put: b.
	array at: 3 put: c.
	array at: 4 put: d.
	^ array! !

!NXTArray class methodsFor: 'brace support' stamp: 'mab 11/13/2008 10:57'!
braceWithNone
	"This method is used in compilation of brace constructs.
	It MUST NOT be deleted or altered."

	^ self new: 0! !

!NXTArray class methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:24'!
with: anObject 
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 1.
	newCollection at: 1 put: anObject.
	^newCollection! !

!NXTArray class methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 14:48'!
with: anObject1 with: anObject2
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 2.
	newCollection at: 1 put: anObject1.
	newCollection at: 2 put: anObject2.
	^newCollection! !

!NXTArray class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:09'!
with: anObject1 with: anObject2 with: anObject3
	"Answer a new instance of me, containing only anObject."

	| newCollection |
	newCollection := self new: 3.
	newCollection at: 1 put: anObject1.
	newCollection at: 2 put: anObject2.
	newCollection at: 3 put: anObject3.
	^newCollection! !

!NXTArray methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:37'!
asOrderedCollection
	^ NXTOrderedCollection withAll: self! !

!NXTArray methodsFor: 'nxt-exclude' stamp: 'mab 5/29/2008 11:46'!
computeSize
	^ self size! !

!NXTArray methodsFor: 'nxt-exclude' stamp: 'mab 11/17/2008 18:52'!
referencesDo: aBlock
	self do: aBlock! !

!NXTArray methodsFor: 'nxt-exclude' stamp: 'mab 11/18/2008 10:07'!
referencesReplace: aBlock
	1 to: self size do: [ :index |
		self at: index put: (aBlock value: (self at: index)) ].! !

!NXTArray methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 14:58'!
size
	<NXTPrimitive: 17>
	^ super size! !

NXTArray weakSubclass: #NXTWeakArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

NXTSequenceableCollection subclass: #NXTLinkedList
	instanceVariableNames: 'firstLink lastLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
add: aLink 
	"Add aLink to the end of the receiver's list. Answer aLink."

	^self addLast: aLink! !

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
add: link after: otherLink

	"Add otherLink  after link in the list. Answer aLink."

	| savedLink |

	savedLink := otherLink nextLink.
	otherLink nextLink: link.
	link nextLink:  savedLink.
	^link.! !

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
add: link before: otherLink

	| aLink |
	firstLink == otherLink ifTrue: [^ self addFirst: link].
	aLink := firstLink.
	[aLink == nil] whileFalse: [
		aLink nextLink == otherLink ifTrue: [
			link nextLink: aLink nextLink.
			aLink nextLink: link.
			^ link
		].
		 aLink := aLink nextLink.
	].
	^ self errorNotFound: otherLink! !

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
addFirst: aLink 
	"Add aLink to the beginning of the receiver's list. Answer aLink."

	self isEmpty ifTrue: [lastLink := aLink].
	aLink nextLink: firstLink.
	firstLink := aLink.
	^aLink! !

!NXTLinkedList methodsFor: 'adding' stamp: 'mab 9/15/2008 16:51'!
addLast: aLink 
	"Add aLink to the end of the receiver's list. Answer aLink."

	self isEmpty
		ifTrue: [firstLink := aLink]
		ifFalse: [lastLink nextLink: aLink].
	lastLink := aLink.
	^aLink! !

!NXTLinkedList methodsFor: 'accessing' stamp: 'mab 9/15/2008 16:51'!
at: index

	| i |
	i := 0.
	self do: [:link |
		(i := i + 1) = index ifTrue: [^ link]].
	^ self errorSubscriptBounds: index! !

!NXTLinkedList methodsFor: 'enumerating' stamp: 'mab 11/18/2008 13:40'!
do: aBlock

	| aLink |
	aLink := firstLink.
	[aLink isNil] whileFalse:
		[aBlock value: aLink.
		 aLink := aLink nextLink]! !

!NXTLinkedList methodsFor: 'accessing' stamp: 'mab 9/15/2008 16:51'!
first
	"Answer the first link. Create an error notification if the receiver is 
	empty."

	self emptyCheck.
	^firstLink! !

!NXTLinkedList methodsFor: 'testing' stamp: 'mab 9/15/2008 16:51'!
isEmpty

	^firstLink == nil! !

!NXTLinkedList methodsFor: 'accessing' stamp: 'mab 9/15/2008 16:51'!
last
	"Answer the last link. Create an error notification if the receiver is 
	empty."

	self emptyCheck.
	^lastLink! !

!NXTLinkedList methodsFor: 'removing' stamp: 'mab 9/15/2008 16:51'!
remove: aLink ifAbsent: aBlock  
	"Remove aLink from the receiver. If it is not there, answer the result of
	evaluating aBlock."

	| tempLink |
	aLink == firstLink
		ifTrue: [firstLink := aLink nextLink.
				aLink == lastLink
					ifTrue: [lastLink := nil]]
		ifFalse: [tempLink := firstLink.
				[tempLink == nil ifTrue: [^aBlock value].
				 tempLink nextLink == aLink]
					whileFalse: [tempLink := tempLink nextLink].
				tempLink nextLink: aLink nextLink.
				aLink == lastLink
					ifTrue: [lastLink := tempLink]].
	aLink nextLink: nil.
	^aLink! !

!NXTLinkedList methodsFor: 'removing' stamp: 'mab 9/15/2008 16:51'!
removeFirst
	"Remove the first element and answer it. If the receiver is empty, create 
	an error notification."

	| oldLink |
	self emptyCheck.
	oldLink := firstLink.
	firstLink == lastLink
		ifTrue: [firstLink := nil. lastLink := nil]
		ifFalse: [firstLink := oldLink nextLink].
	oldLink nextLink: nil.
	^oldLink! !

!NXTLinkedList methodsFor: 'removing' stamp: 'mab 9/15/2008 16:51'!
removeLast
	"Remove the receiver's last element and answer it. If the receiver is 
	empty, create an error notification."

	| oldLink aLink |
	self emptyCheck.
	oldLink := lastLink.
	firstLink == lastLink
		ifTrue: [firstLink := nil. lastLink := nil]
		ifFalse: [aLink := firstLink.
				[aLink nextLink == oldLink] whileFalse:
					[aLink := aLink nextLink].
				 aLink nextLink: nil.
				 lastLink := aLink].
	oldLink nextLink: nil.
	^oldLink! !

!NXTLinkedList methodsFor: 'as yet unclassified' stamp: 'mab 9/15/2008 18:01'!
size
	"Answer how many elements the receiver contains."

	| tally |
	tally := 0.
	self do: [:each | tally := tally + 1].
	^ tally! !

!NXTLinkedList methodsFor: 'enumerating' stamp: 'mab 9/15/2008 16:53'!
species

	^ NXTArray! !

NXTLinkedList subclass: #NXTProcessorScheduler
	instanceVariableNames: 'activeProcess waitingProcesses schedulerProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 11:41'!
= anObject
	^ self == anObject! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 16:08'!
activeProcess
	^ activeProcess! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 09:39'!
addWaitingProcess: aProcess
	self withoutScheduling: [
		self remove: aProcess.
		aProcess nextLink: self waitingProcesses.
		self waitingProcesses: aProcess.
		self activeProcess = aProcess ifTrue: [ self yield ]].
	^ aProcess! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 14:17'!
checkWaitingProcesses
	<NXTPrimitive: 66>! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 13:39'!
findNextRunnable
	[ self isEmpty or: [ self first isRunnable ]] whileFalse: [ self removeFirst ].
	self isEmpty ifTrue: [ ^ nil ].
	^ self addLast: self removeFirst
! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 11:41'!
hash
	^ self identityHash! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 12/15/2008 13:35'!
initializeClasses
	Smalltalk valuesDo: [ :class | class initialize ].! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 12:05'!
processCount
	| count process |
	count := 0.
	process := self waitingProcesses.
	[ process isNil ] whileFalse: [ count := count + 1. process := process nextLink ].
	^ self size + count! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 11:59'!
removeWaitingProcess: process ifAbsent: aBlock
	| last current |
	last := nil.
	current := self waitingProcesses.
	[ current isNil ] whileFalse: [
		current == process ifTrue: [
			last 
				ifNil: [ self waitingProcesses: current nextLink ]
				ifNotNil: [ last nextLink: current nextLink ].
			current nextLink: nil.
			^ process ].
		last := current.
		current := current nextLink ].
	^ aBlock value
	! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:28'!
resumeProcess: aProcess
	self withoutScheduling: [
		(self includes: aProcess) ifFalse: [ self addLast: aProcess ].
		self removeWaitingProcess: aProcess ifAbsent: []].
	^ aProcess! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 13:41'!
schedule
	self scheduleTo: (self findNextRunnable ifNil: [ ^ false ]).
	^ true! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 14:17'!
scheduleLoop
	[ self checkWaitingProcesses.
	self schedule or: [ self waitingProcesses isNil not ]] whileTrue.! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 17:54'!
scheduleTo: process
	<NXTPrimitive: 47>! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 9/15/2008 16:25'!
schedulingEnabled: aBoolean
	<NXTPrimitive: 48>! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 12/16/2008 11:45'!
startup
	self initializeClasses.
	self test.
	[ NXTSystem new run ] fork.
	self scheduleLoop.! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:26'!
suspendProcess: aProcess
	self withoutScheduling: [
		self remove: aProcess.
		self activeProcess = aProcess ifTrue: [ self yield ]].
	^ aProcess! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 2/4/2009 13:03'!
test
! !

!NXTProcessorScheduler methodsFor: 'accessing' stamp: 'mab 12/28/2008 19:52'!
waitingProcesses
	^ waitingProcesses! !

!NXTProcessorScheduler methodsFor: 'accessing' stamp: 'mab 12/28/2008 19:52'!
waitingProcesses: anObject
	waitingProcesses := anObject! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 09:28'!
withoutScheduling: aBlock
	self schedulingEnabled: false.
	aBlock value.
	self schedulingEnabled: true.! !

!NXTProcessorScheduler methodsFor: 'as yet unclassified' stamp: 'mab 12/30/2008 13:10'!
yield
	<NXTPrimitive: 65>! !

NXTLinkedList subclass: #NXTSemaphore
	instanceVariableNames: 'excessSignals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTSemaphore class methodsFor: 'instance creation' stamp: 'mab 9/16/2008 09:37'!
forMutualExclusion
	"Answer an instance of me that contains a single signal. This new 
	instance can now be used for mutual exclusion (see the critical: message 
	to Semaphore)."

	^self new signal! !

!NXTSemaphore methodsFor: 'mutual exclusion' stamp: 'mab 9/16/2008 09:34'!
critical: aBlock
	| blockValue |
	self wait.
	blockValue := aBlock value.
	self signal.
	^ blockValue! !

!NXTSemaphore methodsFor: 'initialize-release' stamp: 'mab 9/16/2008 09:36'!
initSignals
	"Consume any excess signals the receiver may have accumulated."

	excessSignals := 0.! !

!NXTSemaphore methodsFor: 'initialize-release' stamp: 'mab 9/16/2008 09:40'!
initialize
	self initSignals! !

!NXTSemaphore methodsFor: 'testing' stamp: 'mab 9/16/2008 09:33'!
isSignaled
	"Return true if this semaphore is currently signaled"
	^excessSignals > 0! !

!NXTSemaphore methodsFor: 'communication' stamp: 'mab 9/16/2008 09:28'!
signal
	Processor withoutScheduling: [
		self isEmpty
			ifTrue: [ excessSignals := excessSignals + 1 ]
			ifFalse: [ self removeFirst resume ]].! !

!NXTSemaphore methodsFor: 'communication' stamp: 'mab 9/16/2008 09:47'!
wait
	Processor withoutScheduling: [
		excessSignals > 0
			ifTrue: [ excessSignals := excessSignals - 1 ]
			ifFalse: [ (self addLast: Processor activeProcess) suspend ]].! !

NXTSequenceableCollection subclass: #NXTOrderedCollection
	instanceVariableNames: 'array firstIndex lastIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTOrderedCollection class methodsFor: 'instance creation' stamp: 'mab 5/29/2008 15:59'!
new
	^ self new: 10! !

!NXTOrderedCollection class methodsFor: 'instance creation' stamp: 'mab 5/29/2008 16:00'!
new: anInteger 
	^ self basicNew setCollection: (NXTArray new: anInteger)! !

!NXTOrderedCollection class methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 15:17'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size) addAll: aCollection! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 6/9/2008 15:30'!
add: newObject
	^self addLast: newObject! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 10/3/2008 22:39'!
addFirst: newObject 
	"Add newObject to the beginning of the receiver. Answer newObject."

	firstIndex = 1 ifTrue: [self makeRoomAtFirst].
	firstIndex := firstIndex - 1.
	array at: firstIndex put: newObject.
	^ newObject! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 15:48'!
addLast: newObject 
	"Add newObject to the end of the receiver. Answer newObject."

	lastIndex = array size ifTrue: [self makeRoomAtLast].
	lastIndex := lastIndex + 1.
	array at: lastIndex put: newObject.
	^ newObject! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 15:46'!
at: anInteger 
	"Answer my element at index anInteger. at: is used by a knowledgeable
	client to access an existing element"
	
	(anInteger < 1 or: [anInteger + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^ array at: anInteger + firstIndex - 1]! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 15:36'!
at: anInteger put: anObject 
	"Put anObject at element index anInteger. at:put: cannot be used to
	append, front or back, to an ordered collection; it is used by a
	knowledgeable client to replace an element."

	| index |
	index := anInteger asInteger.
	(index < 1 or: [index + firstIndex - 1 > lastIndex])
		ifTrue: [self errorNoSuchElement]
		ifFalse: [^array at: index + firstIndex - 1 put: anObject]! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 10:02'!
collect: aBlock 
	"Evaluate aBlock with each of my elements as the argument. Collect the 
	resulting values into a collection that is like me. Answer the new 
	collection. Override superclass in order to use addLast:, not at:put:."

	| newCollection |
	newCollection := self species new: self size.
	firstIndex to: lastIndex do:
		[:index |
		newCollection addLast: (aBlock value: (array at: index))].
	^ newCollection! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/20/2008 16:10'!
errorNoSuchElement
	self error: 'attempt to index non-existent element in an ordered collection'! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 16:00'!
grow
	"Become larger. Typically, a subclass has to override this if the subclass
	adds instance variables."
	| newArray |
	newArray := NXTArray new: self size + self growSize.
	newArray replaceFrom: 1 to: array size with: array startingAt: 1.
	array := newArray! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 15:48'!
growSize
	^ array size max: 2! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 10/3/2008 22:39'!
makeRoomAtFirst
	| delta index |
	delta := array size - self size.
	delta = 0 ifTrue: 
			[self grow.
			delta := array size - self size].
	lastIndex = array size ifTrue: [^ self]. "just in case we got lucky"
	index := array size.
	[index > delta]
		whileTrue: 
			[array at: index put: (array at: index - delta + firstIndex - 1).
			array at: index - delta + firstIndex - 1 put: nil.
			index := index - 1].
	firstIndex := delta + 1.
	lastIndex := array size! !

!NXTOrderedCollection methodsFor: 'adding' stamp: 'mab 5/29/2008 15:48'!
makeRoomAtLast
	| newLast delta |
	newLast := self size.
	array size - self size = 0 ifTrue: [self grow].
	(delta := firstIndex - 1) = 0 ifTrue: [^ self].
	"we might be here under false premises or grow did the job for us"
	1 to: newLast do:
		[:index |
		array at: index put: (array at: index + delta).
		array at: index + delta put: nil].
	firstIndex := 1.
	lastIndex := newLast! !

!NXTOrderedCollection methodsFor: 'private' stamp: 'mab 5/29/2008 15:53'!
reset
	firstIndex := array size // 3 max: 1.
	lastIndex := firstIndex - 1! !

!NXTOrderedCollection methodsFor: 'private' stamp: 'mab 5/29/2008 15:53'!
setCollection: anArray
	array := anArray.
	self reset! !

!NXTOrderedCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:52'!
size
	"Answer how many elements the receiver contains."

	^ lastIndex - firstIndex + 1! !

!NXTSequenceableCollection class methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:39'!
withAll: aCollection
	"Create a new collection containing all the elements from aCollection."

	^ (self new: aCollection size) replaceFrom: 1 to: aCollection size with: aCollection! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 17:47'!
, other
	| oldSize newSize c |
	newSize := self size + other size.
	c := self species new: newSize.
	1 to: self size do: [ :index | c at: index put: (self at: index) ].
	oldSize := self size.
	1 to: other size do: [ :index | c at: index + oldSize put: (other at: index) ].
	^ c
	! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 16:30'!
= otherCollection 
	"Answer true if the receiver is equivalent to the otherCollection.
	First test for identity, then rule out different species and sizes of
	collections. As a last resort, examine each element of the receiver
	and the otherCollection."

	self == otherCollection ifTrue: [^ true].
	self species == otherCollection species ifFalse: [^ false].
	^ self hasEqualElements: otherCollection! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:56'!
allButFirst: n
	"Answer a copy of the receiver containing all but the first n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: n + 1 to: self size! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 15:28'!
allButLast: n
	"Answer a copy of the receiver containing all but the last n
	elements. Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: self size - n! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/24/2008 16:59'!
asArray
	"Answer an Array whose elements are the elements of the receiver."

	^ NXTArray withAll: self! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 15:42'!
atAllPut: anObject 
	"Put anObject at every one of the receiver's indices."

	| size |
	(size := self size) > 26 "first method faster from 27 accesses and on"
		ifTrue: [self from: 1 to: size put: anObject]
		ifFalse: [1 to: size do: [:index | self at: index put: anObject]]! !

!NXTSequenceableCollection methodsFor: 'comparing' stamp: 'mab 7/25/2008 19:33'!
beginsWith: aSequenceableCollection

	(aSequenceableCollection isEmpty or: [self size < aSequenceableCollection size]) ifTrue: [^false].
	aSequenceableCollection withIndexDo: [:each :index | (self at: index) ~= each ifTrue: [^false]].
	^true! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 18:41'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection := self species new: self size.
	1 to: self size do:
		[:index |
		newCollection at: index put: (aBlock value: (self at: index))].
	^ newCollection! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 16:14'!
copyFrom: start to: stop 
	"Answer a copy of a subset of the receiver, starting from element at 
	index start until element at index stop."

	| newSize |
	newSize := stop - start + 1.
	^(self species new: newSize)
		replaceFrom: 1
		to: newSize
		with: self
		startingAt: start! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/5/2008 14:36'!
do: aBlock 
	"Refer to the comment in Collection|do:."
	1 to: self size do:
		[:index | aBlock value: (self at: index)]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:43'!
doWithIndex: elementAndIndexBlock
	"Use the new version with consistent naming"
	^ self withIndexDo: elementAndIndexBlock! !

!NXTSequenceableCollection methodsFor: 'comparing' stamp: 'mab 11/15/2008 17:22'!
endsWith: aSequenceableCollection

	| start |
	(aSequenceableCollection isEmpty or: [self size < aSequenceableCollection size]) ifTrue: [^false].
	start := self size - aSequenceableCollection size.
	aSequenceableCollection withIndexDo: [:each :index | (self at: start + index) ~= each ifTrue: [^false]].
	^true! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 15:21'!
first
	^ self at: 1! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 16:14'!
first: n
	"Answer the first n elements of the receiver.
	Raise an error if there are not enough elements."

	^ self copyFrom: 1 to: n! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 15:45'!
from: startIndex to: endIndex put: anObject
	"Put anObject in all indexes between startIndex 
	and endIndex. Very fast. Faster than to:do: for
	more than 26 positions. Answer anObject"

	| written toWrite thisWrite |

	startIndex > endIndex ifTrue: [^self].
	self at: startIndex put: anObject.
	written := 1.
	toWrite := endIndex - startIndex + 1.
	[written < toWrite] whileTrue:
		[
			thisWrite := written min: toWrite - written.
			self 
				replaceFrom: startIndex + written
				to: startIndex + written + thisWrite - 1
				with: self startingAt: startIndex.
			written := written + thisWrite
		].
	^anObject! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 16:30'!
hasEqualElements: otherCollection
	"Answer whether the receiver's size is the same as otherCollection's
	size, and each of the receiver's elements equal the corresponding 
	element of otherCollection.
	This should probably replace the current definition of #= ."

	| size |
	"(otherCollection isKindOf: SequenceableCollection) ifFalse: [^ false]."
	(size := self size) = otherCollection size ifFalse: [^ false].
	1 to: size do:
		[:index |
		(self at: index) = (otherCollection at: index) ifFalse: [^ false]].
	^ true! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:25'!
indexOf: anElement
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer 0."

	^ self indexOf: anElement ifAbsent: [0]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:25'!
indexOf: anElement ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement within the  
	receiver. If the receiver does not contain anElement, answer the 
	result of evaluating the argument, exceptionBlock."

	^ self indexOf: anElement startingAt: 1 ifAbsent: exceptionBlock! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:25'!
indexOf: anElement startingAt: start ifAbsent: exceptionBlock
	"Answer the index of the first occurence of anElement after start
	within the receiver. If the receiver does not contain anElement, 
	answer the 	result of evaluating the argument, exceptionBlock."

	start to: self size do:
		[:index |
		(self at: index) = anElement ifTrue: [^ index]].
	^ exceptionBlock value! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 18:43'!
last
	"Answer the last element of the receiver"

	^ self at: self size! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:39'!
pairsDo: aBlock 
	"Evaluate aBlock with my elements taken two at a time.  If there's an odd number of items, ignore the last one.  Allows use of a flattened array for things that naturally group into pairs.  See also pairsCollect:"

	1 to: self size // 2 do:
		[:index | aBlock value: (self at: 2 * index - 1) value: (self at: 2 * index)]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/5/2008 16:14'!
replaceFrom: start to: stop with: replacement 
	"This destructively replaces elements from start to stop in the receiver. 
	Answer the receiver itself. Use copyReplaceFrom:to:with: for 
	insertion/deletion which may alter the size of the result."

	replacement size = (stop - start + 1)
		ifFalse: [self error: 'Size of replacement doesnt match'].
	^self replaceFrom: start to: stop with: replacement startingAt: 1! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 15:50'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	"This destructively replaces elements from start to stop in the receiver 
	starting at index, repStart, in the sequenceable collection, 
	replacementCollection. Answer the receiver. No range checks are 
	performed."

	| index repOff |
	repOff := repStart - start.
	index := start - 1.
	[(index := index + 1) <= stop]
		whileTrue: [self at: index put: (replacement at: repOff + index)]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:12'!
startsWith: start 
	| comp |
	self size < start size ifTrue: [^ false].
	comp := true.
	(self first: start size) with: start
		do: [:ea :ea2 | ea = ea2 ifFalse: [comp := false]].
	^ comp! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:12'!
with: otherCollection do: twoArgBlock 
	"Evaluate twoArgBlock with corresponding elements from this collection and otherCollection."
	otherCollection size = self size ifFalse: [self error: 'otherCollection must be the same size'].
	1 to: self size do:
		[:index |
		twoArgBlock value: (self at: index)
				value: (otherCollection at: index)]! !

!NXTSequenceableCollection methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:42'!
withIndexDo: elementAndIndexBlock 
	"Just like with:do: except that the iteration index supplies the second argument to the block."
	1 to: self size do:
		[:index |
		elementAndIndexBlock
			value: (self at: index)
			value: index]! !

NXTSequenceableCollection variableByteSubclass: #NXTString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTString class methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:38'!
cr
	| string |
	string := self new: 1.
	string at: 1 put: 10.
	^ string! !

!NXTString class methodsFor: 'nxt-exclude' stamp: 'mab 6/5/2008 17:12'!
elementSize
	^ 1! !

!NXTString class methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 17:12'!
printString: aString
	<NXTPrimitive: 0>
	Transcript show: aString; cr.! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:51'!
= other
	other isString ifFalse: [ ^ false ].
	self size = other size ifFalse: [ ^ false ].
	1 to: self size do: [ :index |
		(self at: index) = (other at: index) ifFalse: [ ^ false ]].
	^ true
	! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 7/15/2008 10:47'!
asByteArray
	^ self! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 10:56'!
asString
	^ self! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 7/16/2008 14:41'!
asSymbol
	^ NXTSymbol intern: self! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 9/10/2008 14:34'!
at: index
	<primitive: 63>
	<NXTPrimitive: 20>! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 9/10/2008 14:33'!
at: index put: aCharacter
	<primitive: 64>
	<NXTPrimitive: 21>! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 6/5/2008 17:17'!
computeSize
	^ self size! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 12/15/2008 13:19'!
hash
	<NXTPrimitive: 62>
	| hash |
	hash := 0.
	self do: [ :character |
		hash := character asInteger + (hash << 6) + (hash << 16) - hash ].
	^ hash \\ (NXTSmallInteger maxVal + 1)! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 11/20/2008 14:25'!
isByteString
	^ true! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:57'!
isString
	^ true! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 17:12'!
print
	self class printString: self! !

!NXTString methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 16:33'!
printNl
	(self, self class cr) print! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 6/6/2008 14:36'!
printOn: aStream
	aStream nextPutAll: 'an NXTString('''.
	aStream nextPutAll: self.
	aStream nextPutAll: ''')'.! !

!NXTString methodsFor: 'nxt-exclude' stamp: 'mab 7/21/2008 18:38'!
writeDataOn: aByteStream withImage: image
	1 to: self size do: [ :index |
		aByteStream nextPut: (self at: index) asInteger ].! !

NXTString variableByteSubclass: #NXTSymbol
	instanceVariableNames: ''
	classVariableNames: 'SymbolTable'
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTSymbol class methodsFor: 'as yet unclassified' stamp: 'mab 10/29/2008 13:36'!
initialize
	super initialize.
	SymbolTable := NXTWeakSet withAll: self allInstances.! !

!NXTSymbol class methodsFor: 'as yet unclassified' stamp: 'mab 10/29/2008 11:55'!
intern: aStringOrSymbol
	^ (self lookup: aStringOrSymbol) ifNil: [
		| aSymbol |
		aStringOrSymbol isSymbol ifTrue: [
			aSymbol := aStringOrSymbol
		] ifFalse: [
			aSymbol := NXTSymbol new: aStringOrSymbol size.
			aSymbol string: aStringOrSymbol.
		].
		SymbolTable add: aSymbol.
	].! !

!NXTSymbol class methodsFor: 'as yet unclassified' stamp: 'mab 10/29/2008 11:49'!
lookup: aStringOrSymbol
	^ SymbolTable like: aStringOrSymbol! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:48'!
= aSymbol
	"Compare the receiver and aSymbol." 
	self == aSymbol ifTrue: [^ true].
	self class == aSymbol class ifTrue: [^ false].
	"Use String comparison otherwise"
	^ super = aSymbol! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:50'!
asMutator
	^ (self, ':') asSymbol! !

!NXTSymbol methodsFor: 'nxt-exclude' stamp: 'mab 11/16/2008 15:05'!
asSqueakObject
	^ (String withAll: self) asSymbol! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:49'!
asString
	| string |
	string := NXTString new: self size.
	string replaceFrom: 1 to: self size with: self.
	^ string! !

!NXTSymbol methodsFor: 'testing' stamp: 'mab 7/25/2008 19:16'!
isSymbol
	^ true! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 17:18'!
print
	'#' print. self class printString: self.! !

!NXTSymbol methodsFor: 'nxt-exclude' stamp: 'mab 6/6/2008 14:36'!
printOn: aStream
	aStream nextPutAll: 'an NXTSymbol(#'.
	aStream nextPutAll: self.
	aStream nextPut: $).! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 15:04'!
species
	^ NXTString! !

!NXTSymbol methodsFor: 'as yet unclassified' stamp: 'mab 10/29/2008 11:58'!
string: aString

	1 to: aString size do: [:j | super at: j put: (aString at: j)].
	^self  ! !

NXTCollection subclass: #NXTSet
	instanceVariableNames: 'tally array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTSet commentStamp: 'mab 8/15/2008 14:47' prior: 0!
Methods taken from Ian Piumarta's idST (object/st80/Set.st).!

NXTSet subclass: #NXTDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTDictionary commentStamp: 'mab 8/15/2008 15:09' prior: 0!
Methods taken from Ian Piumarta's idST (object/st80/Dictionary.st).!

!NXTDictionary class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 16:44'!
new
	^ super new! !

!NXTDictionary class methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 09:02'!
newFrom: aDict 
	"Answer an instance of me containing the same associations as aDict.
	 Error if any key appears twice."
	| newDictionary |
	newDictionary := self new: aDict size.
	aDict associationsDo:
		[:x |
		(newDictionary includesKey: x key)
			ifTrue: [self error: 'Duplicate key: ', x key printString]
			ifFalse: [newDictionary add: x]].
	^ newDictionary

"	NewDictionary newFrom: {1->#a. 2->#b. 3->#c}
	{1->#a. 2->#b. 3->#c} as: NewDictionary
	NewDictionary newFrom: {1->#a. 2->#b. 1->#c}
	{1->#a. 2->#b. 1->#c} as: NewDictionary
"! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:08'!
= aDictionary
	aDictionary isDictionary ifFalse: [^false].
	self size = aDictionary size ifFalse: [^false].
	self associationsDo: [:assoc|
	(aDictionary at: assoc key ifAbsent: [^false]) = assoc value
		ifFalse: [^false]].
	^true! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:56'!
add: anAssociation
	| index element |
	index := self findElementOrNil: anAssociation key.
	element := array at: index.
	element == nil
		ifTrue: [self atNewIndex: index put: anAssociation]
		ifFalse: [element value: anAssociation value].
	^ anAssociation! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:57'!
addAll: aDictionary
	aDictionary == self ifFalse: [aDictionary associationsDo: [:assoc | self add: assoc]].
	^aDictionary.! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:49'!
associationAt: key
	^self associationAt: key ifAbsent: [self errorKeyNotFound]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 12:08'!
associationAt: key ifAbsent: aBlock
	"Answer the association with the given key.  If key is not found,
	return the result of evaluating aBlock."
	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	^ assoc
		ifNil:  [aBlock value]
		ifNotNil: [assoc]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:57'!
associationsDo: aBlock
	super do: aBlock! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:17'!
associationsSelect: aBlock 
	"Evaluate aBlock with each of my associations as the argument. Collect
	into a new dictionary, only those associations for which aBlock evaluates
	to true."

	| newCollection |
	newCollection := self species new.
	self associationsDo: 
		[:each | 
		(aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:42'!
at: key
	"Answer the value associated with the key."
	^self at: key ifAbsent: [self errorKeyNotFound]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 12:08'!
at: key ifAbsent: aBlock
	"Answer the value associated with the key or, if key isn't found,
	answer the result of evaluating aBlock."
	| assoc |
	assoc := array at: (self findElementOrNil: key).
	^ assoc
		ifNil:  [aBlock value]
		ifNotNil: [assoc value]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 13:20'!
at: key ifPresent: aBlock
	"Lookup the given key in the receiver. If it is present, answer the value of evaluating the given block with the value associated with the key. Otherwise, answer nil."

	| v |
	v := self at: key ifAbsent: [^ nil].
	^ aBlock value: v
! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:48'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."
	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (NXTAssociation key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:38'!
collect: aBlock 
	"Evaluate aBlock with each of my values as the argument.  Collect the
	resulting values into a collection that is like me. Answer with the new
	collection."
	| newCollection |
	newCollection := NXTOrderedCollection new: self size.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:58'!
do: aBlock
	super do: [:assoc | aBlock value: assoc value]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:01'!
errorKeyNotFound
	self error: 'key not found'! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:01'!
errorValueNotFound
	self error: 'value not found'! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 15:07'!
includesAssociation: anAssociation
  ^ (self   
      associationAt: anAssociation key
      ifAbsent: [ ^ false ]) value = anAssociation value
! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:56'!
includesKey: key
	self at: key ifAbsent: [^false].
	^true! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 16:55'!
isDictionary
	^ true! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:02'!
keyAt: index
	"May be overridden by subclasses so that fixCollisions will work"
	| assoc |
	assoc := array at: index.
	^nil == assoc ifFalse: [assoc key]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:02'!
keyAtValue: value 
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer nil."

	^self keyAtValue: value ifAbsent: [self errorValueNotFound]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:02'!
keyAtValue: value ifAbsent: exceptionBlock
	"Answer the key that is the external name for the argument, value. If 
	there is none, answer the result of evaluating exceptionBlock.
	: Use =, not ==, so stings like 'this' can be found.  Note that MethodDictionary continues to use == so it will be fast."
 
	self associationsDo: 
		[:association | value = association value ifTrue: [^association key]].
	^exceptionBlock value! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:54'!
keys
	| keySet |
	keySet := NXTSet new: self size.
	self keysDo: [:key | keySet add: key].
    ^keySet! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:58'!
keysAndValuesDo: aBlock
	^self associationsDo: [:assoc | aBlock value: assoc key value: assoc value]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:58'!
keysDo: aBlock
	self associationsDo: [:association | aBlock value: association key]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:02'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject key) put: anObject.
	tally := tally + 1.! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:04'!
occurrencesOf: anObject 
	"Answer how many of the receiver's elements are equal to anObject."

	| count |
	count := 0.
	self do: [:each | anObject = each ifTrue: [count := count + 1]].
	^count! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:03'!
rehash	
	| newSelf |
	newSelf := self species new: self size.
	self associationsDo: [:each | newSelf noCheckAdd: each].
	array := newSelf array! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:07'!
removeKey: key
	^self removeKey: key ifAbsent: [self errorKeyNotFound]! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:07'!
removeKey: key ifAbsent: aBlock 
	"Remove key (and its associated value) from the receiver. If key is not in 
	the receiver, answer the result of evaluating aBlock. Otherwise, answer 
	the value externally named by key."
	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc == nil ifTrue: [ ^ aBlock value ].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^ assoc value! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 12:09'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil
	(indicating an empty slot) or an element that matches
	anObject. Answer the index of that slot or zero if no slot is
	found. This method will be overridden in various subclasses that
	have different interpretations for matching elements."
	| element start finish |
	start := (anObject hash \\ array size) + 1.
	finish := array size.
	"Search from (hash mod size) to the end."
	start to: finish do: [:index |
	((element := array at: index) isNil or: [element key = anObject])
		ifTrue: [^index]].
	"Search from 1 to where we started."
	1 to: start - 1 do: [:index |
		((element := array at: index) isNil or: [element key = anObject])
			ifTrue: [^index]].
	^0! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:59'!
select: aBlock
	"Evaluate aBlock with each of my values as the argument.  Collect into a
	new Dictionary all associations for which aBlock evaluates to true."
	| newCollection |
	newCollection := self species new.
	self associationsDo: [:assoc | (aBlock value: assoc value) ifTrue: [newCollection add: assoc]].
	^newCollection! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:55'!
values	
	| valueArray |
	valueArray := NXTArray new: self size.
	self doWithIndex: [:value :index | valueArray at: index put: value].
	^valueArray! !

!NXTDictionary methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:00'!
valuesDo: aBlock
	self associationsDo: [:assoc | aBlock value: assoc value]! !

NXTDictionary subclass: #NXTSystemDictionary
	instanceVariableNames: 'display motors buttons sensors packageManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 15:35'!
addClass: class
	class superclass isNil ifFalse: [ 
		class superclass subclasses add: class ].
	class class superclass isNil ifFalse: [
		class class superclass subclasses add: class class ].
	^ Smalltalk at: class name put: class! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:48'!
buttons
	^ buttons ifNil: [ buttons := NXTButtonContainer new ]! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 15:23'!
classNamed: aClassName
	^ self at: aClassName ifAbsent: [
		(aClassName endsWith: ' class') ifFalse: [ ^ nil ].
		^ (self at: (aClassName allButLast: 6) asSymbol ifAbsent: [ ^ nil ]) class ]! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:42'!
display
	^ display ifNil: [ display := NXTDisplay new ]! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 10/28/2008 13:49'!
garbageCollect
	<NXTPrimitive: 52>! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 17:53'!
isNXTalk
	^ true! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/12/2008 17:51'!
motorA
	^ self motors at: 1! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/12/2008 17:51'!
motorB
	^ self motors at: 2! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/12/2008 17:51'!
motorC
	^ self motors at: 3! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/12/2008 17:48'!
motors
	^ motors ifNil: [ motors := NXTMotor all ]! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:35'!
packageManager
	^ packageManager! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:35'!
packageManager: anObject
	packageManager := anObject.! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:05'!
sensorAt: port put: sensor
	sensor port: port.
	^ self sensors at: port put: sensor.! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:04'!
sensors
	^ sensors ifNil: [ sensors := NXTArray new: 4 ]! !

!NXTSystemDictionary methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 21:59'!
shutdown
	<NXTPrimitive: 51>! !

!NXTSet class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:32'!
new
	^ self new: 2! !

!NXTSet class methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 17:22'!
new: nElements
	^ super new initialize: (self sizeFor: nElements)! !

!NXTSet class methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 17:21'!
sizeFor: nElements
	"Large enough size to hold nElements with some slop (see fullCheck)"
	nElements <= 0 ifTrue: [^ 1].
	^ nElements+1*4//3! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 16:08'!
= aSet
	self == aSet ifTrue: [^ true].	"stop recursion"
	(aSet isKindOf: NXTSet) ifFalse: [^ false].
	self size = aSet size ifFalse: [^ false].
	self do: [:each | (aSet includes: each) ifFalse: [^ false]].
	^ true! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:36'!
add: newObject
	| index |
	newObject isNil ifTrue: [self error: 'Sets cannot meaningfully contain nil as an element'].
	index := self findElementOrNil: newObject.
	(array at: index) isNil ifTrue: [self atNewIndex: index put: newObject].
	^newObject! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:03'!
array
	^ array! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:37'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.
	self fullCheck.! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:42'!
do: unaryBlock
	tally = 0 ifFalse: [array do: [:element | element isNil ifFalse: [unaryBlock value: element]]]! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 17:19'!
findElementOrNil: anObject
	"Answer the index of a first slot containing either a nil (indicating an empty slot) or an element that matches the given object. Answer the index of that slot or zero. Fail if neither a match nor an empty slot is found."

	| index |

	index := self scanFor: anObject.
	index > 0 ifTrue: [^index].

	"Bad scene.  Neither have we found a matching element
	nor even an empty slot.  No hashed set is ever supposed to get
	completely full."
	self error: 'There is no free space in this set!!'.! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 12:06'!
fixCollisionsFrom: index
	"The element at index has been removed and replaced by nil.
	This method moves forward from there, relocating any entries
	that had been placed below due to collisions with this one"
	| length oldIndex newIndex element |
	oldIndex := index.
	length := array size.
	[oldIndex = length
		ifTrue: [oldIndex := 1]
		ifFalse: [oldIndex := oldIndex + 1].
	(element := self keyAt: oldIndex) isNil]
		whileFalse: 
			[newIndex := self findElementOrNil: element.
			oldIndex = newIndex ifFalse: [self swap: oldIndex with: newIndex]].! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:38'!
fullCheck
	"Keep array at least 1/4 free for decent hash behaviour."
	(array size - tally) < (1 max: (array size // 4)) ifTrue: [self grow]! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 17:40'!
grow
	"Grow the elements array and reinsert the old elements."
	| oldElements oldSize |
	oldElements := array.
	oldSize := array size.
	array := NXTArray new: oldSize + self growSize.
	tally := 0.
	oldElements do: [:element | element isNil ifFalse: [self noCheckAdd: element]]! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:38'!
growSize
	^ array size! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:34'!
initialize: size
	tally := 0.
	array := NXTArray new: size.! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 12/15/2008 10:54'!
isSet
	^ true! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:41'!
keyAt: index
	"May be overridden by subclasses so that fixCollisions will work"
	^ array at: index! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:43'!
like: anObject
	| index |
	index := self scanFor: anObject.
	^index < 1 ifFalse: [array at: index]! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:39'!
noCheckAdd: anObject
	array at: (self findElementOrNil: anObject) put: anObject.
	tally := tally + 1.! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 10:29'!
remove: oldObject ifAbsent: aBlock
	| index |
	index := self findElementOrNil: oldObject.
	(array at: index) isNil ifTrue: [^aBlock value].
	array at: index put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: index.
	^oldObject! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:37'!
scanFor: anObject
	"Scan the array for the first slot containing either a nil
	(indicating an empty slot) or an element that matches anObject.
	Answer the index of that slot or 0 if no slot is found.  This
	method will be overridden in various subtypes that have
	different interpretations for matching elements. "
	| finish start |
	finish := array size.
	start := anObject hash \\ finish + 1.
	"search from (hash mod size) to the end"
	start to: finish do: [:index |
		| element |
		((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^index]].
	"search from start to (hash mod size)"
	1 to: start do: [:index |
		| element |
		((element := array at: index) isNil or: [element = anObject])
			ifTrue: [^index]].
	^0.	"no match AND no empty slot"! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:43'!
size
	^ tally! !

!NXTSet methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 14:41'!
swap: oneIndex with: otherIndex
	"May be overridden by subclasses so that fixCollisions will work"
	array swap: oneIndex with: otherIndex
! !

NXTSet subclass: #NXTWeakSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTWeakSet methodsFor: 'as yet unclassified' stamp: 'mab 10/28/2008 15:10'!
grow
	"Grow the elements array and reinsert the old elements."
	| oldElements oldSize |
	oldElements := array.
	oldSize := array size.
	array := NXTWeakArray new: oldSize + self growSize.
	tally := 0.
	oldElements do: [:element | element isNil ifFalse: [self noCheckAdd: element]]! !

!NXTWeakSet methodsFor: 'as yet unclassified' stamp: 'mab 10/28/2008 15:06'!
initialize: size
	tally := 0.
	array := NXTWeakArray new: size.! !

!NXTWeakSet methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 14:56'!
realSize
	| size |
	size := 0.
	array do: [ :each |
		each isNil ifFalse: [ size := size + 1]].
	^ size! !

!NXTWeakSet methodsFor: 'as yet unclassified' stamp: 'mab 10/28/2008 15:14'!
rehash
	"Reinsert the old elements into a new WeakArray."
	| oldElements |
	oldElements := array.
	array := NXTWeakArray new: array size.
	tally := 0.
	oldElements do: [:element | element isNil ifFalse: [self noCheckAdd: element]]! !

NXTObject subclass: #NXTDelay
	instanceVariableNames: 'delayDuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTDelay methodsFor: 'as yet unclassified' stamp: 'mab 12/17/2008 10:52'!
asDelay
	^ self! !

!NXTDelay methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 13:05'!
setDelay: milliseconds
	delayDuration := milliseconds.! !

!NXTDelay methodsFor: 'as yet unclassified' stamp: 'mab 12/28/2008 19:46'!
wait
	Processor activeProcess waitFor: (NXTEvent time: NXTTime millisecondClockValue + delayDuration).! !

NXTObject subclass: #NXTDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 2/9/2009 16:31'!
driveAhead
	self motorA speed: 75.
	self motorB speed: 75.! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 2/9/2009 16:31'!
driveBack
	self motorA
		speed: -75.
	self motorB
		speed: -75.! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 2/9/2009 16:31'!
run
	| radar |
	radar := NXTRadar port: 2.
	self driveAhead.
	[ self buttons enter isPressed ] whileFalse: [
		(radar isWithin: 40) ifTrue: [ self turnAround ].
		250 milliSeconds wait ].
	self stop.
	! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 2/9/2009 16:29'!
stop
	self motorA stop.
	self motorB stop.
! !

!NXTDemo methodsFor: 'as yet unclassified' stamp: 'mab 2/9/2009 16:30'!
turnAround
	self driveBack.
	(1000 + 100 atRandom) milliSeconds wait.
	self stop.
	2 * 3 atRandom = 1 
		ifTrue: [ self motorC speed: -75 ]
		ifFalse: [ self motorC speed: 75 ].
	(500 + 500 atRandom) milliSeconds wait.
	self driveAhead.! !

NXTObject subclass: #NXTDispatcher
	instanceVariableNames: 'dataStream localObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTDispatcher class methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 18:27'!
for: localObject on: dataStream
	^ self new
		localObject: localObject;
		dataStream: dataStream! !

!NXTDispatcher methodsFor: 'accessing' stamp: 'mab 11/14/2008 18:26'!
dataStream
	^ dataStream! !

!NXTDispatcher methodsFor: 'accessing' stamp: 'mab 11/14/2008 18:26'!
dataStream: anObject
	dataStream := anObject! !

!NXTDispatcher methodsFor: 'accessing' stamp: 'mab 11/14/2008 18:26'!
localObject
	^ localObject! !

!NXTDispatcher methodsFor: 'accessing' stamp: 'mab 11/14/2008 18:26'!
localObject: anObject
	localObject := anObject! !

!NXTDispatcher methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 18:51'!
receive
	| message |
	[
		message := self dataStream next.
		message isMessage ifFalse: [ self error: 'USB connection out of sync' ].
		('Got ', message selector, ' message') printNl.
		message selector = #exit ifTrue: [ ^ self return: #exited ].
		self return: (message sendTo: self localObject).
		'Answered' printNl.
	] doWhileTrue: [ true ].! !

!NXTDispatcher methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 18:52'!
return: value
	value = self localObject
		ifTrue: [ self dataStream nextPut: nil ]
		ifFalse: [ self dataStream nextPut: value ].
	self dataStream flush.
! !

NXTObject subclass: #NXTDisplay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 13:28'!
clear
	<NXTPrimitive: 35>! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:55'!
cursorToX: x Y: y
	<NXTPrimitive: 45>! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 9/19/2008 16:55'!
put: aString
	aString print.! !

!NXTDisplay methodsFor: 'as yet unclassified' stamp: 'mab 7/23/2008 16:25'!
scrolling: on
	<NXTPrimitive: 32>! !

NXTObject subclass: #NXTDriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 17:10'!
driveAhead
	self motorB 
		speed: 75.
	self motorC
		speed: 75.! !

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 15:05'!
driveBackwards
	self motorB 
		speed: -75.
	self motorC
		speed: -75.! !

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 15:05'!
left
	self motorB 
		speed: 75.
	self motorC
		speed: -75.! !

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 15:05'!
right
	self motorB 
		speed: -75.
	self motorC
		speed: 75.! !

!NXTDriver methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 17:11'!
stop
	self motorB stop.
	self motorC stop.
! !

NXTObject subclass: #NXTException
	instanceVariableNames: 'messageText signalContext handlerContext outerContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTException subclass: #NXTError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTError methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:40'!
defaultAction
	"No one has handled this error, but now give them a chance to decide how to debug it.  If none handle this either then open debugger (see UnhandedError-defaultAction)"

	NXTUnhandledError signalForException: self! !

!NXTError methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 19:18'!
isResumable
	"Determine whether an exception is resumable."

	^ false! !

NXTError subclass: #NXTMessageNotUnderstood
	instanceVariableNames: 'message receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMessageNotUnderstood methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 22:52'!
isResumable
	"Determine whether an exception is resumable."

	^true! !

!NXTMessageNotUnderstood methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:00'!
message
	^ message! !

!NXTMessageNotUnderstood methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:00'!
message: anObject
	message := anObject! !

!NXTMessageNotUnderstood methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 23:50'!
messageText
	"Return an exception's message text."

	^messageText ifNil: [ message isNil
				ifTrue: [super messageText]
				ifFalse: [message lookupClass name, '>>', message selector asString]]
! !

!NXTMessageNotUnderstood methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:01'!
receiver
	^ receiver! !

!NXTMessageNotUnderstood methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:01'!
receiver: anObject
	receiver := anObject! !

!NXTException class methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:32'!
handles: exception
	"Determine whether an exception handler will accept a signaled exception."
	^ exception isKindOf: self! !

!NXTException class methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:48'!
signal
	"Signal the occurrence of an exceptional condition."

	^ self new signal! !

!NXTException class methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 15:55'!
signal: text
	self new signal: text! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:05'!
defaultAction
	"The default action taken if the exception is signaled."

	self subclassResponsibility! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:16'!
description
	"Return a textual description of the exception."

	| desc mt |
	desc := self class name asString.
	^(mt := self messageText) == nil
		ifTrue: [desc]
		ifFalse: [desc, ': ', mt]! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:49'!
isResumable
	"Determine whether an exception is resumable."

	^ true! !

!NXTException methodsFor: 'accessing' stamp: 'mab 5/21/2008 18:21'!
messageText
	^ messageText! !

!NXTException methodsFor: 'accessing' stamp: 'mab 5/21/2008 18:21'!
messageText: anObject
	messageText := anObject! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 19:32'!
outer
	"Evaluate the enclosing exception action and return to here instead of signal if it resumes (see #resumeUnchecked:)."

	| prevOuterContext currentContext |
	currentContext := thisContext contextTag.
	self isResumable ifTrue: [
		prevOuterContext := outerContext.
		outerContext := currentContext.
	].
	self pass.
! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:52'!
pass
	"Yield control to the enclosing exception action for the receiver."

	handlerContext nextHandlerContext handleSignal: self! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 16:54'!
privHandlerContext: aContextTag

	handlerContext := aContextTag! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:39'!
resume
	"Return from the message that signaled the receiver."

	self resume: nil! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:49'!
resume: resumptionValue
	"Return resumptionValue as the value of the signal message."

	self isResumable ifFalse: [NXTIllegalResumeAttempt signal].
	self resumeUnchecked: resumptionValue! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:04'!
resumeUnchecked: resumptionValue
	"Return resumptionValue as the value of #signal, unless this was called after an #outer message, then return resumptionValue as the value of #outer."

	| ctxt |
	outerContext ifNil: [
		signalContext return: resumptionValue
	] ifNotNil: [
		ctxt := outerContext.
		outerContext := ctxt tempAt: 1. "prevOuterContext in #outer"
		ctxt return: resumptionValue
	].
! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:26'!
return
	"Return nil as the value of the block protected by the active exception handler."

	self return: nil! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:26'!
return: returnValue
	"Return the argument as the value of the block protected by the active exception handler."

	handlerContext return: returnValue! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 16:50'!
signal
	"Ask ContextHandlers in the sender chain to handle this signal.  The default is to execute and return my defaultAction."
	signalContext := thisContext contextTag.
	^ thisContext nextHandlerContext handleSignal: self! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:14'!
signal: text
	self messageText: text.
	self signal! !

!NXTException methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:15'!
signalerContext
	"Find the first sender of signal(:)"

	^ signalContext findContextSuchThat: [:ctxt |
		(ctxt receiver == self or: [ctxt receiver == self class]) not]! !

NXTException subclass: #NXTIllegalResumeAttempt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTIllegalResumeAttempt methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:40'!
defaultAction
	"No one has handled this error, but now give them a chance to decide how to debug it.  If none handle this either then open debugger (see UnhandedError-defaultAction)"

	NXTUnhandledError signalForException: self! !

!NXTIllegalResumeAttempt methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:40'!
isResumable
	
	^ false! !

NXTException subclass: #NXTNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTNotification methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 19:19'!
defaultAction
	"No action is taken. The value nil is returned as the value of the message that signaled the exception."

	^nil! !

!NXTNotification methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 19:19'!
isResumable
	"Answer true. Notification exceptions by default are specified to be resumable."

	^true! !

NXTException subclass: #NXTTestFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

NXTException subclass: #NXTUnhandledError
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTUnhandledError class methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:06'!
signalForException: anError

	^ self new
		exception: anError;
		signal! !

!NXTUnhandledError methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 18:50'!
defaultAction
	(exception signalerContext stackOfSize: 10) do: [ :each |
		each printNl ].
	'Unhandled Exception: ' print.
	exception description printNl.
	NXTButton waitForAnyKey.
	self environment shutdown.! !

!NXTUnhandledError methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:06'!
exception

	^ exception! !

!NXTUnhandledError methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:06'!
exception: anError

	exception := anError! !

!NXTUnhandledError methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:07'!
isResumable
	
	^ false! !

NXTObject subclass: #NXTFrame
	instanceVariableNames: 'context pc stackPointer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTFrame variableSubclass: #NXTBlockFrame
	instanceVariableNames: 'block home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
catchNonLocalReturns
	"Evaluate the receiver and catch non local returns, Even if target frame has been left (VM support)."
	^ self onNonLocalReturnsDo: [ :return | return ]! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
doWhileFalse: conditionBlock
	"Evaluate the receiver once, then again as long the value of conditionBlock is false."
 
	| result |
	[result := self value.
	conditionBlock value] whileFalse.

	^ result! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
doWhileTrue: conditionBlock
	"Evaluate the receiver once, then again as long the value of conditionBlock is true."
 
	| result |
	[result := self value.
	conditionBlock value] whileTrue.

	^ result! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
ensure: aBlock
	"Evaluate a termination block after evaluating the receiver, regardless of whether the receiver's evaluation completes."

	| returnValue b ctx |
	returnValue := self value.
	"aBlock wasn't nil when execution of this method began; it is nil'd out by the unwind machinery, and that's how we know it's already been evaluated ... otherwise, obviously, it needs to be evaluated"
	ctx := thisContext.
	aBlock == nil ifFalse: [
		"nil out aBlock temp before evaluating aBlock so it is not executed again if aBlock remote returns"
		b := aBlock.
		ctx argumentAt: 1 put: nil.  "aBlock _ nil"
		b value.
	].
	^ returnValue! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
fork
	^ NXTProcess forContext: self.! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
home
	^ home! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
isBlock
	^ true! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
methodClass
	^ self home methodClass! !

!NXTBlockFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:57'!
numArgs
	^ block numArgs! !

!NXTBlockFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:57'!
numTemps
	^ block numTemps! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
on: exception do: handlerAction
	"Evaluate the receiver in the scope of an exception handler."
	| handlerActive |
	handlerActive := true.
	^self value! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
onNonLocalReturnsDo: handler
	"Evaluate the receiver and catch non local returns, Even if target frame has been left (VM support)."
	^ self value! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
printNl
	'[] in ' print.
	self home printNl.! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
receiver
	^ home receiver! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
repeat
	"Evaluate the receiver repeatedly, ending only if the block explicitly returns."

	[self value. true] whileTrue! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
restart
	<NXTPrimitive: 5>
	self restart! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
value
	<NXTPrimitive: 2>! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
value: aValue
	<NXTPrimitive: 2>! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
value: aValue1 value: aValue2
	<NXTPrimitive: 2>! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
whileFalse
	^ self whileFalse: []! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
whileFalse: aBlock
	self value ifTrue: [ ^ nil ].
	aBlock value.
	self restart.! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
whileTrue
	^ self whileTrue: []! !

!NXTBlockFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:57'!
whileTrue: aBlock
	self value ifFalse: [ ^ nil ].
	aBlock value.
	self restart.! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/19/2009 14:04'!
argumentAt: index
	^ self at: 5 + index! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/19/2009 14:04'!
argumentAt: index put: value
	^ self at: 5 + index put: value! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:15'!
findContextSuchThat: testBlock
	"Search self and my sender chain for first one that satisfies testBlock.  Return nil if none satisfy"

	| ctxt |
	ctxt := self.
	[ctxt isNil] whileFalse: [
		(testBlock value: ctxt) ifTrue: [^ ctxt].
		ctxt := ctxt sender.
	].
	^ nil! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 16:49'!
findNextHandlerContextStarting
	"Return the next handler marked context, returning nil if there is none.  Search starts with self and proceeds up to nil."
	| ctx |
	ctx := self.
		[ctx isHandlerContext ifTrue:[^ctx].
		(ctx := ctx sender) == nil ] whileFalse.
	^nil! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 20:41'!
findNextUnwindContextUpTo: aContext
	"Return the next unwind marked above the receiver, returning nil if there is none.  Search proceeds up to but not including aContext."

	| ctx |
	ctx := self.
		[(ctx := ctx sender) == nil or: [ctx == aContext]] whileFalse:
		[ ctx isUnwindContext ifTrue: [^ctx]].
	^nil! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 21:31'!
handleSignal: exception
	"Sent to handler (on:do:) contexts only.  If my exception class (first arg) handles exception then execute my handle block (second arg), otherwise forward this message to the next handler context.  If none left, execute exception's defaultAction (see nil>>handleSignal:)."
	| val |
	(((self argumentAt: 1) handles: exception) and: [self tempAt: 1]) ifFalse: [
		^ self nextHandlerContext handleSignal: exception].
	
	exception privHandlerContext: self contextTag.
	"Disable myself while executing exception handler"
	self tempAt: 1 put: false.
	val := [ (self argumentAt: 2) value: exception ]
		ensure: [ self tempAt: 1 put: true ].
	self return: val.  "return from self if not otherwise directed in handle block"! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:55'!
hasSender: aContext
	"Answer whether the receiver is strictly above context on the stack."

	| s |
	self == aContext ifTrue: [^false].
	s := self sender.
	[s == nil]
		whileFalse: 
			[s == aContext ifTrue: [^true].
			s := s sender].
	^false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 8/21/2008 15:45'!
isBlock
	^ false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 20:49'!
isDead
	"Has self finished"

	^ pc isNil! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 13:28'!
isEscapedFromStack
	^ self environment isNil not! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 16:51'!
isHandlerContext
	^ false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 8/21/2008 15:45'!
isMethod
	^ false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 19:13'!
isUnwindContext
	^ false! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 16:48'!
nextHandlerContext
	^ self sender findNextHandlerContextStarting! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 10/4/2008 19:23'!
printNl
	| selector class mclass |
	"self method == nil ifTrue: [^ super printOn: aStream]."
	class := self receiver class.
	mclass := self methodClass.
	selector := self selector ifNil:[self method defaultSelector].
	class name asString print.
	mclass == class 
		ifFalse: 
			['(' print.
			mclass name asString print.
			')' print].
	'>>' print.
	selector print.
	selector = #doesNotUnderstand: ifTrue: [
		' ' print.
		(self argumentAt: 1) selector print.
	].
	NXTString cr print.! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 20:55'!
resume: value
	"Unwind thisContext to self and resume with value as result of last send.  Execute unwind blocks when unwinding.  ASSUMES self is a sender of thisContext"

	| ctxt unwindBlock |
	self isDead ifTrue: [self cannotReturn: value to: self].
	ctxt := thisContext.
	[	ctxt := ctxt findNextUnwindContextUpTo: self.
		ctxt isNil
	] whileFalse: [
		unwindBlock := ctxt tempAt: 1.
		unwindBlock ifNotNil: [
			ctxt argumentAt: 1 put: nil.
			thisContext terminateTo: ctxt.
			unwindBlock value].
	].
	thisContext terminateTo: self.
	^ value
! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:43'!
return: value
	"Unwind thisContext to self and return value to self's sender.  Execute any unwind blocks while unwinding.  ASSUMES self is a sender of thisContext"

	"context ifNil: [self cannotReturn: value to: sender]."
	self sender resume: value! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 16:48'!
sender
	^ context! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:52'!
stackOfSize: limit 
	"Answer an OrderedCollection of the top 'limit' contexts
		on the receiver's sender chain."

	| a stack |
	stack := NXTOrderedCollection new.
	stack addFirst: (a := self).
	[(a := a sender) ~~ nil and: [stack size < limit]]
		whileTrue: [ stack addFirst: a].
	^ stack! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 15:49'!
stackPointer
	^ stackPointer! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 16:23'!
stackStart
	^ stackPointer - self numArgs! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/19/2009 14:04'!
tempAt: index
	^ self at: (5 + self numArgs + index)! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/19/2009 14:05'!
tempAt: index put: value
	^ self at: (5 + self numArgs + index) put: value! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:52'!
terminate
	"Make myself unresumable."
	context := nil.
	pc := nil.
! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 18:52'!
terminateTo: previousContext
	"Terminate all the Contexts between me and previousContext, if previousContext is on my Context stack. Make previousContext my sender."

	| currentContext sendingContext |
	(self hasSender: previousContext) ifTrue: [
		currentContext := context.
		[currentContext == previousContext] whileFalse: [
			sendingContext := currentContext sender.
			currentContext terminate.
			currentContext := sendingContext]].
	context := previousContext! !

!NXTFrame methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 20:47'!
unwindTo: aContext

	| ctx unwindBlock |
	ctx := self.
	[(ctx := ctx findNextUnwindContextUpTo: aContext) isNil] whileFalse: [
		unwindBlock := ctx tempAt: 1.
		unwindBlock == nil ifFalse: [
			ctx tempAt: 1 put: nil.
			unwindBlock value]
	].
! !

NXTFrame variableSubclass: #NXTMethodFrame
	instanceVariableNames: 'method receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:58'!
contextTag
	"Context tags may be used for referring to contexts instead of contexts themselves as they can be copied and will continue to work in other processes (continuations). By default, we use the context itself to as its tag."
	^self! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:58'!
isHandlerContext
	^ self selector = #on:do: and: [ self owner = NXTBlockFrame ]! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:58'!
isMethod
	^ true! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:58'!
isUnwindContext
	^ self selector = #ensure: and: [ self owner = NXTBlockFrame ]! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:58'!
method
	^ method! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:58'!
methodClass
	^ method methodClass! !

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
numArgs
	^ method numArgs! !

!NXTMethodFrame methodsFor: 'accessing' stamp: 'mab 1/12/2009 15:58'!
numTemps
	^ method numTemps! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:58'!
owner
	^ method methodClass! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:58'!
receiver
	^ receiver! !

!NXTMethodFrame methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 15:58'!
selector
	^ method selector! !

NXTObject subclass: #NXTLineFollower
	instanceVariableNames: 'sweep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-LineFollower'!

!NXTLineFollower class methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 12:39'!
driveIntensity
	^ 55! !

!NXTLineFollower class methodsFor: 'as yet unclassified' stamp: 'mab 12/8/2008 09:01'!
lightSensorPort
	^ 3! !

!NXTLineFollower class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 10:58'!
motorPower
	^ 75! !

!NXTLineFollower class methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 12:39'!
searchIntensity
	^ 45! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 12/8/2008 08:37'!
adjustSweep
	self sweep: self sweep * 2.! !

!NXTLineFollower methodsFor: 'motor control' stamp: 'mab 1/4/2009 10:59'!
driveAhead
	self motorB speed: self class motorPower.
	self motorC speed: self class motorPower.! !

!NXTLineFollower methodsFor: 'motor control' stamp: 'mab 1/4/2009 10:45'!
driveStraightAheadOnLine
	self driveAhead.
	self lightSensor waitUntilLighterThan: self class driveIntensity.
	self stop.! !

!NXTLineFollower methodsFor: 'executing' stamp: 'mab 1/4/2009 12:50'!
exit
	self stop.! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 1/4/2009 13:35'!
findLine
	self reset.
	[ self adjustSweep.
	self tryLeft ifTrue: [ ^ self ].
	self adjustSweep.
	self tryRight ifTrue: [ ^ self ]] repeat.! !

!NXTLineFollower methodsFor: 'initialize-release' stamp: 'mab 1/4/2009 12:50'!
initialize
	self lightSensor: NXTLightSensor new.! !

!NXTLineFollower methodsFor: 'accessing' stamp: 'mab 12/8/2008 09:01'!
lightSensor
	^ self environment sensorAt: self class lightSensorPort! !

!NXTLineFollower methodsFor: 'accessing' stamp: 'mab 12/8/2008 09:03'!
lightSensor: anObject
	^ self environment sensorAt: self class lightSensorPort put: anObject! !

!NXTLineFollower methodsFor: 'initialize-release' stamp: 'mab 12/8/2008 08:35'!
reset
	self sweep: 2.! !

!NXTLineFollower methodsFor: 'executing' stamp: 'mab 1/4/2009 17:17'!
run
	2 seconds asDelay wait.
	"self buttons exit onPressedDo: [ ^ self exit ]."
	20 timesRepeat: [ self reset.
	self findLine.
	self driveStraightAheadOnLine ].
	'Huhu' printNl.! !

!NXTLineFollower methodsFor: 'motor control' stamp: 'mab 12/8/2008 09:29'!
stop
	self motorB stop.
	self motorC stop.! !

!NXTLineFollower methodsFor: 'accessing' stamp: 'mab 12/8/2008 08:35'!
sweep
	^ sweep! !

!NXTLineFollower methodsFor: 'accessing' stamp: 'mab 12/8/2008 08:35'!
sweep: anObject
	sweep := anObject! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 1/4/2009 16:29'!
tryForward: aMotor backward: anotherMotor
	| handler |
	handler := self lightSensor onDarkerThan: self class searchIntensity do: [ self stop. ^ true ].
	anotherMotor speed: self class motorPower negated.
	aMotor speed: self class motorPower.
	aMotor rotationSensor waitDegrees: self sweep.
	handler terminate.
	self stop.
	^ false! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 1/4/2009 12:48'!
tryLeft
	^ self tryForward: self motorB backward: self motorC! !

!NXTLineFollower methodsFor: 'line finding' stamp: 'mab 1/4/2009 12:48'!
tryRight
	^self tryForward: self motorC backward: self motorB! !

NXTObject subclass: #NXTLineFollower2
	instanceVariableNames: 'sweep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-LineFollower'!

!NXTLineFollower2 class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
driveIntensity
	^ 55! !

!NXTLineFollower2 class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
lightSensorPort
	^ 3! !

!NXTLineFollower2 class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 17:17'!
motorPower
	^ 75! !

!NXTLineFollower2 class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
searchIntensity
	^ 45! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 13:39'!
adjustSweep
	self sweep: self sweep * 2.! !

!NXTLineFollower2 methodsFor: 'motor control' stamp: 'mab 1/4/2009 13:39'!
driveAhead
	self motorB speed: self class motorPower.
	self motorC speed: self class motorPower.! !

!NXTLineFollower2 methodsFor: 'motor control' stamp: 'mab 1/4/2009 13:40'!
driveStraightAheadOnLine
	self driveAhead.
	[ self lightSensor intensity < self class driveIntensity ] whileTrue.
	self stop.! !

!NXTLineFollower2 methodsFor: 'executing' stamp: 'mab 1/4/2009 13:39'!
exit
	self stop.! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 15:48'!
findLine
	self reset.
	[ self adjustSweep.
	self tryLeft ifTrue: [ ^ self ].
	self adjustSweep.
	self tryRight ifTrue: [ ^ self ]] repeat.! !

!NXTLineFollower2 methodsFor: 'initialize-release' stamp: 'mab 1/4/2009 13:39'!
initialize
	self lightSensor: NXTLightSensor new.! !

!NXTLineFollower2 methodsFor: 'accessing' stamp: 'mab 1/4/2009 13:39'!
lightSensor
	^ self environment sensorAt: self class lightSensorPort! !

!NXTLineFollower2 methodsFor: 'accessing' stamp: 'mab 1/4/2009 13:39'!
lightSensor: anObject
	^ self environment sensorAt: self class lightSensorPort put: anObject! !

!NXTLineFollower2 methodsFor: 'initialize-release' stamp: 'mab 1/4/2009 13:39'!
reset
	self sweep: 2.! !

!NXTLineFollower2 methodsFor: 'executing' stamp: 'mab 1/4/2009 16:28'!
run
	| end |
	2 seconds asDelay wait.
	end := NXTTimer now + 60.
	[ self reset.
	self findLine.
	self driveStraightAheadOnLine.
	NXTTimer now >= end ifTrue: [ ^ self ]] repeat.! !

!NXTLineFollower2 methodsFor: 'motor control' stamp: 'mab 1/4/2009 13:39'!
stop
	self motorB stop.
	self motorC stop.! !

!NXTLineFollower2 methodsFor: 'accessing' stamp: 'mab 1/4/2009 13:39'!
sweep
	^ sweep! !

!NXTLineFollower2 methodsFor: 'accessing' stamp: 'mab 1/4/2009 13:39'!
sweep: anObject
	sweep := anObject! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 15:48'!
tryForward: aMotor backward: anotherMotor
	anotherMotor speed: self class motorPower negated.
	aMotor speed: self class motorPower.
	aMotor rotationSensor reset.
	[ aMotor rotationSensor read < self sweep ] whileTrue: [
		self lightSensor intensity < self class searchIntensity ifTrue: [ self stop. ^ true ]].
	self stop.
	^ false! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 15:47'!
tryLeft
	^ self tryForward: self motorB backward: self motorC! !

!NXTLineFollower2 methodsFor: 'line finding' stamp: 'mab 1/4/2009 15:47'!
tryRight
	^self tryForward: self motorC backward: self motorB! !

NXTObject subclass: #NXTLink
	instanceVariableNames: 'nextLink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

NXTLink subclass: #NXTEvent
	instanceVariableNames: 'type value condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTEvent class methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 15:06'!
button
	^ 1! !

!NXTEvent class methodsFor: 'types' stamp: 'mab 12/31/2008 15:07'!
button: buttonNumber
	^ self new
		type: self button
		value: buttonNumber! !

!NXTEvent class methodsFor: 'conditions' stamp: 'mab 1/4/2009 12:24'!
forRotationSensor: aNumber
	^ self new type: 6 + aNumber! !

!NXTEvent class methodsFor: 'conditions' stamp: 'mab 12/31/2008 15:47'!
forSensor: aNumber
	^ self new type: 1 + aNumber! !

!NXTEvent class methodsFor: 'conditions' stamp: 'mab 12/28/2008 19:36'!
greaterThan
	^ 0! !

!NXTEvent class methodsFor: 'conditions' stamp: 'mab 12/31/2008 15:35'!
lessThan
	^ 1! !

!NXTEvent class methodsFor: 'types' stamp: 'mab 12/28/2008 19:36'!
time
	^ 0! !

!NXTEvent class methodsFor: 'types' stamp: 'mab 12/28/2008 19:41'!
time: clockValue
	^ self new
		type: self time
		value: clockValue
		condition: self greaterThan! !

!NXTEvent methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 15:49'!
condition: aCondition
	condition := aCondition! !

!NXTEvent methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 15:47'!
type: aType
	type := aType.! !

!NXTEvent methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 15:07'!
type: aType value: aValue
	self type: aType value: aValue condition: nil
! !

!NXTEvent methodsFor: 'as yet unclassified' stamp: 'mab 12/28/2008 19:40'!
type: aType value: aValue condition: aCondition
	type := aType.
	value := aValue.
	condition := aCondition.! !

!NXTEvent methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 15:47'!
value: aValue
	value := aValue.! !

!NXTLink class methodsFor: 'instance creation' stamp: 'mab 9/15/2008 17:36'!
nextLink: aLink 
	"Answer an instance of me referring to the argument, aLink."

	^self new nextLink: aLink; yourself! !

!NXTLink methodsFor: 'accessing' stamp: 'mab 9/15/2008 17:36'!
nextLink
	"Answer the link to which the receiver points."

	^nextLink! !

!NXTLink methodsFor: 'accessing' stamp: 'mab 9/15/2008 17:36'!
nextLink: aLink 
	"Store the argument, aLink, as the link to which the receiver refers. 
	Answer aLink."

	^nextLink := aLink! !

NXTLink subclass: #NXTProcess
	instanceVariableNames: 'currentFrame stack stackTopIndex waitsFor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTProcess class methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 09:59'!
forContext: aContext
	| newProcess |
	newProcess := self new.
	newProcess currentFrame: aContext.
	Processor resumeProcess: newProcess.
	^ newProcess! !

!NXTProcess class methodsFor: 'as yet unclassified' stamp: 'mab 9/22/2008 15:10'!
stackSize
	^ 500! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 14:07'!
checkEvents
	| event |
	event := self waitsFor.
	[ event isNil ] whileFalse: [
		event checkConditions ifTrue: [ 'Yes' printNl. NXTButton waitForAnyKey ].
		event := event nextLink ].! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 18:23'!
currentFrame
	^ currentFrame! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 18:23'!
currentFrame: aContext
	currentFrame := aContext! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 9/22/2008 15:12'!
initialize
	stackTopIndex := -1.
	stack := NXTArray new: self class stackSize.! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 10:04'!
insertFrame: aFrame before: otherFrame
	<NXTPrimitive: 67>! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 9/15/2008 11:48'!
isRunnable
	^ self currentFrame isNil not! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 12/28/2008 19:10'!
isWaiting
	^ self waitsFor isNil not! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 10:07'!
resume
	Processor resumeProcess: self.! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 20:26'!
return: value from: frame
	"Returns from the given frame. ASSUMES that frame is a sender of currentFrame"
	"Processor activeProcess == self ifTrue: [ self error: 'Not possible' ].
	stackTopIndex := frame stackStart + 1.
	stackTopIndex printNl.
	currentFrame := frame sender.
	self stack at: stackTopIndex + 1 put: 42."
	<NXTPrimitive: 67>! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 9/3/2008 18:11'!
stack
	^ stack! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 09:49'!
suspend
	Processor suspendProcess: self.! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 16:35'!
terminate
	Processor activeProcess = self ifTrue: [ self error: 'Not allowed' ].
	Processor withoutScheduling: [
		self currentFrame: nil ].! !

!NXTProcess methodsFor: 'as yet unclassified' stamp: 'mab 12/30/2008 12:28'!
waitFor: anEvent
	self waitsFor: anEvent.
	Processor addWaitingProcess: self.! !

!NXTProcess methodsFor: 'accessing' stamp: 'mab 12/28/2008 19:10'!
waitsFor
	^ waitsFor! !

!NXTProcess methodsFor: 'accessing' stamp: 'mab 12/28/2008 19:10'!
waitsFor: anObject
	waitsFor := anObject! !

NXTObject subclass: #NXTLookupKey
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTLookupKey commentStamp: 'mab 8/15/2008 15:10' prior: 0!
Methods taken from Ian Piumarta's idST (object/st80/LookupKey.st).!

NXTLookupKey subclass: #NXTAssociation
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Collections'!

!NXTAssociation commentStamp: 'mab 8/15/2008 15:35' prior: 0!
Methods taken from Ian Piumarta's idST (object/st80/Association.st).!

!NXTAssociation class methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:00'!
key: value
	^ self key: value value: nil! !

!NXTAssociation class methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:48'!
key: aKey value: anObject
	^(super withKey: aKey) value: anObject; yourself! !

!NXTAssociation methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:37'!
= anAssociation
	^super = anAssociation and: [value = anAssociation value]! !

!NXTAssociation methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:37'!
hash
	^key hash bitXor: value hash! !

!NXTAssociation methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:36'!
value
	^value! !

!NXTAssociation methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:36'!
value: anObject
	value := anObject! !

!NXTLookupKey class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:12'!
withKey: aKey
	^self new key: aKey; yourself! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:13'!
< aLookupKey
	^key < aLookupKey key! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 10:02'!
= aLookupKey
	self species = aLookupKey species
		ifTrue: [^key = aLookupKey key]
		ifFalse: [^false]! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:14'!
hash
	^key hash! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:10'!
isLookupKey
	^ true! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:13'!
key
	^key! !

!NXTLookupKey methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 15:36'!
key: anObject
	key := anObject! !

NXTObject subclass: #NXTMessage
	instanceVariableNames: 'selector arguments lookupClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMessage class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 13:16'!
selector: aSymbol
	^ self selector: aSymbol arguments: NXTArray new! !

!NXTMessage class methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 13:17'!
selector: aSymbol arguments: anArray 
	"Answer an instance of me with selector, aSymbol, and arguments, 
	anArray."

	^self new selector: aSymbol arguments: anArray! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 11:49'!
arguments
	^ arguments! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 11:49'!
isMessage
	^ true! !

!NXTMessage methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:49'!
lookupClass
	^ lookupClass! !

!NXTMessage methodsFor: 'accessing' stamp: 'mab 10/3/2008 23:49'!
lookupClass: anObject
	lookupClass := anObject! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 11:49'!
selector
	^ selector! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 11:49'!
selector: aSelector arguments: args
	selector := aSelector.
	arguments := args.! !

!NXTMessage methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 18:28'!
sendTo: aReceiver
	^ self arguments
		ifNil: [ aReceiver perform: self selector ]
		ifNotNil: [ aReceiver perform: self selector withArguments: self arguments ]! !

NXTObject variableSubclass: #NXTMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTMethod variableSubclass: #NXTBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTMethod class methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 11:02'!
bytecodes: bytecodes literals: literals header: header
	| method |
	method := self newMethod: bytecodes size numLiterals: literals size.
	method header: header.
	literals doWithIndex: [ :each :index |
		method literalAt: index put: each ].
	bytecodes doWithIndex: [ :each :index |
		method at: index + method initialPC - 1 put: each ].
	^ method! !

!NXTMethod class methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 11:03'!
bytecodes: bytecodes literals: literals numTemps: numTemps numArgs: numArgs
	^ self 
		bytecodes: bytecodes 
		literals: literals 
		header: (self calcHeaderFor: literals size numTemps: numTemps numArgs: numArgs)! !

!NXTMethod class methodsFor: 'as yet unclassified' stamp: 'mab 9/17/2008 17:17'!
calcHeaderFor: numLiterals numTemps: numTemps numArgs: numArgs
	^ ((numArgs << 9) bitOr: (numLiterals << 3)) bitOr: numTemps! !

!NXTMethod class methodsFor: 'as yet unclassified' stamp: 'mab 9/17/2008 17:06'!
calcHeaderForPrimitive: numPrim numArgs: numArgs
	^ (numArgs << 9 bitOr: 1 << 8) bitOr: numPrim! !

!NXTMethod class methodsFor: 'nxt-exclude' stamp: 'mab 9/17/2008 10:54'!
elementSize
	^ 1! !

!NXTMethod class methodsFor: 'as yet unclassified' stamp: 'mab 9/17/2008 11:36'!
elementSizeForObjects
	^ Smalltalk isNXTalk ifTrue: [ 2 ] ifFalse: [ 1 ]! !

!NXTMethod class methodsFor: 'as yet unclassified' stamp: 'mab 9/17/2008 17:00'!
newMethod: numBytes numLiterals: numLiterals
	^ super basicNew: self elementSizeForObjects * (1 + numLiterals) + numBytes
	! !

!NXTMethod class methodsFor: 'as yet unclassified' stamp: 'mab 9/17/2008 14:28'!
primitive: primNum numArgs: numArgs
	| method |
	method := self newMethod: 0 numLiterals: 0.
	method header: (self calcHeaderForPrimitive: primNum numArgs: numArgs).
	^ method! !

!NXTMethod methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 11:11'!
bytecodes
	^ (NXTArray new: self numBytecodes) 
		replaceFrom: 1 
		to: self numBytecodes 
		with: self 
		startingAt: self initialPC! !

!NXTMethod methodsFor: 'nxt-exclude' stamp: 'mab 11/20/2008 10:54'!
computeSize
	^  (1 + self numLiterals) * 2 + self numBytecodes! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 14:32'!
endPC
	^ self size! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 9/17/2008 10:53'!
header
	"Answer the word containing the information about the form of the 
	receiver and the form of the context needed to run the receiver."

	^self objectAt: 1! !

!NXTMethod methodsFor: 'as yet unclassified' stamp: 'mab 9/17/2008 11:15'!
header: value
	^ self objectAt: 1 put: value! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 11:38'!
initialPC
	"Answer the program counter for the receiver's first bytecode."

	^ (self numLiterals + 1) * self class elementSizeForObjects + 1! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 9/17/2008 10:53'!
literalAt: index 
	"Answer the literal indexed by the argument."

	^self objectAt: index + 1! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 9/17/2008 10:53'!
literalAt: index put: value 
	"Replace the literal indexed by the first argument with the second 
	argument. Answer the second argument."

	^self objectAt: index + 1 put: value! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 11/17/2008 19:13'!
literals
	"Answer an Array of the literals referenced by the receiver."
	| literals numberLiterals |
	literals := NXTArray new: (numberLiterals := self numLiterals).
	1 to: numberLiterals do: [ :index |
		literals at: index put: (self literalAt: index) ].
	^ literals! !

!NXTMethod methodsFor: 'as yet unclassified' stamp: 'mab 11/6/2008 02:51'!
methodClass
	"answer the class that I am installed in"
	^ self literalAt: self numLiterals! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 10:53'!
numArgs
	"Answer the number of arguments the receiver takes."
	
	^ (self header bitShift: -9) bitAnd: 16r03! !

!NXTMethod methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 10:48'!
numBytecodes
	^ self endPC - self initialPC + 1! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 9/17/2008 17:09'!
numLiterals
	"Answer the number of literals used by the receiver."
	self primitive ifNotNil: [ ^ 0 ].
	^ (self header bitShift: -3) bitAnd: 16r1F! !

!NXTMethod methodsFor: 'accessing' stamp: 'mab 11/6/2008 00:13'!
numTemps
	"Answer the number of temporaries the receiver takes."
	
	^ self header bitAnd: 16r07! !

!NXTMethod methodsFor: 'as yet unclassified' stamp: 'mab 9/17/2008 10:55'!
objectAt: index 
	<NXTPrimitive: 49>
	^ self at: index! !

!NXTMethod methodsFor: 'literals' stamp: 'mab 9/17/2008 10:55'!
objectAt: index put: value 
	<NXTPrimitive: 50>
	^ self at: index put: value! !

!NXTMethod methodsFor: 'as yet unclassified' stamp: 'mab 9/17/2008 14:24'!
primitive
	(self header >> 8 bitAnd: 16r01) = 0 ifTrue: [ ^ nil ].
	^ self header bitAnd: 16rFF! !

!NXTMethod methodsFor: 'nxt-exclude' stamp: 'mab 11/17/2008 18:47'!
referencesDo: aBlock
	self literals do: [ :literal |
		aBlock value: literal ].! !

!NXTMethod methodsFor: 'nxt-exclude' stamp: 'mab 11/18/2008 10:06'!
referencesReplace: aBlock
	1 to: self numLiterals do: [ :index |
		self literalAt: index put: (aBlock value: (self literalAt: index)) ].! !

!NXTMethod methodsFor: 'as yet unclassified' stamp: 'mab 11/9/2008 15:40'!
selector
	^ self literalAt: self numLiterals - 1.! !

!NXTMethod methodsFor: 'nxt-exclude' stamp: 'mab 11/24/2008 12:12'!
writeDataOn: aByteStream withImage: image
	self header writeAsReferenceOn: aByteStream within: image..
	self primitive isNil ifTrue: [
		1 to: self numLiterals do: [ :literalIndex |
			(self literalAt: literalIndex) asNXTObject 
				writeAsReferenceOn: aByteStream within: image ].
		self initialPC to: self endPC do: [ :bytecodeIndex | aByteStream 
			nextPut: (self at: bytecodeIndex) ]].! !

NXTObject subclass: #NXTMotor
	instanceVariableNames: 'number rotationSensor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:09'!
all
	^ NXTArray 
		with: (self number: 0)
		with: (self number: 1)
		with: (self number: 2)! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:55'!
number: number
	^ self new
		number: number! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 11:53'!
resetTachoCountFor: motorNumber
	<NXTPrimitive: 68>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:56'!
rotate: aNumber at: aSpeed
	<NXTPrimitive: 1>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 16:49'!
rotate: aMotorNumber at: speed by: degrees brakingHard: hardBrake
	<NXTPrimitive: 9>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:40'!
rotate: aMotorNumber at: speed for: milliseconds brakingHard: hardBrake
	<NXTPrimitive: 55>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:24'!
stop: motorNumber brakingHard: hardBrake
	<NXTPrimitive: 54>! !

!NXTMotor class methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:48'!
tachoCountFor: motorNumber
	<NXTPrimitive: 56>! !

!NXTMotor methodsFor: 'accessing' stamp: 'mab 7/22/2008 17:55'!
number
	^ number! !

!NXTMotor methodsFor: 'accessing' stamp: 'mab 7/22/2008 17:55'!
number: anObject
	number := anObject! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:13'!
rotateAt: speed by: degrees
	self rotateAt: speed by: degrees brakingHard: false.! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:13'!
rotateAt: speed by: degrees brakingHard: hardBrake
	self class rotate: self number at: speed by: degrees brakingHard: hardBrake.! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 11:04'!
rotationSensor
	^ rotationSensor ifNil: [ rotationSensor := NXTRotationSensor port: self number ]! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:56'!
speed: aNumber
	self class rotate: self number at: aNumber! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 12:49'!
stop
	self stop: true.! !

!NXTMotor methodsFor: 'as yet unclassified' stamp: 'mab 11/10/2008 17:27'!
stop: hardBrake
	self class stop: self number brakingHard: hardBrake.! !

NXTObject subclass: #NXTNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTNumber subclass: #NXTFloat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTNumber subclass: #NXTInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTInteger class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:55'!
new: length neg: neg
	"Answer an instance of a large integer whose size is length. neg is a flag 
	determining whether the integer is negative or not."

	neg 
		ifTrue: [^NXTLargeNegativeInteger new: length]
		ifFalse: [^NXTLargePositiveInteger new: length]! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:07'!
<= other
	^ self < other or: [ self = other ]! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:07'!
> other
	^ (self <= other) not! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:07'!
>= other
	^ (self < other) not! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 10/8/2008 18:32'!
benchFib  "Handy send-heavy benchmark"
	"(result // seconds to run) = approx calls per second"
	" | r t |
	  t _ Time millisecondsToRun: [r _ 26 benchFib].
	  (r * 1000) // t"
	"138000 on a Mac 8100/100"
	<nomacros>
	^ self < 2
		ifTrue: [1] 
		ifFalse: [(self-1) benchFib + (self-2) benchFib + 1]
! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 10/8/2008 18:32'!
benchmark  "Handy bytecode-heavy benchmark"
	"(500000 // time to run) = approx bytecodes per second"
	"5000000 // (Time millisecondsToRun: [10 benchmark]) * 1000"
	"3059000 on a Mac 8100/100"
 	<nomacros>   
	| size flags prime k count |
    size := 8190.
    1 to: self do:
        [:iter |
        count := 0.
		flags := nil.
        flags := (NXTArray new: size) atAllPut: true.
        1 to: size do:
            [:i | (flags at: i) ifTrue:
                [prime := i+1.
                k := i + prime.
                [k <= size] whileTrue:
                    [flags at: k put: false.
                    k := k + prime].
                count := count + 1]]].
    ^ count! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:44'!
isInteger
	"True for all subclasses of Integer."

	^ true! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 13:32'!
milliSeconds
	^ NXTDelay new setDelay: self! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 15:46'!
min: aMagnitude 
	"Answer the receiver or the argument, whichever has the lesser 
	magnitude."

	self < aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 13:08'!
seconds
	^ NXTDelay new setDelay: self * 1000! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:17'!
timesRepeat: aBlock
	| todo |
	todo := self.
	[ todo > 0 ] whileTrue: [ todo := todo - 1. aBlock value ].! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 14:07'!
tinyBenchmarks
	"Report the results of running the two tiny Squeak benchmarks.
	ar 9/10/1999: Adjusted to run at least 1 sec to get more stable results"
	"0 tinyBenchmarks"
	"On a 292 MHz G3 Mac: 22727272 bytecodes/sec; 984169 sends/sec"
	"On a 400 MHz PII/Win98:  18028169 bytecodes/sec; 1081272 sends/sec"
	| t1 t2 r n1 n2 |
	n1 := 1.
	[t1 := NXTTime millisecondsToRun: [n1 benchmark].
	t1 < 1000] whileTrue:[n1 := n1 * 2]. "Note: #benchmark's runtime is about O(n)"
	n2 := 28.
	[t2 := NXTTime millisecondsToRun: [r := n2 benchFib].
	t2 < 1000] whileTrue:[n2 := n2 + 1]. 
	"Note: #benchFib's runtime is about O(k^n),
		where k is the golden number = (1 + 5 sqrt) / 2 = 1.618...."
	n1 print. '-' print. "' * 500000 * 1000) // ' print. "
	t1 print. '.' printNl. "' bytecodes/sec; ' print."
	r print. '-' print. "' * 1000) // ' print."
	t2 print. '.' printNl. "' sends/sec' printNl."! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:15'!
to: stop by: step do: aBlock 
	"Normally compiled in-line, and therefore not overridable.
	Evaluate aBlock for each element of the interval (self to: stop by: 
step)."
	| nextValue |
	nextValue := self.
	step = 0 ifTrue: [self error: 'step must be non-zero'].
	step < 0
		ifTrue: [[stop <= nextValue]
				whileTrue: 
					[aBlock value: nextValue.
					nextValue := nextValue + step]]
		ifFalse: [[stop >= nextValue]
				whileTrue: 
					[aBlock value: nextValue.
					nextValue := nextValue + step]]! !

!NXTInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:15'!
to: stop do: aBlock 
	| nextValue |
	nextValue := self.
	[ nextValue <= stop ]
		whileTrue: 
			[ aBlock value: nextValue.
			nextValue := nextValue + 1 ]! !

NXTInteger variableByteSubclass: #NXTLargePositiveInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

NXTLargePositiveInteger variableByteSubclass: #NXTLargeNegativeInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTLargePositiveInteger class methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 12:20'!
elementSize
	^ 1! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:42'!
* other
	<NXTPrimitive: 43>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:56'!
+ other
	<NXTPrimitive: 14>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:55'!
- other
	<NXTPrimitive: 40>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:05'!
// other
	| temp n |
	temp := self.
	n := 0.
	[ temp > 0] whileTrue: [ temp := temp - other. n := n + 1 ].
	^ n! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 16:41'!
< other
	<NXTPrimitive: 41>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 20:13'!
= other
	<NXTPrimitive: 44>
	^ super = other! !

!NXTLargePositiveInteger methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 13:56'!
computeSize
	^ self size! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 18:06'!
digitAt: index
	^ self at: index! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 18:06'!
digitAt: index put: object
	^ self at: index put: object! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:53'!
digitLength
	^ super size! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 14:12'!
print
	<NXTPrimitive: 13>! !

!NXTLargePositiveInteger methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:49'!
printNl
	self print.
	NXTString cr print.! !

!NXTLargePositiveInteger methodsFor: 'nxt-exclude' stamp: 'mab 9/8/2008 13:56'!
writeDataOn: aByteStream withImage: image
	1 to: self size do: [ :index |
		aByteStream nextPut: (self at: index) asInteger ].! !

NXTInteger subclass: #NXTSmallInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTSmallInteger class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 11:44'!
maxVal
	^ 16r3FFF! !

!NXTSmallInteger class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 11:44'!
minVal
	^ -16r4000! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 15:40'!
* other
	<NXTPrimitive: 22>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 4/29/2008 15:25'!
+ other
	<NXTPrimitive: 3>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:24'!
- aNumber
	<NXTPrimitive: 19>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:20'!
// aNumber
	<NXTPrimitive: 18>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 5/16/2008 21:46'!
< other
	<NXTPrimitive: 11>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 17:50'!
<< shift
	^ self bitShift: shift! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 12/15/2008 17:47'!
<= other
	<NXTPrimitive: 64>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/1/2008 17:50'!
>> shift
	^ self bitShift: shift negated! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 18:31'!
\\ aNumber
	<NXTPrimitive: 37>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 14:42'!
asInteger
	^ self! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:00'!
atRandom
	<NXTPrimitive: 24>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:38'!
bitAnd: other
	<NXTPrimitive: 8>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 19:14'!
bitOr: other
	<NXTPrimitive: 42>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 14:43'!
bitShift: shift
	<NXTPrimitive: 31>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/11/2008 15:54'!
bitXor: other
	<NXTPrimitive: 23>! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 13:11'!
digitAt: n 
	"Answer the value of an indexable field in the receiver.  LargePositiveInteger uses bytes of base two number, and each is a 'digit' base 256.  Fail if the argument (the index) is not an Integer or is out of bounds."
	n>4 ifTrue: [^ 0].
	self < 0
		ifTrue: 
			[self = NXTSmallInteger minVal ifTrue:
				["Can't negate minVal -- treat specially"
				^ #(0 0 0 64) at: n].
			^ ((0-self) bitShift: (1-n)*8) bitAnd: 16rFF]
		ifFalse: [^ (self bitShift: (1-n)*8) bitAnd: 16rFF]! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:52'!
digitLength
	"Answer the number of indexable fields in the receiver. This value is the 
	same as the largest legal subscript. Included so that a SmallInteger can 
	behave like a LargePositiveInteger or LargeNegativeInteger."

	(self < 16r100 and: [self > -16r100]) ifTrue: [^ 1].
	^ 2
! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 5/7/2008 17:55'!
isZero
	^ self = 0! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:26'!
max: aNumber
	self < aNumber
		ifTrue: [ ^ aNumber ]
		ifFalse: [ ^ self ]! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:01'!
print
	<NXTPrimitive: 4>
	Transcript show: self asString! !

!NXTSmallInteger methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:02'!
printNl
	self print.
	NXTString cr print.! !

!NXTNumber methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:42'!
negated
	"Answer a Number that is the negation of the receiver."

	^0 - self! !

!NXTNumber methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 17:42'!
negative
	"Answer whether the receiver is mathematically negative."

	^ self < 0! !

!NXTObject class methodsFor: 'nxt-exclude' stamp: 'mab 6/5/2008 17:11'!
elementSize
	^ 2! !

!NXTObject class methodsFor: 'as yet unclassified' stamp: 'mab 12/15/2008 13:24'!
initialize! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 2/12/2009 15:24'!
-> anObject
	^ NXTAssociation key: self value: anObject! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 6/6/2008 16:27'!
= other
	^ self == other! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 6/6/2008 16:27'!
== other
	<NXTPrimitive: 7>
	^ self == other! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 6/6/2008 10:38'!
asNXTObject
	^ self! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 6/2/2008 15:33'!
at: anInteger
	<NXTPrimitive: 20>
	^ super at: anInteger! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 6/2/2008 15:34'!
at: anInteger put: anObject
	<NXTPrimitive: 21>
	^ super at: anInteger put: anObject! !

!NXTObject methodsFor: 'environment' stamp: 'mab 9/19/2008 16:52'!
buttons
	^ self environment buttons! !

!NXTObject methodsFor: 'class membership' stamp: 'mab 5/21/2008 17:36'!
class
	<NXTPrimitive: 12>! !

!NXTObject methodsFor: 'class membership' stamp: 'mab 11/15/2008 18:32'!
class: anNXTClass
	<NXTPrimitive: 63>! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 5/21/2008 10:26'!
computeSize
	^ self class allInstVarNames size! !

!NXTObject methodsFor: 'environment' stamp: 'mab 9/19/2008 16:52'!
display
	^ self environment display! !

!NXTObject methodsFor: 'error handling' stamp: 'mab 10/3/2008 22:48'!
doesNotUnderstand: aMessage 
	 "Handle the fact that there was an attempt to send the given message to the receiver but the receiver does not understand this message (typically sent from the machine when a message is sent to the receiver and no method is defined for that selector)."
	"Testing: (3 activeProcess)"

	NXTMessageNotUnderstood new 
		message: aMessage;
		receiver: self;
		signal.
	^ aMessage sentTo: self.
! !

!NXTObject methodsFor: 'environment' stamp: 'mab 9/19/2008 16:40'!
environment
	^ self class environment! !

!NXTObject methodsFor: 'error handling' stamp: 'mab 11/17/2008 12:43'!
error: aString
	NXTError signal: aString.
	! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 8/15/2008 16:59'!
halt
	<NXTPrimitive: 34>
	super halt.! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 11/18/2008 11:33'!
hash
	^ self identityHash! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 11/19/2008 16:39'!
identityHash
	<NXTPrimitive: 36>
	^ super identityHash! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 12/15/2008 11:10'!
identityHashReplacement
	^ #literal hashFor: self! !

!NXTObject methodsFor: 'testing' stamp: 'mab 9/15/2008 14:36'!
ifNil: aBlock
	^ self! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 13:27'!
ifNil: nilBlock ifNotNil: ifNotNilBlock
	"Evaluate the block, unless I'm == nil (q.v.)"

	^ ifNotNilBlock value! !

!NXTObject methodsFor: 'testing' stamp: 'mab 10/3/2008 21:41'!
ifNotNil: ifNotNilBlock
	"If I got here, I am not nil, so evaluate the block ifNotNilBlock"

	^ ifNotNilBlock value! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 13:26'!
ifNotNil: ifNotNilBlock ifNil: nilBlock 
	"If I got here, I am not nil, so evaluate the block ifNotNilBlock"

	^ ifNotNilBlock value! !

!NXTObject methodsFor: 'initialize-release' stamp: 'mab 5/29/2008 15:56'!
initialize! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 11/14/2008 19:18'!
instVarAt: anInteger
	<NXTPrimitive: 20>
	^ super instVarAt: anInteger! !

!NXTObject methodsFor: 'accessing' stamp: 'mab 11/14/2008 19:18'!
instVarAt: anInteger put: anObject
	<NXTPrimitive: 21>
	^ super instVarAt: anInteger put: anObject! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 11/16/2008 14:53'!
instanceVariables
	| c |
	c := NXTOrderedCollection new.
	self class allInstVarNames doWithIndex: [ :name :index |
		c add: (self instVarAt: index) ].
	^ c! !

!NXTObject methodsFor: 'testing' stamp: 'mab 5/22/2008 16:35'!
isClass
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 11/17/2008 19:32'!
isClassProxy
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 15:06'!
isDictionary
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 14:22'!
isKindOf: aClass 
	"Answer whether the class, aClass, is a superclass or class of the receiver."

	self class == aClass
		ifTrue: [^true]
		ifFalse: [^self class inheritsFrom: aClass]! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/15/2008 15:10'!
isLookupKey
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/15/2008 11:44'!
isMessage
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 5/21/2008 16:33'!
isMeta
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/15/2008 16:21'!
isNXTObject
	^ true! !

!NXTObject methodsFor: 'testing' stamp: 'mab 5/20/2008 14:22'!
isNil
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 12/15/2008 10:54'!
isSet
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 8/19/2008 15:57'!
isString
	^ false! !

!NXTObject methodsFor: 'testing' stamp: 'mab 7/25/2008 19:15'!
isSymbol
	^ false! !

!NXTObject methodsFor: 'environment' stamp: 'mab 11/12/2008 17:51'!
motorA
	^ self environment motorA! !

!NXTObject methodsFor: 'environment' stamp: 'mab 11/12/2008 17:51'!
motorB
	^ self environment motorB! !

!NXTObject methodsFor: 'environment' stamp: 'mab 11/12/2008 17:51'!
motorC
	^ self environment motorC! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 16:11'!
nextInstance
	<NXTPrimitive: 29>! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 5/21/2008 10:29'!
nxtClass
	^ self class name asSymbol! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 11/3/2008 20:52'!
objectHeader
	| header |
	self computeSize >= 16rFFFF ifTrue: [ self halt ].
	header := self computeSize.
	^ header! !

!NXTObject methodsFor: 'performing' stamp: 'mab 7/15/2008 10:50'!
perform: aSymbol
	<NXTPrimitive: 25>
	^ super perform: aSymbol! !

!NXTObject methodsFor: 'performing' stamp: 'mab 7/15/2008 15:00'!
perform: aSymbol with: anObject
	<NXTPrimitive: 25>
	^ super perform: aSymbol with: anObject! !

!NXTObject methodsFor: 'performing' stamp: 'mab 8/19/2008 18:43'!
perform: aSymbol withArguments: anArray
	<NXTPrimitive: 38>
	^ super perform: aSymbol withArguments: anArray! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 11/18/2008 15:11'!
referencesDo: aBlock
	self class allInstVarNames do: [ :instVarName |
		aBlock value: (self instVarNamed: instVarName) ]! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 11/18/2008 11:14'!
referencesReplace: aBlock
	self class allInstVarNames do: [ :instVarName |
		self instVarNamed: instVarName put: (aBlock value: (self instVarNamed: instVarName)) ].
! !

!NXTObject methodsFor: 'environment' stamp: 'mab 11/13/2008 09:07'!
sensorAt: port
	^ self environment sensors at: port! !

!NXTObject methodsFor: 'environment' stamp: 'mab 11/13/2008 09:05'!
sensorAt: port put: sensor
	^ self environment sensorAt: port put: sensor! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 6/2/2008 15:28'!
size
	<NXTPrimitive: 17>
	^ super size! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 14:41'!
species
	^ self class! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 10/8/2008 21:28'!
subclassResponsibility
	self error: 'My subclass should have overridden ', thisContext sender selector asString! !

!NXTObject methodsFor: 'evaluating' stamp: 'mab 5/20/2008 14:23'!
value
	^ self! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 12/15/2008 09:00'!
writeAsReferenceOn: aByteStream within: image
	aByteStream littleEndianWord: (((image objectTable idFor: self) bitShift: 1) bitOr: 1)! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 11/18/2008 12:13'!
writeClassOn: aByteStream withImage: image
	| class |
	class := image metaclasses at: self ifAbsent: [ self nxtClass isSymbol 
		ifTrue: [ image classes at: self nxtClass ]
		ifFalse: [ self nxtClass ]].
	class writeAsReferenceOn: aByteStream within: image.! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 11/17/2008 18:52'!
writeDataOn: aByteStream withImage: image
	self referencesDo: [ :object |
		object writeAsReferenceOn: aByteStream within: image ].! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 9/17/2008 11:41'!
writeHeaderOn: aByteStream
	aByteStream littleEndianWord: self objectHeader.! !

!NXTObject methodsFor: 'nxt-exclude' stamp: 'mab 11/3/2008 22:06'!
writeOn: aByteStream withImage: image
	self writeClassOn: aByteStream withImage: image.
	self class isVariable ifTrue: [ self writeHeaderOn: aByteStream ].
	self writeDataOn: aByteStream withImage: image.! !

!NXTObject methodsFor: 'as yet unclassified' stamp: 'mab 2/12/2009 15:25'!
yourself
	^ self! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 7/25/2008 19:09'!
~= anObject 
	"Answer whether the receiver and the argument do not represent the 
	same object."

	^self = anObject == false! !

!NXTObject methodsFor: 'comparing' stamp: 'mab 9/8/2008 18:18'!
~~ anObject
	"Answer whether the receiver and the argument are not the same object 
	(do not have the same object pointer)."

	self == anObject
		ifTrue: [^ false]
		ifFalse: [^ true]! !

NXTObject subclass: #NXTPackage
	instanceVariableNames: 'name entrypoint classes metaclasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 14:34'!
classes
	^ classes! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:00'!
entrypoint
	^ entrypoint! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:44'!
entrypoint: anObject
	entrypoint := anObject! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 11:21'!
initialize
	classes := NXTDictionary new.
	metaclasses := NXTDictionary new.! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:00'!
isApplication
	^ self entrypoint isNil not! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:00'!
isLibrary
	^ self entrypoint isNil! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 14:34'!
metaclasses
	^ metaclasses! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 15:20'!
name
	^ name! !

!NXTPackage methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 15:19'!
name: anObject
	name := anObject.! !

NXTObject subclass: #NXTPackageDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

NXTPackageDescription subclass: #NXTApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

NXTApplication subclass: #NXSnakeApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-Snake'!

!NXSnakeApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:31'!
classes
	^ #(NXSBoard NXSBoardView NXSElement NXSApple NXSnakeElement NXSnake)! !

!NXSnakeApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:32'!
entrypoint
	^ #NXSnake -> #run! !

!NXSnakeApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:31'!
name
	^ 'Snake'! !

!NXTApplication methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:44'!
addToManager: aPackageManager
	^ aPackageManager addApplication: self! !

!NXTApplication methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:13'!
entrypoint
	^ self subclassResponsibility! !

!NXTApplication methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:13'!
isApplication
	^ true! !

NXTApplication subclass: #NXTBenchmarkApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTBenchmarkApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:52'!
classes
	^ #(NXTBenchmark)! !

!NXTBenchmarkApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:52'!
entrypoint
	^ #NXTBenchmark -> #run! !

!NXTBenchmarkApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:54'!
name
	^ 'Tiny Benchmark'! !

NXTApplication subclass: #NXTBluetoothTesterApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTBluetoothTesterApp methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 17:17'!
classes
	^ #(NXTBluetoothTester #NXTDriver)! !

!NXTBluetoothTesterApp methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:14'!
entrypoint
	^ #NXTBluetoothTester -> #run! !

!NXTBluetoothTesterApp methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:14'!
name
	^ 'Bluetooth'! !

NXTApplication subclass: #NXTDemoApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTDemoApp methodsFor: 'as yet unclassified' stamp: 'mab 11/27/2008 10:51'!
classes
	^ #(NXTDemo)! !

!NXTDemoApp methodsFor: 'as yet unclassified' stamp: 'mab 11/27/2008 10:51'!
entrypoint
	^ #NXTDemo -> #run! !

!NXTDemoApp methodsFor: 'as yet unclassified' stamp: 'mab 11/27/2008 10:51'!
name
	^ 'Explorer'! !

NXTApplication subclass: #NXTLineFollowerApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-LineFollower'!

!NXTLineFollowerApp methodsFor: 'as yet unclassified' stamp: 'mab 12/8/2008 09:44'!
classes
	^ #(NXTLineFollower)! !

!NXTLineFollowerApp methodsFor: 'as yet unclassified' stamp: 'mab 12/8/2008 09:44'!
entrypoint
	^ #NXTLineFollower -> #run! !

!NXTLineFollowerApp methodsFor: 'as yet unclassified' stamp: 'mab 12/8/2008 09:44'!
name
	^ 'Line Follower'! !

NXTApplication subclass: #NXTLineFollowerApp2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Examples-LineFollower'!

!NXTLineFollowerApp2 methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
classes
	^ #(NXTLineFollower2)! !

!NXTLineFollowerApp2 methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:39'!
entrypoint
	^ #NXTLineFollower2 -> #run! !

!NXTLineFollowerApp2 methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:47'!
name
	^ 'Line Follower2'! !

NXTApplication subclass: #NXTSensorTestApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTSensorTestApp methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 11:11'!
classes
	^ #(NXTSensorTest)! !

!NXTSensorTestApp methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:08'!
entrypoint
	^ #NXTSensorTest -> #run! !

!NXTSensorTestApp methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 10:42'!
name
	^ 'Sensor Test'! !

NXTApplication subclass: #NXTTestRunnerApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTTestRunnerApp methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:54'!
classes
	^ ((PackageInfo named: 'NXTalk-ST-Tests') classes collect: [ :class | class name ]), #(NXTTestRunner)! !

!NXTTestRunnerApp methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:55'!
entrypoint
	^ #NXTTestRunner -> #run! !

!NXTTestRunnerApp methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:53'!
name
	^ 'Test Runner'! !

NXTApplication subclass: #NXTThreadTestApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTThreadTestApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:37'!
classes
	^ #(NXTThreadTest)! !

!NXTThreadTestApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:38'!
entrypoint
	^ #NXTThreadTest -> #run! !

!NXTThreadTestApp methodsFor: 'as yet unclassified' stamp: 'mab 12/18/2008 13:38'!
name
	^ 'Thread Test'! !

NXTApplication subclass: #NXTUsbManagerApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTUsbManagerApp methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 18:17'!
classes
	^ #(NXTUsbManager NXTDriver)! !

!NXTUsbManagerApp methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:05'!
entrypoint
	^ #NXTUsbManager -> #run! !

!NXTUsbManagerApp methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 17:43'!
name
	^ 'USB Transfer'! !

NXTPackageDescription subclass: #NXTLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

NXTLibrary subclass: #NXTBaseLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

!NXTBaseLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 17:55'!
baseCategories
	^ #('NXTalk-ST-Kernel' 'NXTalk-ST-Collections' 'NXTalk-ST-Hardware')! !

!NXTBaseLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 11:47'!
classes
	| classes |
	classes := OrderedCollection new.
	self baseCategories do: [ :category |
		classes addAll: ((PackageInfo named: category) classes collect: [ :class | class name ]) ].
	^ classes , #(NXTSystem NXTPackageManager NXTPackage)! !

!NXTBaseLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 16:31'!
name
	^ 'System Library'! !

!NXTLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:25'!
isLibrary
	^ true! !

NXTLibrary subclass: #NXTStreamLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

!NXTStreamLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 17:46'!
classes
	^ (PackageInfo named: 'NXTalk-ST-Streams') classes collect: [ :class | class name ]! !

!NXTStreamLibrary methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 17:45'!
name
	^ 'Stream Library'! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:41'!
addToManager: aPackageManager
	self subclassResponsibility! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:18'!
classes
	"All classes to include for deployment on the NXT"
	^ NXTArray new! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:18'!
dependencies
	"Packages needed to be already installed on the NXT or deployed with me"
	^ NXTArray new! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:13'!
isApplication
	^ false! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:18'!
isLibrary
	^ false! !

!NXTPackageDescription methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 09:46'!
name
	^ self subclassResponsibility! !

NXTObject subclass: #NXTPackageManager
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Packaging'!

NXTPackageManager class
	instanceVariableNames: 'default'!

NXTPackageManager class
	instanceVariableNames: 'default'!

!NXTPackageManager class methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:46'!
default
	^ default ifNil: [ default := self new ]! !

!NXTPackageManager class methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:45'!
default: aDefaultPackageManager
	default := aDefaultPackageManager.! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:43'!
applications
	^ self packages select: [ :package | package isApplication ]! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/22/2008 16:23'!
installPackage: aPackage
	| metaclass |
	Smalltalk isNXTalk ifFalse: [ self error: 'Package can only be installed on the NXT' ].
	aPackage classes rehash.
	aPackage metaclasses rehash.
	aPackage classes valuesDo: [ :class |
		metaclass := aPackage metaclasses at: class.
		class class: metaclass.
		Smalltalk addClass: class.
		class initialize ].
	self packages add: aPackage.! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 16:39'!
libaries
	^ self packages select: [ :package | package isLibrary ]! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:41'!
packageNames
	^ self packages collect: [ :package | package name ]! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 14:25'!
packages
	^ packages ifNil: [ packages := NXTOrderedCollection new ]! !

!NXTPackageManager methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 19:02'!
test
	^ 'cool'! !

NXTObject subclass: #NXTProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

NXTProgram subclass: #NXTDrivingExample
	instanceVariableNames: 'running enterPressed driving right left'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTDrivingExample methodsFor: 'button reading' stamp: 'mab 9/19/2008 16:49'!
checkEnterDown: key
	(self buttons enter isPressed) & enterPressed not ifTrue: [
		enterPressed := true ].! !

!NXTDrivingExample methodsFor: 'button reading' stamp: 'mab 9/16/2008 10:41'!
checkEnterUp: key
	(self buttons enter isPressed) not & enterPressed ifTrue: [
		enterPressed := false.
		driving 
			ifFalse: [ 'Start driving' printNl.
				self driveAhead.
				driving := true ]
			ifTrue: [  'Stop driving' printNl.
				self stopDriving.
				driving := false ]].! !

!NXTDrivingExample methodsFor: 'button reading' stamp: 'mab 9/16/2008 10:41'!
checkLeft: key
	(self buttons left isPressed) & left not ifTrue: [
		left := true.
		self driveLeft ].
	(self buttons left isPressed) not & left ifTrue: [
		left := false.
		self driveAhead ].! !

!NXTDrivingExample methodsFor: 'button reading' stamp: 'mab 9/16/2008 10:41'!
checkRight: key
	(self buttons right isPressed) & right not & left not ifTrue: [
		right := true.
		self driveRight ].
	(self buttons right isPressed) not & right ifTrue: [
		right := false.
		self driveAhead ].! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 11/10/2008 16:21'!
driveAhead
	self motorA 
		speed: 75.
	self motorB
		speed: 75.! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 11/10/2008 16:21'!
driveBack
	self motorA
		speed: -75.
	self motorB
		speed: -75.! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 11/10/2008 16:21'!
driveLeft
	self motorA
		speed: 0.
	self motorB
		speed: 75.! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 11/10/2008 16:21'!
driveRight
	self motorA
		speed: 75.
	self motorB
		speed: 0.! !

!NXTDrivingExample methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 17:15'!
initialize
	self stopDriving.
	running := true.
	enterPressed := false.
	driving := false.
	left := false.
	right := false.! !

!NXTDrivingExample methodsFor: 'running' stamp: 'mab 9/16/2008 10:44'!
keyLoop
	| key |
	key := self buttons read.
	key = self buttons exit ifTrue: [ running := false ].
	self checkEnterDown: key.
	self checkEnterUp: key.
	self checkLeft: key.
	self checkRight: key.! !

!NXTDrivingExample methodsFor: 'running' stamp: 'mab 7/22/2008 17:45'!
run
	'Entering driving mode now: ' printNl.
	'Enter to start and stop engine' printNl.
	'Left/Right for steering' printNl.
	[ running ] whileTrue: [ self keyLoop ].
	'Goodbye!!' printNl.! !

!NXTDrivingExample methodsFor: 'driving' stamp: 'mab 11/10/2008 16:21'!
stopDriving
	self motorA
		speed: 0.
	self motorB
		speed: 0.! !

!NXTProgram methodsFor: 'running' stamp: 'mab 7/22/2008 17:09'!
run
	self subclassResponsibility! !

NXTProgram subclass: #NXTSimpleProgram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTSimpleProgram methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 17:20'!
run
	'It worked!!' printNl.! !

NXTObject subclass: #NXTRemoteProxy
	instanceVariableNames: 'dataStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTRemoteProxy class methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 16:57'!
on: aDataStream
	^ self new dataStream: aDataStream! !

!NXTRemoteProxy methodsFor: 'accessing' stamp: 'mab 11/13/2008 15:37'!
dataStream
	^ dataStream! !

!NXTRemoteProxy methodsFor: 'accessing' stamp: 'mab 11/13/2008 15:37'!
dataStream: anObject
	dataStream := anObject! !

!NXTRemoteProxy methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 16:59'!
doesNotUnderstand: aMessage
	self dataStream nextPut: aMessage asNXTObject.
	self dataStream flush.
	^ self dataStream next! !

NXTObject subclass: #NXTSensor
	instanceVariableNames: 'port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

NXTSensor subclass: #NXTLightSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 13:44'!
intensity
	^ self mapFrom: self read! !

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 13:43'!
mapFrom: aValue
	^ 700 - aValue // 3! !

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 13:44'!
mapTo: aValue
	^ 700 - (aValue * 3)! !

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 13:27'!
onDarkerThan: aValue do: aBlock
	| ownerFrame ownerProcess |
	ownerFrame := thisContext sender.
	ownerProcess := Processor activeProcess.
	^ [ self waitUntilAbove: (self mapTo: aValue). 
		Processor withoutScheduling: [
			aBlock onNonLocalReturnsDo: [ :value | ownerProcess return: value from: ownerFrame. ownerProcess resume ]]] fork! !

!NXTLightSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 13:45'!
waitUntilLighterThan: aValue
	self waitUntilBelow: (self mapTo: aValue).! !

NXTSensor subclass: #NXTRadar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTRadar class methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:59'!
disable: portNumber
	<NXTPrimitive: 58>! !

!NXTRadar class methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:54'!
distance: portNumber ofObject: objectNumber
	<NXTPrimitive: 59>! !

!NXTRadar class methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:59'!
enable: portNumber
	<NXTPrimitive: 57>! !

!NXTRadar class methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:56'!
isRadar: portNumber
	<NXTPrimitive: 60>! !

!NXTRadar methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 14:19'!
distance
	^ self distanceOfObject: 0! !

!NXTRadar methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 14:23'!
distanceOfObject: objectNumber
	^ self class distance: self port ofObject: objectNumber! !

!NXTRadar methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 14:32'!
enable
	super enable.
	"(self class isRadar: self port) ifFalse: [ self error: 'No radar at this port' ]."! !

!NXTRadar methodsFor: 'as yet unclassified' stamp: 'mab 11/12/2008 15:06'!
isWithin: distance
	| value |
	value := self distance.
	^ value > 0 and: [ value <= distance ]! !

NXTSensor subclass: #NXTRotationSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTRotationSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 11:08'!
read
	^ NXTMotor tachoCountFor: self port! !

!NXTRotationSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 11:54'!
reset
	NXTMotor resetTachoCountFor: self port! !

!NXTRotationSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 12:25'!
waitDegrees: aNumber
	| event |
	self reset.
	event := NXTEvent forRotationSensor: self port.
	event value: aNumber.
	event condition: NXTEvent greaterThan.
	Processor activeProcess waitFor: event.! !

!NXTSensor class methodsFor: 'as yet unclassified' stamp: 'mab 11/12/2008 16:06'!
disable: number
	<NXTPrimitive: 61>! !

!NXTSensor class methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 13:57'!
enable: number
	<NXTPrimitive: 30>! !

!NXTSensor class methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:09'!
port: aNumber
	^ self new port: aNumber! !

!NXTSensor class methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 13:58'!
read: number
	<NXTPrimitive: 53>! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 11/11/2008 13:59'!
disable
	self class disable: self port.! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:02'!
enable
	self class enable: self port.! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:16'!
port
	^ port! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:01'!
port: aNumber
	port := aNumber! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 10/30/2008 14:02'!
read
	^ self class read: self port! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 1/3/2009 13:41'!
waitUntilAbove: aValue
	| event |
	event := NXTEvent forSensor: self port.
	event value: aValue.
	event condition: NXTEvent greaterThan.
	Processor activeProcess waitFor: event.! !

!NXTSensor methodsFor: 'as yet unclassified' stamp: 'mab 12/31/2008 15:35'!
waitUntilBelow: aValue
	| event |
	event := NXTEvent forSensor: self port.
	event value: aValue.
	event condition: NXTEvent lessThan.
	Processor activeProcess waitFor: event.! !

NXTSensor subclass: #NXTSound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

NXTObject subclass: #NXTSensorTest
	instanceVariableNames: 'test'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTSensorTest methodsFor: 'as yet unclassified' stamp: 'mab 1/4/2009 15:19'!
run
	self motorB speed: 75.
	self motorC speed: -75.
	[ self buttons right isPressed ] whileFalse: [
		self motorB rotationSensor read print.
		'  ' print.
		self motorC rotationSensor read printNl ].
	self motorB rotationSensor reset.
	self motorC rotationSensor reset.
	self motorB speed: -75.
	self motorC speed: 75.
	[ self buttons exit isPressed ] whileFalse: [
		self motorB rotationSensor read print.
		'  ' print.
		self motorC rotationSensor read printNl ].
	self motorB stop.
	self motorC stop.
	NXTButton waitForAnyKey.
	^ '42 + 1'! !

NXTObject subclass: #NXTSpeaker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

NXTObject subclass: #NXTStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

NXTStream subclass: #NXTDataStream
	instanceVariableNames: 'byteStream readObjects writtenObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

!NXTDataStream class methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 18:45'!
on: aStream
	^ self new setStream: aStream! !

!NXTDataStream class methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 11:04'!
typeIDs
	^ #(#NXTSymbol #NXTString #NXTSmallInteger #NXTArray #NXTUndefinedObject #NXTClassProxy #XYZBackReference 
		#NXTMethod #NXTBlock)! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 16:29'!
beginInstance: aClass size: size
	self writeSmallInteger: size.
	self writeSymbol: aClass name.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 14:31'!
classNameFor: anObject
	| name |
	name := anObject class name.
	(name beginsWith: 'NXT') ifFalse: [ name := 'NXT', name ].
	^ name asSymbol! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:58'!
close
	^ byteStream close! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/30/2008 11:07'!
flush
	^ byteStream flush! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/24/2008 13:17'!
methodNameFor: anObject
	^ ('write', ((self classNameFor: anObject) allButFirst: 3)) asSymbol asMutator! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 14:58'!
next
	| type selector |
	'#' print.
	type := byteStream next.
	type isZero ifTrue: [ ^ self readInstance ].
	selector := ('read', ((self class typeIDs at: type) allButFirst: 3)) asSymbol print.
	^ self perform: selector.
! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:24'!
nextPut: anObject
	| nxtObject typeID |
	nxtObject := anObject asNXTObject.
	typeID := self typeIDFor: nxtObject.
	byteStream nextPut: typeID.
	typeID = 7 ifTrue: [ ^ self writeBackReference: nxtObject ].
	typeID isZero 
		ifTrue: [ self writeInstance: nxtObject ]
		ifFalse: [ self perform: (self methodNameFor: nxtObject) with: nxtObject ].
	! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 15:46'!
readArray
	| size |
	size := byteStream int16.
	^ self next: size! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:11'!
readBackReference
	^ self readObjects at: self readSmallInteger! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 13:28'!
readBlock
	^ self readCallable: NXTBlock
! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 13:28'!
readCallable: class
	| header literals bytecodes |
	header := byteStream int16.
	literals := NXTOrderedCollection new.
	bytecodes := NXTOrderedCollection new.
	byteStream int16 timesRepeat: [ literals add: self next ].
	byteStream int16 timesRepeat: [ bytecodes add: byteStream next ].
	^ class bytecodes: bytecodes literals: literals header: header
! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/22/2008 17:43'!
readClassProxy
	| name |
	name := self readSymbol.
	name = #Smalltalk ifTrue: [ ^ Smalltalk ].
	name = #Processor ifTrue: [ ^ Processor ].
	^ Smalltalk classNamed: name! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 13:48'!
readInstance
	| instSize newClass anObject |
	instSize := self readSmallInteger.
	newClass := Smalltalk at: self readSymbol.
	anObject := newClass basicNew.
	self readObjects add: anObject.
	1 to: instSize do: [ :i |
		anObject instVarAt: i put: self next ].
	^ anObject! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 13:28'!
readMethod
	^ self readCallable: NXTMethod! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:09'!
readObjects
	^ readObjects ifNil: [ readObjects := NXTOrderedCollection new ]! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:11'!
readSmallInteger
	^ byteStream int16! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 20:09'!
readString
	^ byteStream nextString! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 10:50'!
readSymbol
    ^ self readString asSymbol! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 16:10'!
readUndefinedObject
	^ nil! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 20:02'!
reset
	byteStream reset! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 18:45'!
setStream: aStream
	aStream binary.
	byteStream := aStream.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:15'!
typeIDFor: anObject
	self writtenObjects at: anObject ifAbsent: [
		^ self class typeIDs indexOf: (self classNameFor: anObject) ].
	^ self class typeIDs indexOf: #XYZBackReference! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 18:13'!
writeArray: array
	byteStream int16: array size.
	self nextPutAll: array.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:16'!
writeBackReference: anObject
	self writeSmallInteger: (self writtenObjects at: anObject).
	! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 11:07'!
writeBlock: block
	self writeMethod: block! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 16:56'!
writeClassProxy: aClassProxy
	self writeSymbol: aClassProxy name! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:16'!
writeInstance: anObject
	| instVarCount |
	self writtenObjects at: anObject put: (self writtenObjects size + 1).
	instVarCount := anObject class instSize.
	self beginInstance: anObject class size: instVarCount.
	1 to: instVarCount do: [ :i |
		self nextPut: (anObject instVarAt: i) ].
	! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/20/2008 11:06'!
writeMethod: method
	byteStream int16: method header.
	byteStream int16: method numLiterals.
	method literals do: [ :literal | self nextPut: literal ].
	byteStream int16: method numBytecodes.
	method bytecodes do: [ :bytecode | byteStream nextPut: bytecode ].! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:11'!
writeSmallInteger: int
	byteStream int16: int.! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 7/14/2008 19:32'!
writeString: aString
	byteStream nextStringPut: aString! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/24/2008 13:17'!
writeSymbol: aSymbol
	self writeString: aSymbol! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 16:10'!
writeUndefinedObject: anObject
	"Nothing to be done here,"! !

!NXTDataStream methodsFor: 'as yet unclassified' stamp: 'mab 11/15/2008 18:05'!
writtenObjects
	^ writtenObjects ifNil: [ writtenObjects := NXTDictionary new ]! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:41'!
ascii
	"NXT streams are always binary for now"! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:41'!
binary
	"NXT streams are always binary for now"! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:57'!
close! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 14:22'!
next: count
	| array |
	count print. '.' print.
	array := NXTArray new: count.
	1 to: count do: [ :i |
		array at: i put: self next ].
	^ array! !

!NXTStream methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 15:58'!
nextPutAll: aCollection
	aCollection do: [ :each |
		self nextPut: each ].! !

NXTStream subclass: #NXTUsbStream
	instanceVariableNames: 'inputBuffer inputBufferPos outputBuffer outputBufferPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

NXTUsbStream subclass: #NXTBluetoothStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Streams'!

!NXTBluetoothStream methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 15:04'!
fillInputBuffer
	| buffer |
	buffer := NXTString new: 64.
	NXTBluetooth readInto: buffer.
	[ NXTBluetooth dataRead isZero ] whileTrue.
	[ NXTBluetooth dataRead = NXTBluetooth dataRead ] whileFalse.
	"'!!' print. NXTBluetooth dataRead print. '!!' print. NXTBluetooth dataRead print. '!!' print."
	inputBuffer := buffer copyFrom: 1 to: NXTBluetooth dataRead.
	! !

!NXTBluetoothStream methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 16:43'!
flush
	NXTBluetooth write: (outputBuffer copyFrom: 1 to: outputBufferPos - 1).
	[ NXTBluetooth isDataWritten ] whileFalse.
	self reset.! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 16:44'!
fillInputBuffer
	inputBuffer := NXTUsb read.! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:13'!
flush
	NXTUsb send: (outputBuffer copyFrom: 1 to: outputBufferPos - 1).
	self reset.! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:40'!
initialize
	outputBuffer := NXTString new: 64.
	outputBufferPos := 1.! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 16:57'!
int16
	"Answer the next signed, 16-bit integer from this (binary) stream."

	| n |
	n := self next.
	n := (n bitShift: 8) + (self next).
	"n >= 16r8000 ifTrue: [n := n - 16r10000]."
	^ n! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 11:52'!
int16: anInteger
	"Store the given signed, 16-bit integer on this (binary) stream."

	| n |
	"(anInteger < -16r8000) | (anInteger >= 16r8000)
		ifTrue: [self error: 'outside 16-bit integer range'].

	anInteger < 0
		ifTrue: [n := 16r10000 + anInteger]
		ifFalse: [n := anInteger]."
	n := anInteger.
	self nextPut: (n digitAt: 2).
	self nextPut: (n digitAt: 1).
! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 16:44'!
next
	| value |
	(inputBuffer isNil or: [ inputBufferPos > inputBuffer size ]) ifTrue: [
		self fillInputBuffer.
		inputBufferPos := 1 ].
	value := inputBuffer at: inputBufferPos.
	inputBufferPos := inputBufferPos + 1.
	^ value! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:12'!
nextPut: anInteger
	outputBuffer at: outputBufferPos put: anInteger.
	(outputBufferPos := outputBufferPos + 1) > NXTUsb packetSize ifTrue: [
		self flush ].! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/16/2008 17:29'!
nextString
	"Read a string from the receiver. The first byte is the length of the string, unless it is greater than 192, in which case the first four bytes encode the length.  I expect to be in ascii mode when called (caller puts back to binary)."

	| length aByteArray |

	"read the length in binary mode"
	self binary.
	length := self next.		"first byte."
	length >= 192 ifTrue: [length := length - 192.
		1 to: 3 do: [:ii | length := length * 256 + self next]].
	aByteArray := NXTString new: length.

	1 to: length do: [ :i | aByteArray at: i put: self next ].
	^aByteArray asString.
! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 18:14'!
nextStringPut: s 
	"Append the string, s, to the receiver.  Only used by DataStream.  Max size of 64*256*256*256."

	| length |
	(length := s size) < 192
		ifTrue: [self nextPut: length]
		ifFalse: 
			[self nextPut: (length digitAt: 4)+192.
			self nextPut: (length digitAt: 3).
			self nextPut: (length digitAt: 2).
			self nextPut: (length digitAt: 1)].
	self nextPutAll: s.
	^s! !

!NXTUsbStream methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:12'!
reset
	outputBufferPos := 1.! !

NXTObject subclass: #NXTSystem
	instanceVariableNames: 'programs selected packageManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTSystem methodsFor: 'system' stamp: 'mab 8/12/2008 17:56'!
allClasses
	^ NXTObject allSubclasses! !

!NXTSystem methodsFor: 'system' stamp: 'mab 8/13/2008 15:39'!
doKeyAction
	| key |
	key := self buttons waitForAny.
	key = self buttons exit ifTrue: [
		^ #exit ].
	key = self buttons left ifTrue: [ self menuUp ].
	key = self buttons right ifTrue: [ self menuDown ].
	key = self buttons enter ifTrue: [ self execute ].! !

!NXTSystem methodsFor: 'system' stamp: 'mab 1/4/2009 13:48'!
execute
	| application |
	application := self programs at: self selected.
	self display clear.
	(Smalltalk at: application entrypoint key) new perform: application entrypoint value.
	('Finished ', application name, '. Press any key') printNl.
	500 milliSeconds asDelay wait.
	NXTButton waitForAnyKey. 
	self reloadPrograms.! !

!NXTSystem methodsFor: 'system' stamp: 'mab 8/13/2008 15:29'!
menuDown
	self selected: self selected + 1.
	self selected > self programs size ifTrue: [
		self selected: 1 ].! !

!NXTSystem methodsFor: 'system' stamp: 'mab 8/13/2008 15:27'!
menuUp
	self selected: self selected - 1.
	self selected isZero ifTrue: [
		self selected: self programs size ].! !

!NXTSystem methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 14:50'!
packageManager
	^ packageManager ifNil: [ packageManager := Smalltalk packageManager ]! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
programs
	^ programs! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
programs: anObject
	programs := anObject! !

!NXTSystem methodsFor: 'system' stamp: 'mab 11/17/2008 15:19'!
reloadPrograms
	self programs: (self packageManager applications).
	self selected: 1.! !

!NXTSystem methodsFor: 'system' stamp: 'mab 2/10/2009 20:34'!
run
	self test.
	Smalltalk rehash.
	self test2.
	[ self halt. self error: 'blub'] on: NXTError do: [ :error | 'huhu' printNl ].
	self reloadPrograms.
	[ self showMenu ] doWhileTrue: [ self doKeyAction ~= #exit ].
	('Finished ') printNl.
	'Press any key' printNl.
	NXTButton waitForAnyKey.! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
selected
	^ selected! !

!NXTSystem methodsFor: 'accessing' stamp: 'mab 8/13/2008 13:52'!
selected: anObject
	selected := anObject! !

!NXTSystem methodsFor: 'system' stamp: 'mab 11/13/2008 15:59'!
showMenu
	| index |
	self environment display clear.
	index := 0.
	self programs do: [ :prog |
		index := index + 1.
		self selected = index 
			ifTrue: [ '> ' print ]
			ifFalse: [ '  ' print ].
		prog name asString printNl.
	].! !

!NXTSystem methodsFor: 'system' stamp: 'mab 2/4/2009 13:11'!
test
	! !

!NXTSystem methodsFor: 'system' stamp: 'mab 2/11/2009 14:16'!
test2
	! !

NXTObject subclass: #NXTTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

NXTTestCase subclass: #NXTArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTArrayTest methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 14:40'!
testSize
	self assert: (NXTArray new: 5) size = 5
	! !

NXTTestCase subclass: #NXTBlockTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 15:23'!
closure
	| temp |
	temp := #kickass.
	^ [ temp = #kickass ]! !

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 15:04'!
testBlockStacks
	"This should work without crashes"
	[ self error: 'mist' ] on: NXTError do: [].
	[ :block | block ] value: [ ].
	[ ] value.
	true or: [ ].
	[ ]  isBlock.
	10 print.! !

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 9/4/2008 11:51'!
testClosure
	| block |
	block := self closure.
	self assert: block value! !

!NXTBlockTest methodsFor: 'as yet unclassified' stamp: 'mab 6/3/2008 13:33'!
testTemporaryAssignmentFromBlock
	| temp |
	temp := 10.
	[ temp := 5 ] value.
	self assert: temp = 5.! !

NXTTestCase subclass: #NXTClassTest
	instanceVariableNames: ''
	classVariableNames: 'AlwaysFortyTwo ClassVar'
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTClassTest class methodsFor: 'as yet unclassified' stamp: 'mab 11/22/2008 17:44'!
initialize
	"self initialize"
	super initialize.
	AlwaysFortyTwo := 42.! !

!NXTClassTest methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 21:34'!
testClassVar
	self assert: AlwaysFortyTwo = 42.
	ClassVar := 10.
	self assert: ClassVar = 10.! !

NXTTestCase subclass: #NXTDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTDictionaryTest methodsFor: 'tests' stamp: 'mab 8/18/2008 18:32'!
testAdd
	
	| dict |
	dict := NXTDictionary new.
	dict add: #a -> 1.
	dict add: #b -> 2.
	self assert: (dict at: #a) = 1.
	self assert: (dict at: #b) = 2! !

!NXTDictionaryTest methodsFor: 'tests' stamp: 'mab 11/16/2008 15:04'!
testAddAll
	
	| dict1 dict2 |
	dict1 := NXTDictionary new.
	dict1 at: #a put:1 ; at: #b put: 2. 
	dict2 := NXTDictionary new.
	dict2 at: #a put: 3 ; at: #c put: 4.
	dict1 addAll: dict2.
	self assert: (dict1 at: #a) = 3.
	self assert: (dict1 at: #b) = 2.
	self assert: (dict1 at: #c) = 4.! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/18/2008 18:32'!
testAddAssociation
	"self run:#testAddAssociation"
	"self debug:#testAddAssociation"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict at: #a) = 1.
	self assert: (dict at: #b) = 2.
	
	dict at: #a put: 10.
	dict at: #c put: 2.
	
	self assert: (dict at: #a) = 10.
	self assert: (dict at: #b) = 2.
	self assert: (dict at: #c) = 2
	
	! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/19/2008 14:24'!
testAssociationsSelect
	| answer d |
	d := NXTDictionary new.
	d at: (NXTArray with: #hello with: #world)
	  put: #fooBar.
	d at: Smalltalk put: #'Smalltalk is the key'.
	d at: #Smalltalk put: Smalltalk.
	answer := d
				associationsSelect: [:assoc | assoc key == #Smalltalk
						and: [assoc value == Smalltalk]].
	self
		should: [answer isKindOf: NXTDictionary].
	self
		should: [answer size == 1].
	self
		should: [(answer at: #Smalltalk)
				== Smalltalk].
	answer := d
				associationsSelect: [:assoc | assoc key == #NoSuchKey
						and: [assoc value == #NoSuchValue]].
	self
		should: [answer isKindOf: NXTDictionary].
	self
		should: [answer size == 0]! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtError
	"self run: #testAtError"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 666.
	self shouldnt: [ dict at: #a ] raise: NXTError.
	self should: [ dict at: #b ] raise: NXTError.
	
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtIfAbsent
	"self run: #testAtIfAbsent"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 666.
	
	self assert: (dict at: #a ifAbsent: [nil]) = 666.
	
	self assert: (dict at: #b ifAbsent: [nil]) isNil.

	! !

!NXTDictionaryTest methodsFor: 'implementation tests' stamp: 'mab 8/18/2008 18:34'!
testAtNil
	"(self run: #testAtNil)"
	"nil is a valid key in squeak. In VW nil is not a valid key"
	"Ansi 1.9 p, 168
    		5.7.2.5 Message: at: key put: newElement
    		Synopsis
    			Store newElement at key in the receiver. Answer newElement.
    		Definition: <abstractDictionary>
    		If lookup succeeds for key, then newElement replaces the element previously stored at key.
    		Otherwise, the newElement is stored at the new key. In either case, subsequent successful
    		lookups for key will answer newElement.  Answer newElement.

    		The result is undefined if the key is nil.

		This clearly indicates that different smalltalks where doing different assumptions."
	
	
	
	| dict1  |
	dict1 := NXTDictionary new.
	self shouldnt: [ dict1 at: nil put: #none] raise: NXTError.
	self assert: (dict1 at: nil) = #none. 
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtPut
	"self run: #testAtPut"
	"self debug: #testAtPut"
	
	| adictionary |
	adictionary := NXTDictionary new.
	adictionary at: #a put: 3.
	self assert: (adictionary at: #a) = 3.
	adictionary at: #a put: 3.
	adictionary at: #a put: 4.
	self assert: (adictionary at: #a) = 4.
	adictionary at: nil put: 666.
	self assert: (adictionary at: nil) = 666! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:34'!
testAtPutNil
	"self run: #testAtPut"
	"self debug: #testAtPut"
	
	| dict |
	dict := NXTDictionary new.
	dict at: nil put: 1.
	self assert: (dict at: nil) = 1.
	dict at: #a put: nil.
	self assert: (dict at: #a) = nil.
	dict at: nil put: nil.
	self assert: (dict at: nil) = nil.
	
	
	! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/18/2008 18:35'!
testIncludesAssociation
	"self run:#testIncludesAssociation"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict includesAssociation: (#a -> 1)).
	self assert: (dict includesAssociation: (#b -> 2)).
	
	! !

!NXTDictionaryTest methodsFor: 'association tests' stamp: 'mab 8/18/2008 18:35'!
testIncludesAssociationNoValue
	"self run:#testIncludesAssociationNoValue"
	"self debug:#testIncludesAssociationNoValue"
	
	| dict a1 a3 |
	a1 := NXTAssociation key: #Italie.
	a3 := NXTAssociation key: #France value: 'Paris'.
	
	self assert: (a1 key = #Italie).
	self assert: (a1 value isNil).
	
	dict := NXTDictionary new.
	dict add: a1.
	dict add: a3.
	self assert: (dict includesKey: #France).
	self assert: (dict includesKey: #Italie).
	self assert: (dict at: #Italie) isNil.
	self assert: (dict at: #France) = 'Paris'

	
	
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:35'!
testIncludesKey
	"self run:#testIncludesKey"
	"self debug:#testIncludesKey"
	
	| dict a1 a2 a3 |
	a1 := NXTAssociation key: 'Italie'.
	a2 := NXTAssociation new.
	a3 := NXTAssociation key: 'France' value: 'Paris'.
	
	dict := NXTDictionary new.
	dict add: a1 .
	dict add: a2.
	dict add: a3.
	self assert: (dict includesKey: #France).
	self assert: (dict includesKey: 'France').
	self assert: (dict includesKey: #Italie).
	self assert: (dict includesKey: nil).	
		
	self assert: (dict at: 'France' ) = 'Paris'.
! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 16:04'!
testKeyAtValue
	"self run: #testKeyAtValue"
	"self debug: #testKeyAtValue"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	dict at: #c put: 3.
	self assert: (dict keyAtValue: 2) = #b.
	self assert: (dict keyAtValue: 1) = #a.
	self should: [dict keyAtValue: 0] raise: NXTError.
! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 15:58'!
testKeys

	"self run:#testKeys "
	
	| a1 a2  dict | 
	a1 := NXTAssociation key: 'France' value: 'Paris'.
	a2 := NXTAssociation key: 'Italie' value: 'Rome'.
	dict := NXTDictionary new.
	dict add: a1.
	dict add: a2.
	self assert: (dict keys size) = 2.
	self assert: (dict keys includes: #France).! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 16:09'!
testKeysDo
	"self run: #testKeysDo"
	"self debug: #testKeysDo"
	
	| dict res |
	dict := NXTDictionary new.
	
	dict at: #a put: 33.
	dict at: #b put: 66.
	
	res := NXTOrderedCollection new.
	dict keysDo: [ :each | res add: each ].
	
	self assert: res asSet = #(a b) asSet.


	
	! !

!NXTDictionaryTest methodsFor: 'basic tests' stamp: 'mab 8/18/2008 18:36'!
testOccurrencesOf
	"self run:#testOccurrencesOf"
	
	| dict |
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	dict at: #c put: 1.
	dict at: #d put: 3.
	dict at: nil put: nil.
	dict at: #z put: nil.
	
	
	self assert: (dict occurrencesOf: 1 ) = 2.
	self assert: (dict occurrencesOf: nil ) = 2.
	
	
	
	! !

!NXTDictionaryTest methodsFor: 'tests' stamp: 'mab 8/18/2008 18:37'!
testPseudo
	"(self run: #testPseudo)"
	"true and false are valid keys"
	
	| dict1  |
	dict1 := NXTDictionary new.
	self shouldnt: [dict1 at: true put: #true] raise: NXTError.
	self assert: (dict1 at: true) = #true.
		
	self shouldnt: [dict1 at: false put: #false] raise: NXTError.
	self assert: (dict1 at: false) = #false.! !

!NXTDictionaryTest methodsFor: 'implementation tests' stamp: 'mab 8/18/2008 18:37'!
testPseudoVariablesAreValidKeys
	"(self run: #testPseudoVariablesAreValidKeys)"
	"true and false are valid keys"
	
	| dict1  |
	dict1 := NXTDictionary new.
	self shouldnt: [dict1 at: true put: #true] raise: NXTError.
	self assert: (dict1 at: true) = #true.
		
	self shouldnt: [dict1 at: false put: #false] raise: NXTError.
	self assert: (dict1 at: false) = #false.! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 13:41'!
testRemoveKey
		"self run:#testRemoveKey "
	| dict | 
	dict := NXTDictionary new.
	dict at: #a put: 1.
	dict at: #b put: 2.
	self assert: (dict keys size) = 2.
	dict removeKey: #a.
	self assert: dict keys size  = 1.

	self should: [dict at: #a] raise: NXTError.
	self assert: (dict at: #b) = 2


	
	! !

!NXTDictionaryTest methodsFor: 'keys and value tests' stamp: 'mab 8/19/2008 15:43'!
testValues
	"self run:#testValues "
	
	| a1 a2 a3 dict | 
	a1 := NXTAssociation key: 'France' value: 'Paris'.
	a2 := NXTAssociation key: 'Italie' value: 'Rome'.
	dict := NXTDictionary new.
	dict add: a1.
	dict add: a2.
	
	self assert: (dict values size ) = 2.
	self assert: (dict values includes: 'Paris').
	a3 := NXTAssociation new.
	dict add: a3.
	self assert: (dict values size ) = 3.
	self assert: (dict values includes: nil).! !

NXTTestCase subclass: #NXTExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 20:08'!
testEnsureSimple

	[10 * 10.
	50 + 50] ensure: [^ nil ].
	self assert: false.
	! !

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 21:25'!
testEnsureWithError

	[10 * 10.
	NXTNotification signal.
	50 + 50] ensure: [^ nil ].
	self assert: false.
	! !

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 15:03'!
testResumableOuter

	| result |
	result := [NXTNotification signal. 4] 
		on: NXTNotification 
		do: [:ex | ex outer. ex return: 5].
	self assert: result == 5! !

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 19:19'!
testResumablePass

	| result |
	result := [NXTNotification signal. 4] 
		on: NXTNotification 
		do: [:ex | ex pass. ex return: 5].
	self assert: result == 4
! !

!NXTExceptionTest methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 20:04'!
testSimpleResume
	| it |
	[it := NXTNotification signal.
	self assert: it == 3 ] on: NXTNotification do: [:ex | ex resume: 3]! !

NXTTestCase subclass: #NXTExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTExecutionTest methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:10'!
helper: anObject
	^ anObject! !

!NXTExecutionTest methodsFor: 'as yet unclassified' stamp: 'mab 6/5/2008 15:43'!
testAutomaticEndOfExecutionWithRecursiveBlocks
	"If this does not crash, the test is ok"
	| array |
	array := NXTArray new: 10.
	1 to: 10 do: [ :index | array at: index put: index ].
	array do: [ :each | self helper: each ].! !

!NXTExecutionTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 13:48'!
testNonLocalReturnInNestedBlocks
	[ [ ^ self ] value ] value.
	"if we get here, something went wrong"
	self fail.! !

NXTTestCase subclass: #NXTMetaclassesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTMetaclassesTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:14'!
testInheritance
	self assert: NXTBoolean class superclass = NXTObject class.
	self assert: NXTObject class superclass = NXTClass.
	self assert: NXTClass superclass = NXTObject.! !

!NXTMetaclassesTest methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:13'!
testInstanceOfRelationships
	self assert: NXTObject class class = NXTMetaclass.
	self assert: NXTMetaclass class class = NXTMetaclass.! !

NXTTestCase subclass: #NXTSymbolTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 12/17/2008 09:53'!
testCreationFromString
	self assert: #test == 'test' asSymbol.
	self assert: #readSymbol == ('read', 'Symbol') asSymbol.
	self assert: #writeUndefinedObject: == #writeUndefinedObject asMutator.! !

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 12/17/2008 09:53'!
testEquality
	self assert: #test = #test.
	self assert: #test == #test.! !

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 12/17/2008 09:53'!
testLiteralArraySymbols
	| array |
	array := #(#NXTArray).
	self assert: (array at: 1) = #NXTArray! !

!NXTSymbolTest methodsFor: 'as yet unclassified' stamp: 'mab 12/17/2008 09:53'!
testSymbolTableCleanup
	| symbolTable oldTableSize reference |
	Smalltalk garbageCollect.
	symbolTable := NXTSymbol classPool at: #SymbolTable.
	oldTableSize := symbolTable realSize.
	"Create a new symbol"
	reference := 'blubberwabberdingsdongs' asSymbol.
	self assert: symbolTable realSize = (oldTableSize + 1).
	reference := nil.
	Smalltalk garbageCollect.
	symbolTable rehash.
	self assert: symbolTable realSize = oldTableSize.! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 6/9/2008 16:13'!
assert: aBoolean
	aBoolean ifFalse: [ NXTTestFailure new signal: 'Assertion failed' ].! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 13:45'!
fail
	^ self assert: false! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 1/14/2009 18:44'!
run
	| testSelectors failed |
	failed := NXTOrderedCollection new.
	testSelectors := self class selectors select: [ :each | each startsWith: #test ].
	('Testing class ' , self class name, ': ') print.
	testSelectors do: [ :testSelector |
		[
		self perform: testSelector. '.' print ] on: NXTTestFailure do: [ :ex | 
			'F' print.
			failed add: testSelector ]].
	NXTString cr print.
	failed do: [ :selector |
		selector print. ' failed' printNl ].! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 14:21'!
should: assertionBlock
	self assert: assertionBlock value.! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 16:13'!
should: aBlock raise: anExceptionalEvent
	[ aBlock value. self assert: false ] on: anExceptionalEvent do: [ :ex | ^ true ].
	self assert: false.! !

!NXTTestCase methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 16:13'!
shouldnt: aBlock raise: anExceptionalEvent
	[ aBlock value ] on: anExceptionalEvent do: [ :ex | self assert: false ].! !

NXTTestCase subclass: #NXTWeakPointerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Tests'!

!NXTWeakPointerTest methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 23:44'!
testWeakArrayClearing
	| weakArray |
	weakArray := NXTWeakArray new: 1.
	weakArray at: 1 put: NXTObject new.
	Smalltalk garbageCollect.
	self assert: (weakArray at: 1) isNil! !

NXTObject subclass: #NXTTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTTestRunner methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 14:29'!
run
	NXTTestCase allSubclassesDo: [ :testCase |
		testCase new run ].! !

NXTObject subclass: #NXTThreadTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTThreadTest methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 10:15'!
output: name
	500 timesRepeat: [ name print ].! !

!NXTThreadTest methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 13:42'!
run
	| s1 s2 |
	s1 := NXTSemaphore forMutualExclusion.
	s2 := NXTSemaphore forMutualExclusion.
	[ self output: '2'. s1 signal. ] fork.
	[ self output: '3'. s2 signal. ] fork.
	self output: '1'.
	"Wait for all three"
	s1 wait.
	s2 wait.! !

NXTObject subclass: #NXTTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTTime class methodsFor: 'as yet unclassified' stamp: 'mab 10/8/2008 18:28'!
millisecondClockValue
	<NXTPrimitive: 39>
	^ Time millisecondClockValue! !

!NXTTime class methodsFor: 'as yet unclassified' stamp: 'mab 9/8/2008 14:51'!
millisecondsToRun: timedBlock 
	"Answer the number of milliseconds timedBlock takes to return its value."

	| initialMilliseconds |
	initialMilliseconds := self millisecondClockValue.
	timedBlock value.
	^ self millisecondClockValue - initialMilliseconds! !

NXTObject subclass: #NXTTimer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTTimer class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:03'!
now
	<NXTPrimitive: 10>! !

!NXTTimer class methodsFor: 'as yet unclassified' stamp: 'mab 9/12/2008 15:23'!
sleepFor: milliseconds
	<NXTPrimitive: 46>! !

!NXTTimer class methodsFor: 'as yet unclassified' stamp: 'mab 8/13/2008 15:04'!
waitFor: seconds
	| start |
	start := self now.
	[ self now - start < seconds ] whileTrue.! !

NXTObject subclass: #NXTUndefinedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Kernel'!

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 17:03'!
handleSignal: exception
	"When no more handler (on:do:) context left in sender chain this gets called.  Return from signal with default action."

	^ exception resumeUnchecked: exception defaultAction! !

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 7/22/2008 18:15'!
ifNil: aBlock
	^ aBlock value! !

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:27'!
ifNil: nilBlock ifNotNil: ifNotNilBlock
	"Evaluate the block for nil because I'm == nil"

	^ nilBlock value! !

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 10/3/2008 21:42'!
ifNotNil: nilBlock
	^ self! !

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 13:27'!
ifNotNil: ifNotNilBlock ifNil: nilBlock 
	"If I got here, I am nil, so evaluate the block nilBlock"

	^ nilBlock value! !

!NXTUndefinedObject methodsFor: 'as yet unclassified' stamp: 'mab 5/20/2008 14:22'!
isNil
	^ true! !

NXTObject subclass: #NXTUsb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Hardware'!

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 6/19/2008 15:10'!
isConnected
	<NXTPrimitive: 26>
	^ false! !

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:03'!
packetSize
	^ 64! !

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:08'!
read
	"Blocking. Reads the next incoming packet from the USB port"
	<NXTPrimitive: 27>! !

!NXTUsb class methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:31'!
send: aByteArray
	"Blocking. Sends a packet to the USB port"
	<NXTPrimitive: 33>! !

NXTObject subclass: #NXTUsbManager
	instanceVariableNames: 'connection running'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-ST-Programs'!

!NXTUsbManager methodsFor: 'accessing' stamp: 'mab 7/25/2008 18:43'!
connection
	^ connection! !

!NXTUsbManager methodsFor: 'accessing' stamp: 'mab 7/25/2008 18:43'!
connection: anObject
	connection := anObject! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 7/25/2008 19:14'!
exit
	running := false.! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 11/14/2008 17:04'!
getClassList
	^ Smalltalk keys asArray! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 18:17'!
run
	'Waiting for USB connection...' printNl.
	[ NXTUsb isConnected not ] whileTrue: [ 10 ].
	'Got one - waiting for messages' printNl.
	self connection: (NXTDataStream on: NXTUsbStream new).
	(NXTDispatcher 
		for: NXTDriver new
		on: self connection) receive.
	self connection close! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 17:59'!
storeClass: aClass
	| newClass |
	(Smalltalk at: aClass name) become: aClass.
	newClass := Smalltalk at: aClass name.! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 8/19/2008 18:00'!
storeClass: aClass metaclass: aMetaclass
	| newClass |
	(Smalltalk at: aClass name) become: aClass.
	newClass := Smalltalk at: aClass name.
	newClass class: aMetaclass.
	aMetaclass class: NXTMetaclass.! !

!NXTUsbManager methodsFor: 'as yet unclassified' stamp: 'mab 8/20/2008 11:28'!
test: n1 write: n2
	n1 printNl.
	n2 printNl.! !

Object subclass: #NXTObjectTable
	instanceVariableNames: 'objects positions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTObjectTable class methodsFor: 'as yet unclassified' stamp: 'mab 10/29/2008 16:44'!
maxObjectId
	^ 32767! !

!NXTObjectTable class methodsFor: 'as yet unclassified' stamp: 'mab 3/17/2008 17:15'!
on: objectList
	^ self new objects: objectList! !

!NXTObjectTable methodsFor: 'as yet unclassified' stamp: 'mab 12/15/2008 09:09'!
addObject: anObject
	self objects add: anObject.
	self positions add: nil.
	^ anObject! !

!NXTObjectTable methodsFor: 'as yet unclassified' stamp: 'mab 12/15/2008 13:19'!
hashFor: anObject
	^ (self idFor: anObject) \\ (NXTSmallInteger maxVal + 1)! !

!NXTObjectTable methodsFor: 'as yet unclassified' stamp: 'mab 10/29/2008 16:44'!
idFor: anObject
	^ self class maxObjectId - ((self indexOf: anObject) - 1)! !

!NXTObjectTable methodsFor: 'as yet unclassified' stamp: 'mab 9/26/2008 18:15'!
indexOf: anObject
	"OrderedCollection>>#indexOf: uses #= but we need #=="
	self objects doWithIndex: [ :each :index |
		each == anObject ifTrue: [ ^ index ]].
	self error: 'Non-mappable object'.! !

!NXTObjectTable methodsFor: 'accessing' stamp: 'mab 12/15/2008 08:55'!
objects
	^ objects ifNil: [ objects := OrderedCollection new ]! !

!NXTObjectTable methodsFor: 'accessing' stamp: 'mab 3/17/2008 17:15'!
objects: anObject
	objects := anObject! !

!NXTObjectTable methodsFor: 'as yet unclassified' stamp: 'mab 12/12/2008 20:59'!
positions
	^ positions ifNil: [ positions := OrderedCollection new ]! !

!NXTObjectTable methodsFor: 'as yet unclassified' stamp: 'mab 12/12/2008 20:58'!
update: anObject position: aPosition
	self positions at: (self indexOf: anObject) put: aPosition! !

Object subclass: #NXTPackageCompiler
	instanceVariableNames: 'packageDescription package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 19:19'!
classNamed: aName
	(self isMetaclassName: aName) ifTrue: [ ^ self metaclassNamed: aName ].
	^ self package classes at: aName ifAbsent: [
		(self packageDescription classes includes: aName) 
			ifTrue: [ self compileClass: aName ]
			ifFalse: [ NXTClassProxy for: aName ]]! !

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 15:46'!
compile: aPackageDescription
	self packageDescription: aPackageDescription.
	self package: NXTPackage new.
	self package name: aPackageDescription name asNXTObject.
	aPackageDescription isApplication ifTrue: [
		self package entrypoint: aPackageDescription entrypoint asNXTObject ].
	self compileClasses.
	^ self package! !

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 13:49'!
compileClass: className
	| newClass newMetaclass |
	self package classes at: className ifPresent: [ :class | ^ class ].
	newClass := self package classes at: className put: NXTClass new.
	newMetaclass := self package metaclasses at: newClass put: NXTMetaclass new.
	newMetaclass thisClass: newClass.
	NXTClassCompiler new
		compilerContext: self;
		compile: (Smalltalk at: className) into: newClass.
	NXTClassCompiler new
		compilerContext: self;
		compile: (Smalltalk at: className) class into: newMetaclass.
	^ newClass! !

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 11:27'!
compileClasses
	self packageDescription classes do: [ :className | self compileClass: className ].! !

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 13:59'!
isMetaclassName: aName
	^ aName endsWith: ' class'! !

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 19:20'!
metaclassNamed: aName
	| class |
	class := self package classes 
		at: (aName allButLast: 6) asSymbol 
		ifAbsent: [ ^ NXTClassProxy for: aName ].
	^ self package metaclasses at: class! !

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 11:07'!
package
	^ package! !

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 11:07'!
package: aPackage
	package := aPackage! !

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 10:59'!
packageDescription
	^ packageDescription! !

!NXTPackageCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 11:00'!
packageDescription: aPackageDescription
	packageDescription := aPackageDescription! !

!Object methodsFor: '*nxtalk' stamp: 'mab 8/15/2008 16:22'!
isNXTObject
	^ false! !

!SystemDictionary methodsFor: '*nxtalk' stamp: 'mab 9/17/2008 11:33'!
isNXTalk
	^ false! !

!UndefinedObject methodsFor: '*nxtalk' stamp: 'mab 11/13/2008 16:09'!
asNXTObject
	^ NXTUndefinedObject new! !

!ClassDescription methodsFor: '*nxtalk' stamp: 'mab 11/16/2008 15:02'!
hasClassVar: aName
	(self classPool includesKey: aName) ifTrue: [ ^ true ].
	self superclass ifNil: [ ^ false ].
	^ self superclass hasClassVar: aName! !

!Dictionary methodsFor: '*nxtalk' stamp: 'mab 12/30/2008 12:27'!
asNXTObject
	| dict |
	dict := NXTDictionary new: self size.
	self associationsDo: [ :assoc |
		dict at: assoc key asNXTObject put: assoc value asNXTObject ].
	^ dict! !

!Number methodsFor: '*nxtalk' stamp: 'mab 10/8/2008 18:29'!
print
	self asString print! !

!Symbol methodsFor: '*nxtalk' stamp: 'mab 6/6/2008 11:14'!
asNXTObject
	| symbol |
	symbol := NXTSymbol new: self size.
	^ symbol replaceFrom: 1 to: self size with: self! !

!Symbol methodsFor: '*nxtalk' stamp: 'mab 11/18/2008 14:36'!
asSqueakObject
	^ self! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 12:28'!
asNXTLargeInteger: positive
	| size nxtObject |
	size := self digitLength.
	nxtObject := positive 
		ifTrue: [ NXTLargePositiveInteger new: size ]
		ifFalse: [ NXTLargeNegativeInteger new: size ].
	1 to: size do: [ :i | nxtObject at: i put: (self digitAt: i) ].
	^ nxtObject! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 11:46'!
asNXTObject
	self > NXTSmallInteger maxVal ifTrue: [
		^ self asNXTLargeInteger: true ].
	self < NXTSmallInteger minVal ifTrue: [
		^ self asNXTLargeInteger: false ].
	^ self! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 11/17/2008 19:32'!
isClassProxy
	^ false! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 11/18/2008 11:07'!
isNXTObject
	^ self <= NXTSmallInteger maxVal and: [ self >= NXTSmallInteger minVal ]! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 11/17/2008 19:15'!
referencesDo: aBlock! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 11/18/2008 10:07'!
referencesReplace: aBlock! !

!SmallInteger methodsFor: '*nxtalk' stamp: 'mab 9/1/2008 18:21'!
writeAsReferenceOn: aByteStream within: image
	(self < -16r4000 or: [ self > 16r3FFF ]) ifTrue: [ self error: 'Too large smallint!!' ].
	self >= 0 
		ifTrue: [ aByteStream littleEndianWord: (self bitShift: 1) ]
		ifFalse: [ aByteStream 
			littleEndianWord: (16r8000 + self bitShift: 1) ]! !

!Association methodsFor: '*nxtalk' stamp: 'mab 11/18/2008 11:06'!
asNXTObject
	^ NXTAssociation key: self key asNXTObject value: self value asNXTObject! !

PositionableStream subclass: #NXTConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTConnection class methodsFor: 'as yet unclassified' stamp: 'mab 11/4/2008 17:55'!
flashImage
| stream connection builder imageSize |
	stream := RWBinaryOrTextStream on: ByteArray new.
	builder := NXTImageBuilder new.
	builder helloWorldImageOn: stream.
	imageSize := stream size.
	connection := self connect.
	[ 
		connection nextLittleEndianNumber: 4 put: imageSize.
		connection flush.
		connection nextPutAll: stream contents.
		connection flush.
		builder image writeObjectTableToStream: connection.
	] ensure: [ connection close ].! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:54'!
ascii
	"NXT connections are always binary for now"! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/15/2008 14:53'!
binary
	"NXT connections are always binary for now"! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 8/12/2008 10:43'!
close
	^ self stream close! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/4/2008 17:26'!
flush
	^ self stream flush! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:43'!
littleEndianWord
	self nextLittleEndianNumber: 2! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:43'!
littleEndianWord: number
	self nextLittleEndianNumber: 2 put: number! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/29/2008 13:14'!
next
	^ self stream next! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:44'!
nextLittleEndianNumber: n 
	"Answer the next n bytes as a positive Integer or LargePositiveInteger, where the bytes are ordered from least significant to most significant."

	| bytes s |
	bytes := self next: n.
	s := 0.
	n to: 1 by: -1 do: [:i | s := (s bitShift: 8) bitOr: (bytes at: i)].
	^ s
! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:44'!
nextLittleEndianNumber: n put: value
	"Answer the next n bytes as a positive Integer or LargePositiveInteger, where the bytes are ordered from least significant to most significant."
	| bytes |
	bytes := ByteArray new: n.
	1 to: n do: [: i | bytes at: i put: (value digitAt: i)].
	self nextPutAll: bytes! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:48'!
nextPut: anObject
	self stream nextPut: anObject! !

!NXTConnection methodsFor: 'streaming' stamp: 'mab 7/2/2008 16:45'!
nextPutAll: aCollection
	self stream nextPutAll: aCollection! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 13:51'!
sendData: aStringOrByteArray
	self subclassResponsibility! !

!NXTConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:09'!
stream
	self subclassResponsibility! !

NXTConnection subclass: #NXTSerialConnection
	instanceVariableNames: 'serialPort inputBuffer inputBufferPos outputBuffer outputBufferPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

NXTSerialConnection subclass: #NXTBluetoothConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTBluetoothConnection class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:20'!
port
	^ 2! !

!NXTBluetoothConnection methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 14:32'!
wait
	100 milliSeconds asDelay wait.! !

!NXTSerialConnection class methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 11:42'!
bufferSize
	^ 64! !

!NXTSerialConnection class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:20'!
connect
	^ self new serialPort: (SerialPort new openPort: self port)! !

!NXTSerialConnection class methodsFor: 'as yet unclassified' stamp: 'mab 8/14/2008 11:47'!
new
	^ self basicNew initialize! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 8/14/2008 11:51'!
close
	^ self serialPort close! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 14:31'!
flush
	self serialPort nextPutAll: (outputBuffer copyFrom: 1 to: outputBufferPos - 1).
	outputBufferPos := 1.
	self wait.! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 13:18'!
initialize
	outputBuffer := ByteArray new: 64.
	outputBufferPos := 1.! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 9/16/2008 16:00'!
next
	| value |
	(inputBuffer isNil or: [ inputBufferPos > inputBuffer size ]) ifTrue: [
		[ inputBuffer := self serialPort readByteArray ] doWhileTrue: [ inputBuffer isEmpty ].
		inputBufferPos := 1 ].
	value := inputBuffer at: inputBufferPos.
	inputBufferPos := inputBufferPos + 1.
	^ value! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 9/16/2008 13:32'!
nextPut: anInteger
	outputBuffer at: outputBufferPos put: anInteger asInteger.
	(outputBufferPos := outputBufferPos + 1) > NXTUsb packetSize ifTrue: [
		self flush ].! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 9/16/2008 13:17'!
nextPutAll: aCollection
	aCollection do: [ :element |
		self nextPut: element ].! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 17:12'!
serialPort
	^ serialPort! !

!NXTSerialConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 17:12'!
serialPort: anObject
	serialPort := anObject! !

!NXTSerialConnection methodsFor: 'as yet unclassified' stamp: 'mab 2/13/2009 14:31'!
wait
	30 milliSeconds asDelay wait.! !

NXTSerialConnection subclass: #NXTUsbConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTUsbConnection class methodsFor: 'as yet unclassified' stamp: 'mab 2/11/2009 14:20'!
port
	^ 3! !

NXTConnection subclass: #NXTSocketConnection
	instanceVariableNames: 'socketStream bytesWritten'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Connections'!

!NXTSocketConnection class methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 14:01'!
connect
	^ self localhost! !

!NXTSocketConnection class methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:47'!
localhost
	^ self on: (SocketStream openConnectionToHostNamed: '127.0.0.1' port: 10000) binary! !

!NXTSocketConnection class methodsFor: 'as yet unclassified' stamp: 'mab 7/21/2008 14:32'!
on: socket
	^ self basicNew 
		initialize;
		socketStream: socket! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:59'!
initialize
	bytesWritten := 0! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:55'!
nextPut: anObject
	bytesWritten := bytesWritten + 1.
	super nextPut: anObject! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:55'!
nextPutAll: aCollection
	bytesWritten := bytesWritten + aCollection size.
	super nextPutAll: aCollection! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 17:00'!
position
	^ bytesWritten! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 6/22/2008 13:52'!
sendData: aStringOrByteArray
	self socketStream
		nextPutAll: aStringOrByteArray;
		flush.! !

!NXTSocketConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 14:18'!
socketStream
	^ socketStream! !

!NXTSocketConnection methodsFor: 'accessing' stamp: 'mab 6/19/2008 14:18'!
socketStream: anObject
	socketStream := anObject! !

!NXTSocketConnection methodsFor: 'as yet unclassified' stamp: 'mab 7/2/2008 16:09'!
stream
	^ self socketStream! !

!PositionableStream methodsFor: '*nxtalk' stamp: 'mab 7/2/2008 17:50'!
littleEndianWord
	self nextLittleEndianNumber: 2! !

!PositionableStream methodsFor: '*nxtalk' stamp: 'mab 7/2/2008 17:50'!
littleEndianWord: number
	self nextLittleEndianNumber: 2 put: number! !

SystemWindow subclass: #NXTGui
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-User Interface'!

!LargeNegativeInteger methodsFor: '*nxtalk' stamp: 'mab 9/8/2008 11:30'!
asNXTObject
	| size nxtObject |
	size := self digitLength.
	nxtObject := NXTLargeNegativeInteger new: size.
	1 to: size do: [ :i | nxtObject at: i put: (self at: i) ].
	^ nxtObject! !

!Metaclass methodsFor: '*nxtalk' stamp: 'mab 11/16/2008 15:21'!
elementSize
	^ 2! !

!Array methodsFor: '*nxtalk' stamp: 'mab 7/21/2008 15:41'!
asNXTObject
	| nxtArray |
	nxtArray := NXTArray new: self size.
	self doWithIndex: [ :element :index |
		nxtArray at: index put: element asNXTObject ].
	^ nxtArray! !

RBProgramNodeVisitor subclass: #NXTAbstractCodeCompiler
	instanceVariableNames: 'literals bytecodes arguments temporaries compilerContext stackSize stackPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 10:51'!
bytecodes
	^ Dictionary new
		at: #return put: 2r00000000;
		at: #dup put: 2r00000001;
		at: #pop put: 2r00000010;
		at: #pushSelf put: 2r00000011;
		at: #pushNil put: 2r000000100;
		at: #pushTrue put: 2r00000101;
		at: #pushFalse put: 2r00000110;
		at: #pushThisContext put: 2r00000111;
		at: #pushArg put: 2r00001000;
		at: #blockReturn put: 2r00001111;
		at: #pushTemp put: 2r00010000;
		at: #popTemp put: 2r00011000;
		at: #pushInst put: 2r00100000;
		at: #popInst put: 2r01000000;
		at: #pushLiteral put: 2r01100000;
		at: #pushBlock put: 2r10000000;
		at: #superSend put: 2r10100000;
		at: #send put: 2r11000000;
		at: #jumpIfTrue put: 2r11100000;
		at: #jumpBack put: 2r11110000;
		yourself! !

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 10:04'!
inlineableSelectors
	^ #(#ifTrue: #ifFalse: #ifTrue:ifFalse #ifFalse:ifTrue:)! !

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 15:16'!
inlineableSelectorsWithReceiver
	^ #(#whileTrue: #to:do:)! !

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 13:24'!
maxArguments
	^ 7! !

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 9/10/2008 18:59'!
maxInstVars
	^ 32! !

!NXTAbstractCodeCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 15:49'!
maxTemps
	^ 7! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/13/2008 11:01'!
acceptArrayNode: arrayNode
	self error: 'Not implemented yet'! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 10:40'!
acceptAssignmentNode: anAssignmentNode
	| pushNeeded |
	self ifClassVar: anAssignmentNode variable name do: [
		^ self assignClassVar: anAssignmentNode variable with: anAssignmentNode value].
	self visitNode: anAssignmentNode value.
	pushNeeded := anAssignmentNode parent isSequence not or: [ self lastStatement ].
	pushNeeded ifTrue: [ self dup ].
	self popVariable: anAssignmentNode variable name.
	^ pushNeeded! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 10:41'!
acceptBlockNode: aBlockNode
	| block |
	block := NXTBlockCompiler new
		compilerContext: self;
		compile: aBlockNode.
	self pushBlock: block.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 10:40'!
acceptCascadeNode: cascadeNode
	self visitNode: cascadeNode receiver.
	cascadeNode messages size - 1 timesRepeat: [ self dup ].
	cascadeNode messages 
		do: [ :message | self visitNode: message ]
		separatedBy: [ self pop ].
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:49'!
acceptLiteralNode: aLiteralNode
	self processLiteral: aLiteralNode value.
	^ true
	! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 10:31'!
acceptMessageNode: aMessageNode
	self primitive ifNotNil: [ ^ self ].
	aMessageNode isCascaded not ifTrue: [
		(self tryInlining: aMessageNode) ifTrue: [ ^true ].
		self visitNode: aMessageNode receiver].
	aMessageNode arguments do: [:each | self visitNode: each].
	(aMessageNode receiver isVariable and: [ aMessageNode receiver name = 'super' ])
		ifTrue: [ self superSend: aMessageNode selector]
		ifFalse: [ self send: aMessageNode selector ].
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 10:39'!
acceptReturnNode: aReturnNode
	super acceptReturnNode: aReturnNode.
	self return.
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:49'!
acceptVariableNode: variableNode
	self pushVariable: variableNode name.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 10/9/2008 09:49'!
addBytecode: aSymbol
	self addBytecode: aSymbol argument: 0! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 11/3/2008 14:52'!
addBytecode: aSymbol argument: aNumber
	self bytecodes add: (self class bytecodes at: aSymbol) + aNumber.
	! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 19:26'!
allArguments
	^ arguments! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 19:12'!
allTemporaries
	^ temporaries! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:12'!
arguments
	^ arguments! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:12'!
arguments: anObject
	arguments := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 11:32'!
assignClassVar: variableNode with: valueNode
	self pushSelf.
	self send: #class.
	self pushLiteral: variableNode name asSymbol asNXTObject.
	self visitNode: valueNode.
	self send: #classPoolAt:put:.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 10:38'!
blockReturn
	self addBytecode: #blockReturn! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
bytecodes
	^ bytecodes! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
bytecodes: anObject
	bytecodes := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 15:11'!
classNamed: aName
	^ self compilerContext classNamed: aName! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 09:36'!
compileForInlining: aBlockNode
	^ NXTInlineBlockCompiler compile: aBlockNode in: self! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:55'!
compiledClass
	^ self compilerContext compiledClass! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:17'!
compilerContext
	^ compilerContext! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:17'!
compilerContext: anObject
	compilerContext := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:50'!
compilesBlock
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/17/2008 13:23'!
convertLiteralArray: array
	| nxtArray |
	nxtArray := NXTArray new: array size.
	array doWithIndex: [ :element :index |
		nxtArray at: index put: (self extractLiteralValue: element) ].
	^ nxtArray! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 11:36'!
decStackPos
	self decStackPosBy: 1.! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 11:36'!
decStackPosBy: aNumber
	stackPos := stackPos - aNumber.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:18'!
dup
	self addBytecode: #dup.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 16:04'!
extractLiteralValue: value
	value isNil | (value isKindOf: Boolean) | value isString | value isInteger 
		ifTrue: [ ^ value asNXTObject ].
	value isArray ifTrue: [
		^ self convertLiteralArray: value ].
	self error: 'Unknown literal value'.! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:50'!
ifArgument: aName doWithIndex: aBlock
	| index |
	index := self allArguments indexOf: aName.
	index > self class maxArguments ifTrue: [
		self error: ' Too many arguments' ].
	index isZero ifFalse: [ aBlock value: index - 1 ].
	! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:50'!
ifClassVar: aName do: aBlock
	(self compiledClass hasClassVar: aName) ifTrue: [ aBlock value ].! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:50'!
ifInstVar: aName doWithIndex: aBlock
	| index |
	index := self instVarNames indexOf: aName.
	index > self class maxInstVars ifTrue: [
		self error: 'Too many instance variables' ].
	index isZero ifFalse: [ aBlock value: index - 1 ].
	! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/16/2008 13:49'!
ifNXTClass: aName doWithName: aBlock
	| class |
	class := [ Smalltalk at: aName asSymbol ] on: Error do: [ ^ nil ].
	class isBehavior ifFalse: [ ^ nil ].
	((class inheritsFrom: NXTObject)  or: [ class = NXTObject ])
		ifTrue: [ aBlock value: aName ].
		! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:50'!
ifTemporary: aName doWithIndex: aBlock
	| index |
	index := self allTemporaries indexOf: aName.
	index > self class maxTemps ifTrue: [
		self error: 'Too many temps' ].
	index isZero ifFalse: [ aBlock value: index - 1 ].
	! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 11:16'!
incStackPos
	stackPos := stackPos + 1.
	stackPos > stackSize ifTrue: [ stackSize := stackPos ].! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 16:13'!
indexOfLiteral: value ifAbsent: aBlock
	self literals doWithIndex: [ :literal :index |
		(literal isSymbol and: [ value isSymbol ] and: [ literal asSqueakObject = value asSqueakObject ]) ifTrue: [
			^ index ].
		value = literal ifTrue: [ ^ index ]].
	^ aBlock value
	! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 11:16'!
initialize
	literals := OrderedCollection new.
	bytecodes := OrderedCollection new.
	arguments := OrderedCollection new.
	temporaries := OrderedCollection new.
	stackPos := 0.
	stackSize := 0.! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 17:21'!
inline: startNode to: endNode do: actionBlock
	| inlineableActionBlock forwardJump backwardJump |
	true ifTrue: [ ^ false ].
	inlineableActionBlock := self compileForInlining: actionBlock.
	forwardJump := inlineableActionBlock bytecodes size  + 5.
	backwardJump := inlineableActionBlock bytecodes size + 8.
	(self jumpIfTrueAllowedFor: forwardJump) ifFalse: [ ^ false ].
	(self jumpBackAllowedFor: backwardJump) ifFalse: [ ^ false ].
	(self temporaries size + inlineableActionBlock temporaries size + 1 > self class maxTemps) ifTrue: [
		^ false ].
	(self temporaries includes: '__') ifTrue: [ ^ false].
	self temporaries add: '__'.

	self visitNode: startNode.
	self popTemp: self temporaries size + 1.
	self visitNode: endNode.
	self popVariable: '__'.
	
	self pushTemp: self temporaries size + 1.
	self pushVariable: '__'.
	self send: #>.
	self jumpIfTrue: forwardJump.
	inlineableActionBlock inlineIn: self.
	self pushTemp: self temporaries size + 1.
	self pushLiteral: 1.
	self send: #+.
	self popTemp: self temporaries size + 1.
	self jumpBack: backwardJump.
	
	self temporaries addAll: inlineableActionBlock temporaries.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 13:29'!
inline: conditionBlock whileTrue: actionBlock
	| inlineableConditionBlock inlineableActionBlock forwardJump backwardJump |
	true ifTrue: [ ^ false ].
	inlineableConditionBlock := self compileForInlining: conditionBlock.
	inlineableActionBlock := self compileForInlining: actionBlock.
	forwardJump := inlineableActionBlock bytecodes size  + 2.
	backwardJump := inlineableConditionBlock bytecodes size + 2 + inlineableActionBlock bytecodes size.
	(self jumpIfTrueAllowedFor: forwardJump) ifFalse: [ ^ false ].
	(self jumpBackAllowedFor: backwardJump) ifFalse: [ ^ false ].
	inlineableConditionBlock inlineIn: self.
	self send: #not.
	self jumpIfTrue: forwardJump.
	inlineableActionBlock inlineIn: self.
	self jumpBack: backwardJump.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 10:03'!
inlineIfFalse: falseBlock
	^ self inlineIfTrue: nil ifFalse: falseBlock! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 10:03'!
inlineIfFalse: falseBlock ifTrue: trueBlock
	^ self inlineIfTrue: trueBlock ifFalse: falseBlock! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 10:03'!
inlineIfTrue: trueBlock
	^ self inlineIfTrue: trueBlock ifFalse: nil! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 13:29'!
inlineIfTrue: trueBlock ifFalse: falseBlock
	| inlineableTrueBlock inlineableFalseBlock |
	true ifTrue: [ ^ false ].
	inlineableTrueBlock := self compileForInlining: trueBlock.
	inlineableFalseBlock := self compileForInlining: falseBlock.
	(inlineableTrueBlock bytecodes size  <= 16 and: [ 
		inlineableFalseBlock bytecodes size + 2 <= 16]) ifFalse: [ ^ false ].
	self jumpIfTrue: inlineableFalseBlock bytecodes size + 2.
	inlineableFalseBlock inlineIn: self.
	self pushTrue.
	self jumpIfTrue: inlineableTrueBlock bytecodes size..
	inlineableTrueBlock inlineIn: self.
	^ true! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:18'!
instVarNames
	^ self compilerContext instVarNames! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:18'!
jumpBack: distance
	self decStackPos.
	^ self addBytecode: #jumpBack argument: distance - 1! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 13:46'!
jumpBackAllowedFor: distance
	^ distance <= 16! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:20'!
jumpIfTrue: distance
	self addBytecode: #jumpIfTrue argument: distance - 1.
	self decStackPos..! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 10:17'!
jumpIfTrueAllowedFor: distance
	^ distance <= 16! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 20:05'!
lastStatement
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
literals
	^ literals! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
literals: anObject
	literals := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/19/2008 16:03'!
mapLiteral: aLiteral
	| index |
	index := (self indexOfLiteral: aLiteral ifAbsent: [ self literals add: aLiteral. self literals size ]) - 1.
	index > 31 ifTrue: [ self error: 'Too many literals' ].
	^ index! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:20'!
pop
	self addBytecode: #pop.
	self decStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:29'!
popInst: index
	index > self class maxInstVars ifTrue: [ self error: 'Instance variable out of index' ].
	self addBytecode: #popInst argument: index - 1.
	self decStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:21'!
popTemp: index
	index > self class maxTemps ifTrue: [ self error: 'Temporary out of index' ].
	self addBytecode: #popTemp argument: index - 1.
	self decStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 11:29'!
popVariable: aName
	self ifTemporary: aName doWithIndex: [ :index |
		^ self popTemp: index + 1 ].
	self ifInstVar: aName doWithIndex: [ :index |
		^ self popInst:index + 1 ].
	self error: 'Unknown variable'.! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 15:37'!
primitive
	^ nil! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 10:39'!
processLiteral: value
	value ifNil: [ ^ self pushNil ].
	(value isKindOf: Boolean) ifTrue: [ value 
			ifTrue: [ ^ self pushTrue ]
			ifFalse: [ ^ self pushFalse ]].
	value isSymbol ifTrue: [ ^ self pushLiteral: value asNXTObject ].
	value isString ifTrue: [ ^ self pushLiteral: value asNXTObject ].
	value isInteger ifTrue: [ ^ self pushLiteral: value asNXTObject ].
	value isArray ifTrue: [
		^ self pushLiteral: (self convertLiteralArray: value) ].
	self error: 'Unknown literal value'.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:30'!
pushBlock: aBlock
	self addBytecode: #pushBlock argument: (self mapLiteral: aBlock).
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 11:32'!
pushClassVar: aName
	self pushSelf.
	self send: #class.
	self pushLiteral: aName asSymbol asNXTObject.
	self send: #classPoolAt:! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:31'!
pushFalse
	self addBytecode: #pushFalse.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:32'!
pushLiteral: literal
	self addBytecode: #pushLiteral argument: (self mapLiteral: literal).
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:32'!
pushNil
	self addBytecode: #pushNil.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:34'!
pushSelf
	self addBytecode: #pushSelf.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:35'!
pushTemp: index
	index > self class maxTemps ifTrue: [ self error: 'Temporary out of index' ].
	self addBytecode: #pushTemp argument: index - 1.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:35'!
pushTrue
	self addBytecode: #pushTrue.
	self incStackPos.! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/18/2008 09:05'!
pushVariable: aName
	aName = 'self' ifTrue: [ ^ self addBytecode: #pushSelf ].
	aName = 'Smalltalk' ifTrue: [ 
		^ self pushLiteral: (NXTClassProxy for: #Smalltalk asNXTObject) ].
	aName = 'super' ifTrue: [ ^ self addBytecode: #pushSelf ].
	aName = 'thisContext' ifTrue: [ ^ self addBytecode: #pushThisContext ].
	aName = 'Processor' ifTrue: [ ^ self pushLiteral: (NXTClassProxy 
		for: #Processor asNXTObject) ].
	self ifClassVar: aName do: [ ^ self pushClassVar: aName ].
	self ifArgument: aName doWithIndex: [ :index |
		^ self addBytecode: #pushArg argument: index ].
	self ifTemporary: aName doWithIndex: [ :index |
		^ self addBytecode: #pushTemp argument: index ].
	self ifInstVar: aName doWithIndex: [ :index |
		^ self addBytecode: #pushInst argument: index ].
	self ifNXTClass: aName doWithName: [ :newName |
		^ self pushLiteral: (self compilerContext classNamed: newName asSymbol) ].
	self error: 'Unknown variable'.! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 10:36'!
return
	self addBytecode: #return! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:38'!
send: aSymbol
	self addBytecode: #send argument: (self mapLiteral: aSymbol asNXTObject).
	self decStackPosBy: aSymbol numArgs.! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 1/12/2009 11:44'!
stackSize
	^ stackSize! !

!NXTAbstractCodeCompiler methodsFor: 'bytecodes' stamp: 'mab 1/12/2009 11:38'!
superSend: aSymbol
	self addBytecode: #superSend argument: (self mapLiteral: aSymbol asNXTObject).
	self decStackPosBy: aSymbol numArgs.! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
temporaries
	^ temporaries! !

!NXTAbstractCodeCompiler methodsFor: 'accessing' stamp: 'mab 4/23/2008 19:14'!
temporaries: anObject
	temporaries := anObject! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/7/2008 02:19'!
tryInlining: aMessageNode
	true ifTrue: [ ^ false ].
	(self class inlineableSelectorsWithReceiver includes: aMessageNode selector) ifTrue: [ ^ self 
		perform: ('inline:', aMessageNode selector) asSymbol 
		withArguments: (Array with: aMessageNode receiver), aMessageNode arguments ].
	(self class inlineableSelectors includes: aMessageNode selector) ifTrue: [ 
		self visitNode: aMessageNode receiver.
		^ self 
			perform: ('inline', aMessageNode selector capitalized) asSymbol 
			withArguments: aMessageNode arguments ].
	^ false! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:50'!
visitArgument: argumentNode
	self arguments add: argumentNode name! !

!NXTAbstractCodeCompiler methodsFor: 'as yet unclassified' stamp: 'mab 10/9/2008 09:50'!
visitTemporaryVariable: aNode
	self temporaries add: aNode name.! !

NXTAbstractCodeCompiler subclass: #NXTBlockCompiler
	instanceVariableNames: 'lastStatement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/29/2009 13:09'!
acceptSequenceNode: aSequenceNode 
	self visitTemporaryVariables: aSequenceNode temporaries.
	aSequenceNode statements
		ifNotEmpty: [ aSequenceNode statements 
			allButLastDo: [:each | (self visitNode: each) 
				ifTrue: [self pop]].
			self lastStatement: true.
			self visitNode: (aSequenceNode statements last)]
		ifEmpty: [ self pushNil ].
	self addBytecode: #return.! !

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 19:27'!
allArguments
	^ self arguments, self compilerContext allArguments! !

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 4/28/2008 19:27'!
allTemporaries
	^ self temporaries, self compilerContext allTemporaries! !

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 11:44'!
compile: aBlockNode
	self visitArguments: aBlockNode arguments.
	self visitNode: aBlockNode body.
	^ NXTBlock 
		bytecodes: { self stackSize }, self bytecodes
		literals: self literals
		numTemps: self temporaries size
		numArgs: self arguments size! !

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 6/12/2008 15:20'!
compilesBlock
	^ true! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 5/7/2008 17:44'!
initialize
	super initialize.
	lastStatement := false.! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 20:04'!
lastStatement
	^ lastStatement! !

!NXTBlockCompiler methodsFor: 'accessing' stamp: 'mab 4/28/2008 20:04'!
lastStatement: anObject
	lastStatement := anObject! !

!NXTBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/29/2009 13:08'!
return
	self blockReturn! !

NXTBlockCompiler subclass: #NXTInlineBlockCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTInlineBlockCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 11/2/2008 22:38'!
bytecodesUsingLiterals
	^ OrderedCollection 
		with: (self bytecodes at: #pushLiteral)
		with: (self bytecodes at: #pushBlock)
		with: (self bytecodes at: #send)
		with: (self bytecodes at: #superSend)! !

!NXTInlineBlockCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 16:10'!
bytecodesUsingTemporaries
	^ OrderedCollection 
		with: (self bytecodes at: #pushTemp)
		with: (self bytecodes at: #popTemp)
! !

!NXTInlineBlockCompiler class methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 09:51'!
compile: block in: aCodeCompiler
	^ self new
		compilerContext: aCodeCompiler;
		compile: block
	! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/2/2008 23:17'!
allArguments
	^ self compilerContext allArguments! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 15:43'!
allTemporaries
	^ self temporaries, self compilerContext allTemporaries! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 10:00'!
compile: aBlockNode
	aBlockNode ifNil: [ ^ self compileAsEmpty ].
	aBlockNode isVariable ifTrue: [ ^ self compileForVariable: aBlockNode ].
	aBlockNode isBlock ifFalse: [ self error: 'Block expected' ].
	self visitArguments: aBlockNode arguments.
	self visitNode: aBlockNode body.
	self bytecodes removeLast.! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 10:01'!
compileAsEmpty
	self pushNil.! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 09:54'!
compileForVariable: aVarNode
	self acceptVariableNode: aVarNode.
	self send: #value.! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 16:21'!
inline: bytecode in: aCodeCompiler
	(self usesLiteral: bytecode) ifTrue: [
		^ aCodeCompiler bytecodes add: (self withoutLiteralIndex: bytecode)
			+ (aCodeCompiler mapLiteral: (self literalFor: bytecode)) ].
	(self usesTemporary: bytecode) ifTrue: [
		^ aCodeCompiler bytecodes add: (self relocateTemporary: bytecode for: aCodeCompiler) ].
	aCodeCompiler bytecodes add: bytecode.
		
		! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/2/2008 22:33'!
inlineIn: aCodeCompiler
	self bytecodes do: [ :bytecode |
		self inline: bytecode in: aCodeCompiler ].! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/2/2008 22:48'!
literalFor: bytecode
	^ self literals at: (bytecode - (self withoutLiteralIndex: bytecode) + 1)
		
		! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 16:20'!
onlyTemporaryIndex: bytecode
	^ bytecode bitAnd: 2r00000111! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 17:21'!
relocateTemporary: bytecode for: aCodeCompiler
	self temporaries size = 0 ifTrue: [ ^ bytecode].
	(self onlyTemporaryIndex: bytecode) >= self temporaries size 
		ifTrue: [ ^ (self withoutTemporaryIndex: bytecode)
			+ (self onlyTemporaryIndex: bytecode) - self temporaries size ]
		ifFalse: [ ^ (self withoutTemporaryIndex: bytecode)
			+ aCodeCompiler temporaries size + (self onlyTemporaryIndex: bytecode) ]
	! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/29/2009 13:08'!
return
	self addBytecode: #return! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 16:09'!
usesLiteral: bytecode
	^ self class bytecodesUsingLiterals includes: (self withoutLiteralIndex: bytecode)
		! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 16:11'!
usesTemporary: bytecode
	^ self class bytecodesUsingTemporaries includes: (self withoutTemporaryIndex: bytecode)
		! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 15:43'!
visitArgument: argumentNode
	self temporaries add: argumentNode name! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 15:43'!
visitTemporaryVariable: aNode
	self temporaries add: aNode name.! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/2/2008 22:45'!
withoutLiteralIndex: bytecode
	^ bytecode bitAnd: 2r11100000! !

!NXTInlineBlockCompiler methodsFor: 'as yet unclassified' stamp: 'mab 11/3/2008 16:10'!
withoutTemporaryIndex: bytecode
	^ bytecode bitAnd: 2r11111000! !

NXTAbstractCodeCompiler subclass: #NXTMethodCompiler
	instanceVariableNames: 'primitive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NXTalk-Building'!

!NXTMethodCompiler methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 14:59'!
acceptMethodNode: aMethodNode
	aMethodNode pragmas do: [:each | self visitNode: each].
	self visitMethodArguments: aMethodNode arguments.
	self visitNode: aMethodNode body! !

!NXTMethodCompiler methodsFor: 'as yet unclassified' stamp: 'mab 5/29/2008 15:25'!
acceptPragmaNode: aPragmaNode
	| pragma newMethodNode |
	pragma := aPragmaNode pragma.
	pragma keyword = #NXTPrimitive: ifTrue: [
		self primitive: (pragma argumentAt: 1) ].
	pragma keyword = #nxtTakeMethodFrom: ifTrue: [ 
		newMethodNode := SqueakParser parseMethod: ((Smalltalk at: (pragma argumentAt: 1))
			compiledMethodAt: (aPragmaNode parent selector )) getSource.
		aPragmaNode parent arguments: newMethodNode arguments.
		aPragmaNode parent body: newMethodNode body ].! !

!NXTMethodCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 10:36'!
acceptSequenceNode: aSequenceNode 
	self primitive ifNotNil: [ ^ nil ].
	self visitTemporaryVariables: aSequenceNode temporaries.
	aSequenceNode statements do: [:each | (self visitNode: each) ifTrue: [self pop]].
	(aSequenceNode statements isEmpty or: [
		aSequenceNode statements last isReturn not]) ifTrue: [ 
			self pushSelf. self return ].! !

!NXTMethodCompiler methodsFor: 'as yet unclassified' stamp: 'mab 1/12/2009 11:45'!
compileMethod: aCompiledMethod
	| ast |
	ast := SqueakParser parseMethod: aCompiledMethod getSource.
	self visitNode: ast.
	self primitive ifNil: [ ^ NXTMethod 
		bytecodes: { self stackSize }, self bytecodes 
		literals: self literals , (OrderedCollection 
			with: aCompiledMethod selector asNXTObject
			with: self compilerContext nxtClass)
		numTemps: self temporaries size
		numArgs: self arguments size ].
	^ NXTMethod primitive: self primitive numArgs: self arguments size! !

!NXTMethodCompiler methodsFor: 'accessing' stamp: 'mab 4/16/2008 14:37'!
primitive
	^ primitive! !

!NXTMethodCompiler methodsFor: 'accessing' stamp: 'mab 4/16/2008 14:08'!
primitive: anObject
	primitive := anObject! !

!Message methodsFor: '*nxtalk' stamp: 'mab 11/13/2008 15:42'!
asNXTObject
	^ NXTMessage selector: self selector asNXTObject arguments: (NXTArray withAll: self arguments)

	! !
NXTSymbol initialize!
NXTObject initialize!
NXTClassTest initialize!
